searchData={"items":[{"type":"module","title":"Examples.BasicAgent01","doc":"","ref":"Examples.BasicAgent01.html"},{"type":"function","title":"Examples.BasicAgent01.demo/0","doc":"","ref":"Examples.BasicAgent01.html#demo/0"},{"type":"module","title":"Examples.ToolAgent02","doc":"","ref":"Examples.ToolAgent02.html"},{"type":"function","title":"Examples.ToolAgent02.demo/0","doc":"","ref":"Examples.ToolAgent02.html#demo/0"},{"type":"module","title":"Jido.AI","doc":"High-level API for accessing AI provider keys.","ref":"Jido.AI.html"},{"type":"function","title":"Jido.AI.clear_all_session_values/0","doc":"","ref":"Jido.AI.html#clear_all_session_values/0"},{"type":"function","title":"Jido.AI.clear_session_value/1","doc":"","ref":"Jido.AI.html#clear_session_value/1"},{"type":"function","title":"Jido.AI.get/1","doc":"","ref":"Jido.AI.html#get/1"},{"type":"function","title":"Jido.AI.get_session_value/1","doc":"","ref":"Jido.AI.html#get_session_value/1"},{"type":"function","title":"Jido.AI.set_session_value/2","doc":"","ref":"Jido.AI.html#set_session_value/2"},{"type":"module","title":"Jido.AI.Actions.Instructor","doc":"A low-level action that provides direct access to Instructor's chat completion functionality.\nSupports most Instructor options and integrates with Jido's Model and Prompt structures.","ref":"Jido.AI.Actions.Instructor.html"},{"type":"module","title":"Features - Jido.AI.Actions.Instructor","doc":"- Multi-provider support (Anthropic, OpenAI, Ollama, llamacpp, Together, OpenRouter, etc.)\n- Streaming capabilities with array or partial response models\n- Response mode configuration (:json, :function_call)\n- Structured output validation with automatic retries","ref":"Jido.AI.Actions.Instructor.html#module-features"},{"type":"module","title":"Usage - Jido.AI.Actions.Instructor","doc":"```elixir\n# Define a response model with Ecto\ndefmodule WeatherResponse do\n  use Ecto.Schema\n\n  embedded_schema do\n    field :temperature, :float\n    field :conditions, :string\n    field :city, :string\n  end\nend\n\n# Create a structured response\n{:ok, result, _} = Jido.AI.Actions.Instructor.run(%{\n  model: %Jido.AI.Model{provider: :anthropic, model: \"claude-3-sonnet-20240229\", api_key: \"key\"},\n  prompt: Jido.AI.Prompt.new(:user, \"What's the weather in Tokyo?\"),\n  response_model: WeatherResponse,\n  max_retries: 2\n})\n```","ref":"Jido.AI.Actions.Instructor.html#module-usage"},{"type":"module","title":"Support Matrix - Jido.AI.Actions.Instructor","doc":"| Provider   | Adapter               | Configuration                     |\n|------------|----------------------|----------------------------------|\n| anthropic  | Anthropic            | api_key                          |\n| openai     | OpenAI               | openai: [api_key: \"key\"]         |\n| openrouter | OpenAI               | openai: [api_key, api_url]       |\n| ollama     | OpenAI               | openai: [api_key, api_url]       |\n| llamacpp   | Llamacpp             | llamacpp: [api_url]              |\n| together   | OpenAI               | openai: [api_key, api_url]       |\n| other      | Defaults to Anthropic| api_key                          |","ref":"Jido.AI.Actions.Instructor.html#module-support-matrix"},{"type":"function","title":"Jido.AI.Actions.Instructor.category/0","doc":"","ref":"Jido.AI.Actions.Instructor.html#category/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.description/0","doc":"","ref":"Jido.AI.Actions.Instructor.html#description/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.name/0","doc":"","ref":"Jido.AI.Actions.Instructor.html#name/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.on_after_run/1","doc":"","ref":"Jido.AI.Actions.Instructor.html#on_after_run/1"},{"type":"function","title":"Jido.AI.Actions.Instructor.on_after_validate_params/1","doc":"","ref":"Jido.AI.Actions.Instructor.html#on_after_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.Instructor.on_error/4","doc":"","ref":"Jido.AI.Actions.Instructor.html#on_error/4"},{"type":"function","title":"Jido.AI.Actions.Instructor.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.AI.Actions.Instructor.html#run/2"},{"type":"function","title":"Jido.AI.Actions.Instructor.schema/0","doc":"","ref":"Jido.AI.Actions.Instructor.html#schema/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.tags/0","doc":"","ref":"Jido.AI.Actions.Instructor.html#tags/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.to_json/0","doc":"","ref":"Jido.AI.Actions.Instructor.html#to_json/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.to_tool/0","doc":"","ref":"Jido.AI.Actions.Instructor.html#to_tool/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.AI.Actions.Instructor.html#validate_params/1"},{"type":"function","title":"Examples - Jido.AI.Actions.Instructor.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.AI.Actions.Instructor.html#validate_params/1-examples"},{"type":"function","title":"Jido.AI.Actions.Instructor.vsn/0","doc":"","ref":"Jido.AI.Actions.Instructor.html#vsn/0"},{"type":"module","title":"Jido.AI.Actions.Instructor.BooleanResponse","doc":"","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html"},{"type":"function","title":"Jido.AI.Actions.Instructor.BooleanResponse.category/0","doc":"","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html#category/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.BooleanResponse.description/0","doc":"","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html#description/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.BooleanResponse.name/0","doc":"","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html#name/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.BooleanResponse.on_after_run/1","doc":"","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html#on_after_run/1"},{"type":"function","title":"Jido.AI.Actions.Instructor.BooleanResponse.on_after_validate_params/1","doc":"","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html#on_after_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.Instructor.BooleanResponse.on_before_validate_params/1","doc":"","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html#on_before_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.Instructor.BooleanResponse.on_error/4","doc":"","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html#on_error/4"},{"type":"function","title":"Jido.AI.Actions.Instructor.BooleanResponse.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html#run/2"},{"type":"function","title":"Jido.AI.Actions.Instructor.BooleanResponse.schema/0","doc":"","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html#schema/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.BooleanResponse.tags/0","doc":"","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html#tags/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.BooleanResponse.to_json/0","doc":"","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html#to_json/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.BooleanResponse.to_tool/0","doc":"","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html#to_tool/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.BooleanResponse.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html#validate_params/1"},{"type":"function","title":"Examples - Jido.AI.Actions.Instructor.BooleanResponse.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html#validate_params/1-examples"},{"type":"function","title":"Jido.AI.Actions.Instructor.BooleanResponse.vsn/0","doc":"","ref":"Jido.AI.Actions.Instructor.BooleanResponse.html#vsn/0"},{"type":"module","title":"Jido.AI.Actions.Instructor.BooleanResponse.Schema","doc":"","ref":"Jido.AI.Actions.Instructor.BooleanResponse.Schema.html"},{"type":"module","title":"Jido.AI.Actions.Instructor.ChatResponse","doc":"","ref":"Jido.AI.Actions.Instructor.ChatResponse.html"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChatResponse.category/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChatResponse.html#category/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChatResponse.description/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChatResponse.html#description/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChatResponse.name/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChatResponse.html#name/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChatResponse.on_after_run/1","doc":"","ref":"Jido.AI.Actions.Instructor.ChatResponse.html#on_after_run/1"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChatResponse.on_after_validate_params/1","doc":"","ref":"Jido.AI.Actions.Instructor.ChatResponse.html#on_after_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChatResponse.on_before_validate_params/1","doc":"","ref":"Jido.AI.Actions.Instructor.ChatResponse.html#on_before_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChatResponse.on_error/4","doc":"","ref":"Jido.AI.Actions.Instructor.ChatResponse.html#on_error/4"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChatResponse.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.AI.Actions.Instructor.ChatResponse.html#run/2"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChatResponse.schema/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChatResponse.html#schema/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChatResponse.tags/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChatResponse.html#tags/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChatResponse.to_json/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChatResponse.html#to_json/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChatResponse.to_tool/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChatResponse.html#to_tool/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChatResponse.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.AI.Actions.Instructor.ChatResponse.html#validate_params/1"},{"type":"function","title":"Examples - Jido.AI.Actions.Instructor.ChatResponse.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.AI.Actions.Instructor.ChatResponse.html#validate_params/1-examples"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChatResponse.vsn/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChatResponse.html#vsn/0"},{"type":"module","title":"Jido.AI.Actions.Instructor.ChatResponse.Schema","doc":"","ref":"Jido.AI.Actions.Instructor.ChatResponse.Schema.html"},{"type":"module","title":"Jido.AI.Actions.Instructor.ChoiceResponse","doc":"","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChoiceResponse.category/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html#category/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChoiceResponse.description/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html#description/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChoiceResponse.name/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html#name/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChoiceResponse.on_after_run/1","doc":"","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html#on_after_run/1"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChoiceResponse.on_after_validate_params/1","doc":"","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html#on_after_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChoiceResponse.on_before_validate_params/1","doc":"","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html#on_before_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChoiceResponse.on_error/4","doc":"","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html#on_error/4"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChoiceResponse.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html#run/2"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChoiceResponse.schema/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html#schema/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChoiceResponse.tags/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html#tags/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChoiceResponse.to_json/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html#to_json/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChoiceResponse.to_tool/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html#to_tool/0"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChoiceResponse.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html#validate_params/1"},{"type":"function","title":"Examples - Jido.AI.Actions.Instructor.ChoiceResponse.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html#validate_params/1-examples"},{"type":"function","title":"Jido.AI.Actions.Instructor.ChoiceResponse.vsn/0","doc":"","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.html#vsn/0"},{"type":"module","title":"Jido.AI.Actions.Instructor.ChoiceResponse.Schema","doc":"","ref":"Jido.AI.Actions.Instructor.ChoiceResponse.Schema.html"},{"type":"module","title":"Jido.AI.Actions.Langchain","doc":"A low-level action that provides direct access to Langchain's chat completion functionality.\nSupports multiple providers through Langchain adapters and integrates with Jido's Model and Prompt structures.\n\nThis module serves as a foundation for more specialized AI actions like:\n- `Jido.AI.Actions.Langchain.ToolResponse` - For working with tools/function calling\n- `Jido.AI.Actions.Langchain.BooleanResponse` - For specialized yes/no answers with explanations","ref":"Jido.AI.Actions.Langchain.html"},{"type":"module","title":"Features - Jido.AI.Actions.Langchain","doc":"- Multi-provider support (OpenAI, Anthropic, OpenRouter)\n- Tool/function calling capabilities\n- Response quality control with retry mechanisms\n- Support for various LLM parameters (temperature, top_p, etc.)\n- Structured error handling and logging\n- Streaming support (when provider allows)","ref":"Jido.AI.Actions.Langchain.html#module-features"},{"type":"module","title":"Usage - Jido.AI.Actions.Langchain","doc":"```elixir\n# Basic usage\n{:ok, result} = Jido.AI.Actions.Langchain.run(%{\n  model: %Jido.AI.Model{provider: :anthropic, model: \"claude-3-sonnet-20240229\", api_key: \"key\"},\n  prompt: Jido.AI.Prompt.new(:user, \"What's the weather in Tokyo?\")\n})\n\n# With function calling / tools\n{:ok, result} = Jido.AI.Actions.Langchain.run(%{\n  model: %Jido.AI.Model{provider: :openai, model: \"gpt-4o\", api_key: \"key\"},\n  prompt: prompt,\n  tools: [Jido.Actions.Weather.GetWeather, Jido.Actions.Search.WebSearch],\n  temperature: 0.2\n})\n\n# With OpenRouter (for accessing multiple model providers via one API)\n{:ok, result} = Jido.AI.Actions.Langchain.run(%{\n  model: %Jido.AI.Model{\n    provider: :openrouter,\n    model: \"anthropic/claude-3-opus\",\n    api_key: \"key\",\n    base_url: \"https://openrouter.ai/api/v1\"\n  },\n  prompt: prompt\n})\n\n# Streaming responses\n{:ok, stream} = Jido.AI.Actions.Langchain.run(%{\n  model: model,\n  prompt: prompt,\n  stream: true\n})\n\nEnum.each(stream, fn chunk ->\n  IO.puts(chunk.content)\nend)\n```","ref":"Jido.AI.Actions.Langchain.html#module-usage"},{"type":"module","title":"Building Custom Actions - Jido.AI.Actions.Langchain","doc":"This module can be used as a foundation for building more specialized actions.\nFor example, to create a domain-specific completion:\n\n```elixir\ndefmodule MyApp.FoodRecommendationAction do\n  use Jido.Action,\n    name: \"food_recommendation\",\n    description: \"Get restaurant recommendations\"\n\n  alias Jido.AI.Actions.Langchain\n\n  def run(params, context) do\n    # Enhance with domain-specific prompt engineering\n    prompt = create_food_prompt(params)\n\n    # Use BaseCompletion for the heavy lifting\n    BaseCompletion.run(%{\n      model: params.model,\n      prompt: prompt,\n      temperature: 0.7\n    }, context)\n  end\n\n  defp create_food_prompt(params) do\n    # Your domain-specific prompt building logic\n  end\nend\n```","ref":"Jido.AI.Actions.Langchain.html#module-building-custom-actions"},{"type":"module","title":"Support Matrix - Jido.AI.Actions.Langchain","doc":"| Provider   | Adapter                | Notes                          |\n|------------|------------------------|--------------------------------|\n| openai     | LangChain.ChatModels.ChatOpenAI     | GPT models, function calling |\n| anthropic  | LangChain.ChatModels.ChatAnthropic | Claude models                |\n| openrouter | LangChain.ChatModels.ChatOpenAI    | OpenAI-compatible API for multiple providers |","ref":"Jido.AI.Actions.Langchain.html#module-support-matrix"},{"type":"function","title":"Jido.AI.Actions.Langchain.category/0","doc":"","ref":"Jido.AI.Actions.Langchain.html#category/0"},{"type":"function","title":"Jido.AI.Actions.Langchain.description/0","doc":"","ref":"Jido.AI.Actions.Langchain.html#description/0"},{"type":"function","title":"Jido.AI.Actions.Langchain.name/0","doc":"","ref":"Jido.AI.Actions.Langchain.html#name/0"},{"type":"function","title":"Jido.AI.Actions.Langchain.on_after_run/1","doc":"","ref":"Jido.AI.Actions.Langchain.html#on_after_run/1"},{"type":"function","title":"Jido.AI.Actions.Langchain.on_after_validate_params/1","doc":"","ref":"Jido.AI.Actions.Langchain.html#on_after_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.Langchain.on_error/4","doc":"","ref":"Jido.AI.Actions.Langchain.html#on_error/4"},{"type":"function","title":"Jido.AI.Actions.Langchain.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.AI.Actions.Langchain.html#run/2"},{"type":"function","title":"Jido.AI.Actions.Langchain.schema/0","doc":"","ref":"Jido.AI.Actions.Langchain.html#schema/0"},{"type":"function","title":"Jido.AI.Actions.Langchain.tags/0","doc":"","ref":"Jido.AI.Actions.Langchain.html#tags/0"},{"type":"function","title":"Jido.AI.Actions.Langchain.to_json/0","doc":"","ref":"Jido.AI.Actions.Langchain.html#to_json/0"},{"type":"function","title":"Jido.AI.Actions.Langchain.to_tool/0","doc":"","ref":"Jido.AI.Actions.Langchain.html#to_tool/0"},{"type":"function","title":"Jido.AI.Actions.Langchain.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.AI.Actions.Langchain.html#validate_params/1"},{"type":"function","title":"Examples - Jido.AI.Actions.Langchain.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.AI.Actions.Langchain.html#validate_params/1-examples"},{"type":"function","title":"Jido.AI.Actions.Langchain.vsn/0","doc":"","ref":"Jido.AI.Actions.Langchain.html#vsn/0"},{"type":"module","title":"Jido.AI.Actions.Langchain.ToolResponse","doc":"","ref":"Jido.AI.Actions.Langchain.ToolResponse.html"},{"type":"function","title":"Jido.AI.Actions.Langchain.ToolResponse.category/0","doc":"","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#category/0"},{"type":"function","title":"Jido.AI.Actions.Langchain.ToolResponse.description/0","doc":"","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#description/0"},{"type":"function","title":"Jido.AI.Actions.Langchain.ToolResponse.name/0","doc":"","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#name/0"},{"type":"function","title":"Jido.AI.Actions.Langchain.ToolResponse.on_after_run/1","doc":"","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#on_after_run/1"},{"type":"function","title":"Jido.AI.Actions.Langchain.ToolResponse.on_after_validate_params/1","doc":"","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#on_after_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.Langchain.ToolResponse.on_before_validate_params/1","doc":"","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#on_before_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.Langchain.ToolResponse.on_error/4","doc":"","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#on_error/4"},{"type":"function","title":"Jido.AI.Actions.Langchain.ToolResponse.run/2","doc":"Executes the Action with the given parameters and context.\n\nThe `run/2` function must be implemented in the module using Jido.Action.","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#run/2"},{"type":"function","title":"Jido.AI.Actions.Langchain.ToolResponse.schema/0","doc":"","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#schema/0"},{"type":"function","title":"Jido.AI.Actions.Langchain.ToolResponse.tags/0","doc":"","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#tags/0"},{"type":"function","title":"Jido.AI.Actions.Langchain.ToolResponse.test/0","doc":"","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#test/0"},{"type":"function","title":"Jido.AI.Actions.Langchain.ToolResponse.to_json/0","doc":"","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#to_json/0"},{"type":"function","title":"Jido.AI.Actions.Langchain.ToolResponse.to_tool/0","doc":"","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#to_tool/0"},{"type":"function","title":"Jido.AI.Actions.Langchain.ToolResponse.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#validate_params/1"},{"type":"function","title":"Examples - Jido.AI.Actions.Langchain.ToolResponse.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#validate_params/1-examples"},{"type":"function","title":"Jido.AI.Actions.Langchain.ToolResponse.vsn/0","doc":"","ref":"Jido.AI.Actions.Langchain.ToolResponse.html#vsn/0"},{"type":"module","title":"Jido.AI.Actions.OpenaiEx","doc":"","ref":"Jido.AI.Actions.OpenaiEx.html"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.category/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.html#category/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.description/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.html#description/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.name/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.html#name/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.on_after_run/1","doc":"","ref":"Jido.AI.Actions.OpenaiEx.html#on_after_run/1"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.on_after_validate_params/1","doc":"","ref":"Jido.AI.Actions.OpenaiEx.html#on_after_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.on_before_validate_params/1","doc":"","ref":"Jido.AI.Actions.OpenaiEx.html#on_before_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.on_error/4","doc":"","ref":"Jido.AI.Actions.OpenaiEx.html#on_error/4"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.run/2","doc":"Runs a chat completion request using OpenAI Ex.","ref":"Jido.AI.Actions.OpenaiEx.html#run/2"},{"type":"function","title":"Parameters - Jido.AI.Actions.OpenaiEx.run/2","doc":"- params: Map containing:\n    - model: Either a %Jido.AI.Model{} struct or a tuple of {provider, opts}\n    - messages: List of message maps with :role and :content (required if prompt is not provided)\n    - prompt: A %Jido.AI.Prompt{} struct or string (required if messages is not provided)\n    - tools: Optional list of Jido.Action modules for function calling\n    - tool_choice: Optional tool choice configuration\n    - temperature: Optional float between 0 and 2 (defaults to model's temperature)\n    - max_tokens: Optional integer (defaults to model's max_tokens)\n    - top_p: Optional float between 0 and 1\n    - frequency_penalty: Optional float between -2.0 and 2.0\n    - presence_penalty: Optional float between -2.0 and 2.0\n    - stop: Optional list of strings\n    - response_format: Optional atom (:text or :json)\n    - seed: Optional integer for deterministic responses\n    - stream: Optional boolean for streaming responses\n  - context: The action context containing state and other information","ref":"Jido.AI.Actions.OpenaiEx.html#run/2-parameters"},{"type":"function","title":"Returns - Jido.AI.Actions.OpenaiEx.run/2","doc":"- {:ok, %{content: content, tool_results: results}} on success\n  - {:error, reason} on failure\n  - Stream of chunks if streaming is enabled","ref":"Jido.AI.Actions.OpenaiEx.html#run/2-returns"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.schema/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.html#schema/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.tags/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.html#tags/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.to_json/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.html#to_json/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.to_tool/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.html#to_tool/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.AI.Actions.OpenaiEx.html#validate_params/1"},{"type":"function","title":"Examples - Jido.AI.Actions.OpenaiEx.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.AI.Actions.OpenaiEx.html#validate_params/1-examples"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.vsn/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.html#vsn/0"},{"type":"module","title":"Jido.AI.Actions.OpenaiEx.Embeddings","doc":"Action module for generating vector embeddings using OpenAI Ex.\n\nThis module supports embedding generation with both OpenAI and OpenRouter providers.\nEmbeddings are useful for semantic search, clustering, classification, and other\nsimilarity-based operations.","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html"},{"type":"module","title":"Features - Jido.AI.Actions.OpenaiEx.Embeddings","doc":"- Support for both OpenAI and OpenRouter providers\n- Single string or batch processing of multiple strings\n- Configurable dimensions and encoding format\n- Consistent error handling and validation","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#module-features"},{"type":"module","title":"Usage - Jido.AI.Actions.OpenaiEx.Embeddings","doc":"```elixir\n# Generate embeddings for a single string\n{:ok, result} = Jido.AI.Actions.OpenaiEx.Embeddings.run(\n  %{\n    model: %Jido.AI.Model{provider: :openai, model: \"text-embedding-ada-002\", api_key: \"key\"},\n    input: \"Hello, world!\"\n  },\n  %{}\n)\n\n# Generate embeddings for multiple strings\n{:ok, result} = Jido.AI.Actions.OpenaiEx.Embeddings.run(\n  %{\n    model: %Jido.AI.Model{provider: :openai, model: \"text-embedding-ada-002\", api_key: \"key\"},\n    input: [\"Hello\", \"World\"]\n  },\n  %{}\n)\n```","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#module-usage"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.Embeddings.category/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#category/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.Embeddings.description/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#description/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.Embeddings.name/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#name/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.Embeddings.on_after_run/1","doc":"","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#on_after_run/1"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.Embeddings.on_after_validate_params/1","doc":"","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#on_after_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.Embeddings.on_before_validate_params/1","doc":"","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#on_before_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.Embeddings.on_error/4","doc":"","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#on_error/4"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.Embeddings.run/2","doc":"Generates embeddings for the given input using OpenAI Ex.","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#run/2"},{"type":"function","title":"Parameters - Jido.AI.Actions.OpenaiEx.Embeddings.run/2","doc":"- params: Map containing:\n    - model: Either a %Jido.AI.Model{} struct or a tuple of {provider, opts}\n    - input: String or list of strings to generate embeddings for\n    - dimensions: Optional number of dimensions (model dependent)\n    - encoding_format: Optional format for the embeddings (:float or :base64)\n  - context: The action context containing state and other information","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#run/2-parameters"},{"type":"function","title":"Returns - Jido.AI.Actions.OpenaiEx.Embeddings.run/2","doc":"- {:ok, %{embeddings: embeddings}} on success where embeddings is a list of vectors\n  - {:error, reason} on failure","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#run/2-returns"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.Embeddings.schema/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#schema/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.Embeddings.tags/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#tags/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.Embeddings.to_json/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#to_json/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.Embeddings.to_tool/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#to_tool/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.Embeddings.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#validate_params/1"},{"type":"function","title":"Examples - Jido.AI.Actions.OpenaiEx.Embeddings.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#validate_params/1-examples"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.Embeddings.vsn/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.Embeddings.html#vsn/0"},{"type":"module","title":"Jido.AI.Actions.OpenaiEx.ImageGeneration","doc":"Action module for generating images using OpenAI Ex.\n\nThis module supports image generation with both OpenAI and OpenRouter providers.\nIt uses the DALL-E models to create images from text prompts with various\ncustomization options.","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html"},{"type":"module","title":"Features - Jido.AI.Actions.OpenaiEx.ImageGeneration","doc":"- Support for both OpenAI and OpenRouter providers\n- Customizable image generation parameters (size, quality, style)\n- Multiple image generation in a single request\n- Support for different response formats (URL or base64)\n- Consistent error handling and validation","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#module-features"},{"type":"module","title":"Usage - Jido.AI.Actions.OpenaiEx.ImageGeneration","doc":"```elixir\n# Generate a single image\n{:ok, result} = Jido.AI.Actions.OpenaiEx.ImageGeneration.run(\n  %{\n    model: %Jido.AI.Model{provider: :openai, model: \"dall-e-3\", api_key: \"key\"},\n    prompt: \"A beautiful sunset over the ocean\"\n  },\n  %{}\n)\n\n# Generate multiple images with custom parameters\n{:ok, result} = Jido.AI.Actions.OpenaiEx.ImageGeneration.run(\n  %{\n    model: %Jido.AI.Model{provider: :openai, model: \"dall-e-3\", api_key: \"key\"},\n    prompt: \"A beautiful sunset over the ocean\",\n    n: 2,\n    size: \"1024x1792\",\n    quality: \"hd\",\n    style: \"natural\"\n  },\n  %{}\n)\n```","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#module-usage"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ImageGeneration.category/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#category/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ImageGeneration.description/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#description/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ImageGeneration.name/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#name/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ImageGeneration.on_after_run/1","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#on_after_run/1"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ImageGeneration.on_after_validate_params/1","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#on_after_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ImageGeneration.on_before_validate_params/1","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#on_before_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ImageGeneration.on_error/4","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#on_error/4"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ImageGeneration.run/2","doc":"Generates images from a text prompt using OpenAI Ex.","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#run/2"},{"type":"function","title":"Parameters - Jido.AI.Actions.OpenaiEx.ImageGeneration.run/2","doc":"- params: Map containing:\n    - model: Either a %Jido.AI.Model{} struct or a tuple of {provider, opts}\n    - prompt: Text description of the desired image\n    - n: Optional number of images to generate (1-10)\n    - size: Optional size of the generated images\n    - quality: Optional quality level (\"standard\" or \"hd\")\n    - style: Optional style (\"vivid\" or \"natural\")\n    - response_format: Optional format (\"url\" or \"b64_json\")\n  - context: The action context containing state and other information","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#run/2-parameters"},{"type":"function","title":"Returns - Jido.AI.Actions.OpenaiEx.ImageGeneration.run/2","doc":"- {:ok, %{images: images}} on success where images is a list of URLs or base64 strings\n  - {:error, reason} on failure","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#run/2-returns"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ImageGeneration.schema/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#schema/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ImageGeneration.tags/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#tags/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ImageGeneration.to_json/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#to_json/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ImageGeneration.to_tool/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#to_tool/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ImageGeneration.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#validate_params/1"},{"type":"function","title":"Examples - Jido.AI.Actions.OpenaiEx.ImageGeneration.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#validate_params/1-examples"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ImageGeneration.vsn/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ImageGeneration.html#vsn/0"},{"type":"module","title":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.category/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#category/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.description/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#description/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.name/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#name/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.on_after_run/1","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#on_after_run/1"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.on_after_validate_params/1","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#on_after_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.on_before_validate_params/1","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#on_before_validate_params/1"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.on_error/4","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#on_error/4"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.run/2","doc":"Retrieves an asynchronous response using OpenAI Responses API.","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#run/2"},{"type":"function","title":"Parameters - Jido.AI.Actions.OpenaiEx.ResponseRetrieve.run/2","doc":"- params: Map containing:\n    - model: Either a %Jido.AI.Model{} struct or a tuple of {provider, opts}\n    - response_id: The ID of the response to retrieve\n  - context: The action context containing state and other information","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#run/2-parameters"},{"type":"function","title":"Returns - Jido.AI.Actions.OpenaiEx.ResponseRetrieve.run/2","doc":"- {:ok, %{\n      id: response_id,\n      model: model_name,\n      content: response_content,\n      tool_results: [optional_tool_results],\n      status: \"completed\" | \"processing\" | \"error\",\n      created_at: timestamp\n    }} on success\n  - {:error, reason} on failure","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#run/2-returns"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.schema/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#schema/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.tags/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#tags/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.to_json/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#to_json/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.to_tool/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#to_tool/0"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.validate_params/1","doc":"Validates the input parameters for the Action.","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#validate_params/1"},{"type":"function","title":"Examples - Jido.AI.Actions.OpenaiEx.ResponseRetrieve.validate_params/1","doc":"iex> defmodule ExampleAction do\n    ...>   use Jido.Action,\n    ...>     name: \"example_action\",\n    ...>     schema: [\n    ...>       input: [type: :string, required: true]\n    ...>     ]\n    ...> end\n    ...> ExampleAction.validate_params(%{input: \"test\"})\n    {:ok, %{input: \"test\"}}\n\n    iex> ExampleAction.validate_params(%{})\n    {:error, \"Invalid parameters for Action: Required key :input not found\"}","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#validate_params/1-examples"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.vsn/0","doc":"","ref":"Jido.AI.Actions.OpenaiEx.ResponseRetrieve.html#vsn/0"},{"type":"module","title":"Jido.AI.Actions.OpenaiEx.ToolHelper","doc":"Helper module for handling tool calling with OpenAiEx.\nProvides functions to convert Jido.Action to OpenAI tool format and handle tool responses.","ref":"Jido.AI.Actions.OpenaiEx.ToolHelper.html"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ToolHelper.handle_tool_call/2","doc":"Handles a tool call response from OpenAI.\nExecutes the appropriate action with the given parameters.","ref":"Jido.AI.Actions.OpenaiEx.ToolHelper.html#handle_tool_call/2"},{"type":"function","title":"Parameters - Jido.AI.Actions.OpenaiEx.ToolHelper.handle_tool_call/2","doc":"- tool_call: The tool call object from OpenAI response\n  - available_actions: List of available Jido.Action modules","ref":"Jido.AI.Actions.OpenaiEx.ToolHelper.html#handle_tool_call/2-parameters"},{"type":"function","title":"Returns - Jido.AI.Actions.OpenaiEx.ToolHelper.handle_tool_call/2","doc":"* `{:ok, result}` - where result is the output of the action\n  * `{:error, reason}` - if the tool call cannot be handled","ref":"Jido.AI.Actions.OpenaiEx.ToolHelper.html#handle_tool_call/2-returns"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ToolHelper.process_response/2","doc":"Processes a chat completion response that may contain tool calls.\nIf tool calls are present, executes them and returns the results.","ref":"Jido.AI.Actions.OpenaiEx.ToolHelper.html#process_response/2"},{"type":"function","title":"Parameters - Jido.AI.Actions.OpenaiEx.ToolHelper.process_response/2","doc":"- response: The chat completion response from OpenAI\n  - available_actions: List of available Jido.Action modules","ref":"Jido.AI.Actions.OpenaiEx.ToolHelper.html#process_response/2-parameters"},{"type":"function","title":"Returns - Jido.AI.Actions.OpenaiEx.ToolHelper.process_response/2","doc":"* `{:ok, %{content: content, tool_results: results}}` - where content is the assistant's message\n  * `{:error, reason}` - if tool calls cannot be processed","ref":"Jido.AI.Actions.OpenaiEx.ToolHelper.html#process_response/2-returns"},{"type":"function","title":"Jido.AI.Actions.OpenaiEx.ToolHelper.to_openai_tools/1","doc":"Converts a list of Jido.Action modules to OpenAI tool format.\nEach action must implement the Jido.Action.Tool protocol.","ref":"Jido.AI.Actions.OpenaiEx.ToolHelper.html#to_openai_tools/1"},{"type":"function","title":"Parameters - Jido.AI.Actions.OpenaiEx.ToolHelper.to_openai_tools/1","doc":"- actions: List of Jido.Action modules that implement Jido.Action.Tool","ref":"Jido.AI.Actions.OpenaiEx.ToolHelper.html#to_openai_tools/1-parameters"},{"type":"function","title":"Returns - Jido.AI.Actions.OpenaiEx.ToolHelper.to_openai_tools/1","doc":"* `{:ok, tools}` - where tools is a list of OpenAI tool specifications\n  * `{:error, reason}` - if any action doesn't implement the protocol","ref":"Jido.AI.Actions.OpenaiEx.ToolHelper.html#to_openai_tools/1-returns"},{"type":"module","title":"Jido.AI.Agent","doc":"General purpose AI agent powered by Jido","ref":"Jido.AI.Agent.html"},{"type":"function","title":"Jido.AI.Agent.actions/0","doc":"","ref":"Jido.AI.Agent.html#actions/0"},{"type":"type","title":"Jido.AI.Agent.agent_result/0","doc":"","ref":"Jido.AI.Agent.html#t:agent_result/0"},{"type":"type","title":"Jido.AI.Agent.agent_result_with_directives/0","doc":"","ref":"Jido.AI.Agent.html#t:agent_result_with_directives/0"},{"type":"function","title":"Jido.AI.Agent.boolean_response/2","doc":"","ref":"Jido.AI.Agent.html#boolean_response/2"},{"type":"function","title":"Jido.AI.Agent.category/0","doc":"","ref":"Jido.AI.Agent.html#category/0"},{"type":"function","title":"Jido.AI.Agent.chat_response/2","doc":"","ref":"Jido.AI.Agent.html#chat_response/2"},{"type":"function","title":"Jido.AI.Agent.cmd/4","doc":"Validates, plans and executes instructions for the agent with enhanced error handling and state management.","ref":"Jido.AI.Agent.html#cmd/4"},{"type":"function","title":"Parameters - Jido.AI.Agent.cmd/4","doc":"* `agent` - The agent struct to act on\n  * `instructions` - One of:\n    * Single action module\n    * Single action tuple {module, params}\n    * List of action modules\n    * List of {action_module, params} tuples\n    * Mixed list of modules and tuples (e.g. [ValidateAction, {ProcessAction, %{file: \"data.csv\"}}])\n  * `context` - Map of execution context data (default: %{})\n  * `opts` - Keyword list of execution options:\n    * `:runner` - Custom runner module (default: agent's configured runner)\n    * `:strict_validation` - Enable/disable param validation (default: false)","ref":"Jido.AI.Agent.html#cmd/4-parameters"},{"type":"function","title":"Command Flow - Jido.AI.Agent.cmd/4","doc":"1. Optional parameter validation\n2. Instruction normalization\n3. State preparation and merging\n4. Action planning with context\n5. Execution with configured runner\n6. Result processing and state application through directives","ref":"Jido.AI.Agent.html#cmd/4-command-flow"},{"type":"function","title":"Returns - Jido.AI.Agent.cmd/4","doc":"* `{:ok, updated_agent, directives}` - Command executed successfully\n    * State modifications are handled through directives\n    * Result stored in agent.result field\n  * `{:error, Error.t()}` - Detailed error with context","ref":"Jido.AI.Agent.html#cmd/4-returns"},{"type":"function","title":"Examples - Jido.AI.Agent.cmd/4","doc":"# Basic command with single action\n    {:ok, agent, directives} = MyAgent.cmd(agent, ProcessAction)\n\n    # Single action with params\n    {:ok, agent, directives} = MyAgent.cmd(agent, {ProcessAction, %{file: \"data.csv\"}})\n\n    # Multiple actions with context\n    {:ok, agent, directives} = MyAgent.cmd(\n      agent,\n      [\n        ValidateAction,\n        {ProcessAction, %{file: \"data.csv\"}},\n        StoreAction\n      ],\n      %{user_id: \"123\"}\n    )\n\n    # With custom options\n    {:ok, agent, directives} = MyAgent.cmd(\n      agent,\n      {ProcessAction, %{file: \"data.csv\"}},\n      %{user_id: \"123\"},\n      runner: CustomRunner\n    )\n\n    # Error handling\n    case MyAgent.cmd(agent, ProcessAction, %{}) do\n      {:ok, updated_agent, directives} ->\n        # Success case - state updated through directives\n        updated_agent.state\n      {:error, %Error{type: :validation_error}} ->\n        # Handle validation failure\n      {:error, %Error{type: :execution_error}} ->\n        # Handle execution error\n    end","ref":"Jido.AI.Agent.html#cmd/4-examples"},{"type":"function","title":"Jido.AI.Agent.deregister_action/2","doc":"Removes a previously registered action module from the Agent.","ref":"Jido.AI.Agent.html#deregister_action/2"},{"type":"function","title":"Parameters - Jido.AI.Agent.deregister_action/2","doc":"* `agent` - The Agent struct to update\n  * `action_module` - The action module to remove","ref":"Jido.AI.Agent.html#deregister_action/2-parameters"},{"type":"function","title":"Returns - Jido.AI.Agent.deregister_action/2","doc":"* `{:ok, updated_agent}` - Action successfully deregistered\n  * `{:error, term()}` - Deregistration failed","ref":"Jido.AI.Agent.html#deregister_action/2-returns"},{"type":"function","title":"Example - Jido.AI.Agent.deregister_action/2","doc":"{:ok, agent} = MyAgent.deregister_action(agent, MyApp.Actions.OldAction)","ref":"Jido.AI.Agent.html#deregister_action/2-example"},{"type":"function","title":"Jido.AI.Agent.description/0","doc":"","ref":"Jido.AI.Agent.html#description/0"},{"type":"function","title":"Jido.AI.Agent.handle_signal/2","doc":"","ref":"Jido.AI.Agent.html#handle_signal/2"},{"type":"type","title":"Jido.AI.Agent.instruction/0","doc":"","ref":"Jido.AI.Agent.html#t:instruction/0"},{"type":"type","title":"Jido.AI.Agent.instructions/0","doc":"","ref":"Jido.AI.Agent.html#t:instructions/0"},{"type":"type","title":"Jido.AI.Agent.map_result/0","doc":"","ref":"Jido.AI.Agent.html#t:map_result/0"},{"type":"function","title":"Jido.AI.Agent.mount/2","doc":"","ref":"Jido.AI.Agent.html#mount/2"},{"type":"function","title":"Jido.AI.Agent.name/0","doc":"","ref":"Jido.AI.Agent.html#name/0"},{"type":"function","title":"Jido.AI.Agent.new/1","doc":"Creates a new agent instance with an optional ID and initial state.","ref":"Jido.AI.Agent.html#new/1"},{"type":"function","title":"Initialization - Jido.AI.Agent.new/1","doc":"The new agent is initialized with:\n  * A unique identifier (provided or auto-generated)\n  * Default state values from schema\n  * Empty instruction queue\n  * Clean state flag (dirty_state?: false)\n  * Configured actions from compile-time options\n  * Empty result field","ref":"Jido.AI.Agent.html#new/1-initialization"},{"type":"function","title":"ID Generation - Jido.AI.Agent.new/1","doc":"If no ID is provided, a UUIDv4 is generated using namespace-based deterministic generation\nvia `Jido.Util.generate_id/0`. The generated ID is guaranteed to be:\n  * Unique within the current server\n  * Cryptographically secure\n  * URL-safe string format","ref":"Jido.AI.Agent.html#new/1-id-generation"},{"type":"function","title":"State Initialization - Jido.AI.Agent.new/1","doc":"The initial state is constructed using default values from the compile-time schema:\n  * Fields with defaults use their specified values\n  * Required fields without defaults are initialized as nil\n  * Optional fields without defaults are omitted\n  * Unknown fields are ignored\n  * Initial state map is merged and validated if provided","ref":"Jido.AI.Agent.html#new/1-state-initialization"},{"type":"function","title":"Parameters - Jido.AI.Agent.new/1","doc":"* `id` - Optional string ID for the agent. When provided:\n    * Must be unique within your system\n    * Should be URL-safe\n    * Should not exceed 255 characters\n    * Is used-as-is without validation\n  * `initial_state` - Optional map of initial state values to merge with defaults","ref":"Jido.AI.Agent.html#new/1-parameters"},{"type":"function","title":"Returns - Jido.AI.Agent.new/1","doc":"* `t()` - A new agent struct containing:\n    * `:id` - String, provided or generated identifier\n    * `:state` - Map, initialized with schema defaults and initial_state\n    * `:dirty_state?` - Boolean, set to false\n    * `:pending_instructions` - Queue, empty :queue.queue()\n    * `:actions` - List, configured action modules from compile-time\n    * `:result` - Term, initialized as nil","ref":"Jido.AI.Agent.html#new/1-returns"},{"type":"function","title":"Examples - Jido.AI.Agent.new/1","doc":"# Create with auto-generated ID\n    agent = MyAgent.new()\n    agent.id #=> \"c4b3f-...\" (UUID format)\n    agent.dirty_state? #=> false\n\n    # Create with custom ID and initial state\n    agent = MyAgent.new(\"custom_id_123\", %{status: :ready})\n    agent.id #=> \"custom_id_123\"\n    agent.state.status #=> :ready\n\n    # Schema defaults are applied\n    defmodule AgentWithDefaults do\n      use Jido.Agent,\n        name: \"test\",\n        schema: [\n          status: [type: :atom, default: :pending],\n          retries: [type: :integer, default: 3],\n          optional_field: [type: :string]\n        ]\n    end\n\n    agent = AgentWithDefaults.new()\n    agent.state #=> %{\n      status: :pending,     # From default\n      retries: 3,          # From default\n      optional_field: nil   # No default\n    }","ref":"Jido.AI.Agent.html#new/1-examples"},{"type":"function","title":"Warning - Jido.AI.Agent.new/1","doc":"While IDs are guaranteed unique when auto-generated, the function does not validate\nuniqueness of provided IDs. When supplying custom IDs, you must ensure uniqueness\nwithin your system's context.\n\nSee `Jido.Util.generate_id/0` for details on ID generation.","ref":"Jido.AI.Agent.html#new/1-warning"},{"type":"function","title":"Jido.AI.Agent.new/2","doc":"","ref":"Jido.AI.Agent.html#new/2"},{"type":"function","title":"Jido.AI.Agent.on_after_run/3","doc":"","ref":"Jido.AI.Agent.html#on_after_run/3"},{"type":"function","title":"Jido.AI.Agent.on_after_validate_state/1","doc":"","ref":"Jido.AI.Agent.html#on_after_validate_state/1"},{"type":"function","title":"Jido.AI.Agent.on_before_plan/3","doc":"","ref":"Jido.AI.Agent.html#on_before_plan/3"},{"type":"function","title":"Jido.AI.Agent.on_before_run/1","doc":"","ref":"Jido.AI.Agent.html#on_before_run/1"},{"type":"function","title":"Jido.AI.Agent.on_before_validate_state/1","doc":"","ref":"Jido.AI.Agent.html#on_before_validate_state/1"},{"type":"function","title":"Jido.AI.Agent.on_error/2","doc":"","ref":"Jido.AI.Agent.html#on_error/2"},{"type":"function","title":"Jido.AI.Agent.pending?/1","doc":"Returns the number of pending actions in the agent's pending_instructions queue.","ref":"Jido.AI.Agent.html#pending?/1"},{"type":"function","title":"Parameters - Jido.AI.Agent.pending?/1","doc":"- agent: The agent struct to check","ref":"Jido.AI.Agent.html#pending?/1-parameters"},{"type":"function","title":"Returns - Jido.AI.Agent.pending?/1","doc":"- Integer count of pending actions","ref":"Jido.AI.Agent.html#pending?/1-returns"},{"type":"function","title":"Jido.AI.Agent.plan/3","doc":"Plans one or more actions by adding them to the agent's pending instruction queue.\nActions must be registered and valid for the agent. Planning updates the `dirty_state?`\nflag and triggers the `on_before_plan` callback.","ref":"Jido.AI.Agent.html#plan/3"},{"type":"function","title":"Action Registration - Jido.AI.Agent.plan/3","doc":"* Actions must be registered via `register_action/2`\n* Invalid or unregistered actions fail planning","ref":"Jido.AI.Agent.html#plan/3-action-registration"},{"type":"function","title":"Parameters - Jido.AI.Agent.plan/3","doc":"* `agent` - The agent struct to plan actions for\n* `instructions` - One of (see `Instruction.normalize/2` for details):\n  * Single action module\n  * Single action tuple {module, params}\n  * List of action modules\n  * List of {action_module, params} tuples\n  * Mixed list of modules and tuples (e.g. [ValidateAction, {ProcessAction, %{file: \"data.csv\"}}])\n* `context` - Optional map of context data to include in instructions (default: %{})","ref":"Jido.AI.Agent.html#plan/3-parameters"},{"type":"function","title":"Planning Process - Jido.AI.Agent.plan/3","doc":"1. Normalizes instructions into consistent [{module, params}] format\n2. Validates action registration\n3. Builds `Instruction` structs with params and provided context\n4. Executes on_before_plan callback\n5. Adds instructions to pending queue\n6. Sets dirty_state? flag","ref":"Jido.AI.Agent.html#plan/3-planning-process"},{"type":"function","title":"Returns - Jido.AI.Agent.plan/3","doc":"* `{:ok, updated_agent}` - Agent with updated pending_instructions and dirty_state?\n* `{:error, reason}` - Planning failed","ref":"Jido.AI.Agent.html#plan/3-returns"},{"type":"function","title":"Examples - Jido.AI.Agent.plan/3","doc":"# Plan single action\n    {:ok, agent} = MyAgent.plan(agent, ProcessAction)\n\n    # Plan single action with params and context\n    {:ok, agent} = MyAgent.plan(agent, {ProcessAction, %{file: \"data.csv\"}}, %{user_id: \"123\"})\n\n    # Plan multiple actions with shared context\n    {:ok, agent} = MyAgent.plan(agent, [\n      ValidateAction,\n      {ProcessAction, %{file: \"data.csv\"}},\n      {SaveAction, %{path: \"/tmp\"}}\n    ], %{request_id: \"abc123\"})\n\n    # Validation failures\n    {:error, reason} = MyAgent.plan(agent, UnregisteredAction)\n    {:error, reason} = MyAgent.plan(agent, [{InvalidAction, %{}}])","ref":"Jido.AI.Agent.html#plan/3-examples"},{"type":"function","title":"Error Handling - Jido.AI.Agent.plan/3","doc":"* Unregistered actions return execution error with affected action details\n* Invalid instruction format returns error with expected format details\n* Failed callbacks return error with callback context\n* All errors include agent_id and relevant debugging information\n\nSee `registered_actions/1` for checking available actions and `run/2` for executing planned actions.","ref":"Jido.AI.Agent.html#plan/3-error-handling"},{"type":"function","title":"Jido.AI.Agent.register_action/2","doc":"Registers a new action module with the Agent at server.\n\nThe action module must implement the `Jido.Action` behavior and will be\nvalidated before registration.","ref":"Jido.AI.Agent.html#register_action/2"},{"type":"function","title":"Parameters - Jido.AI.Agent.register_action/2","doc":"* `agent` - The Agent struct to update\n  * `action_module` - The action module to register","ref":"Jido.AI.Agent.html#register_action/2-parameters"},{"type":"function","title":"Returns - Jido.AI.Agent.register_action/2","doc":"* `{:ok, updated_agent}` - Action successfully registered\n  * `{:error, term()}` - Registration failed (invalid module)","ref":"Jido.AI.Agent.html#register_action/2-returns"},{"type":"function","title":"Example - Jido.AI.Agent.register_action/2","doc":"{:ok, agent} = MyAgent.register_action(agent, MyApp.Actions.NewAction)","ref":"Jido.AI.Agent.html#register_action/2-example"},{"type":"function","title":"Jido.AI.Agent.registered_actions/1","doc":"Returns all action modules currently registered with the Agent.\n\nThis includes both compile-time configured actions and server registered ones.\nActions are returned in registration order (most recently registered first).","ref":"Jido.AI.Agent.html#registered_actions/1"},{"type":"function","title":"Parameters - Jido.AI.Agent.registered_actions/1","doc":"* `agent` - The Agent struct to inspect","ref":"Jido.AI.Agent.html#registered_actions/1-parameters"},{"type":"function","title":"Returns - Jido.AI.Agent.registered_actions/1","doc":"* `[module()]` - List of registered action modules, empty if none","ref":"Jido.AI.Agent.html#registered_actions/1-returns"},{"type":"function","title":"Example - Jido.AI.Agent.registered_actions/1","doc":"actions = MyAgent.registered_actions(agent)\n    # Returns: [MyAction1, MyAction2]","ref":"Jido.AI.Agent.html#registered_actions/1-example"},{"type":"function","title":"Jido.AI.Agent.reset/1","doc":"Resets the agent's pending action queue.","ref":"Jido.AI.Agent.html#reset/1"},{"type":"function","title":"Parameters - Jido.AI.Agent.reset/1","doc":"- agent: The agent struct to reset","ref":"Jido.AI.Agent.html#reset/1-parameters"},{"type":"function","title":"Returns - Jido.AI.Agent.reset/1","doc":"- `{:ok, updated_agent}` - Queue was reset successfully","ref":"Jido.AI.Agent.html#reset/1-returns"},{"type":"function","title":"Jido.AI.Agent.run/2","doc":"Executes pending instructions in the agent's queue through a multi-phase process.\n\nInstructions are executed with the help of a runner. Review `Jido.Runner` for more information.\n\nEach phase can modify the agent's state and trigger callbacks.","ref":"Jido.AI.Agent.html#run/2"},{"type":"function","title":"Execution Flow - Jido.AI.Agent.run/2","doc":"1. Pre-execution callback (`on_before_run/1`)\n2. Runner execution of pending instructions\n3. Post-execution callback (`on_after_run/3`)\n4. Return agent with updated state and result","ref":"Jido.AI.Agent.html#run/2-execution-flow"},{"type":"function","title":"Parameters - Jido.AI.Agent.run/2","doc":"* `agent` - The agent struct containing pending instructions\n* `opts` - Keyword list of options:\n  * `:runner` - Module implementing the Runner behavior (default: agent's configured runner)","ref":"Jido.AI.Agent.html#run/2-parameters"},{"type":"function","title":"State Management - Jido.AI.Agent.run/2","doc":"State modifications are handled through StateModification directives:\n* `:set` - Set a value at a path: `%StateModification{op: :set, path: [:config, :mode], value: :active}`\n* `:update` - Update with function: `%StateModification{op: :update, path: [:counter], value: &(&1 + 1)}`\n* `:delete` - Remove value at path: `%StateModification{op: :delete, path: [:temp_data]}`\n* `:reset` - Set path to nil: `%StateModification{op: :reset, path: [:cache]}`","ref":"Jido.AI.Agent.html#run/2-state-management"},{"type":"function","title":"Directives - Jido.AI.Agent.run/2","doc":"* Directives are applied after runner execution\n* Directives can modify agent state and result, such as adding or removing actions or enqueuing new instructions\n* Review `Jido.Agent.Directive` for more information","ref":"Jido.AI.Agent.html#run/2-directives"},{"type":"function","title":"Returns - Jido.AI.Agent.run/2","doc":"* `{:ok, updated_agent, directives}` - Execution completed successfully\n* `{:error, %Error{}}` - Execution failed with specific error type:\n  * `:execution_error` - Runner execution failed\n  * Any other error wrapped as execution_error","ref":"Jido.AI.Agent.html#run/2-returns"},{"type":"function","title":"Examples - Jido.AI.Agent.run/2","doc":"# Set up your agent, register and plan some actions to fill the instruction queue\n    agent = MyAgent.new()\n    {:ok, agent} = MyAgent.plan(agent, [BasicAction, {NoSchema, %{value: 2}}])\n\n    # Basic execution with state modification directives\n    {:ok, agent, directives} = MyAgent.run(agent)\n\n    # Using custom runner\n    {:ok, agent, directives} = MyAgent.run(agent, runner: CustomRunner)\n\n    # Error handling\n    case MyAgent.run(agent) do\n      {:ok, agent, directives} ->\n        # Success - state updated through directives\n        agent.state\n\n      {:error, %Error{type: :validation_error}} ->\n        # Handle validation failure\n\n      {:error, %Error{type: :execution_error}} ->\n        # Handle execution failure\n    end","ref":"Jido.AI.Agent.html#run/2-examples"},{"type":"function","title":"Callbacks - Jido.AI.Agent.run/2","doc":"* `on_before_run/1` - Pre-execution preparation\n* `on_after_run/3` - Post-execution processing\n\nSee `Jido.Runner` for implementing custom runners and `plan/2` for queueing actions.","ref":"Jido.AI.Agent.html#run/2-callbacks"},{"type":"function","title":"Jido.AI.Agent.runner/0","doc":"","ref":"Jido.AI.Agent.html#runner/0"},{"type":"function","title":"Jido.AI.Agent.schema/0","doc":"","ref":"Jido.AI.Agent.html#schema/0"},{"type":"function","title":"Jido.AI.Agent.set/3","doc":"Updates the agent's state by deep merging the provided attributes. The update process:\n\n1. Deep merges new attributes with existing state\n2. Validates the merged state against schema\n3. Sets dirty_state? flag for tracking changes\n4. Triggers validation callbacks","ref":"Jido.AI.Agent.html#set/3"},{"type":"function","title":"Parameters - Jido.AI.Agent.set/3","doc":"* `agent` - The agent struct to update\n* `attrs` - Map or keyword list of attributes to merge into state\n* `opts` - Optional keyword list of options:\n  * `strict_validation` - Boolean, whether to perform strict validation (default: false)","ref":"Jido.AI.Agent.html#set/3-parameters"},{"type":"function","title":"Returns - Jido.AI.Agent.set/3","doc":"* `{:ok, updated_agent}` - Agent with merged state and dirty_state? = true\n* `{:error, reason}` - If validation fails or callbacks return error","ref":"Jido.AI.Agent.html#set/3-returns"},{"type":"function","title":"State Management - Jido.AI.Agent.set/3","doc":"* Empty updates return success without changes\n* Updates trigger `on_before_validate_state` and `on_after_validate_state` callbacks\n* Unknown fields are preserved during deep merge\n* Nested updates are supported via deep merging","ref":"Jido.AI.Agent.html#set/3-state-management"},{"type":"function","title":"Field Validation - Jido.AI.Agent.set/3","doc":"Only fields defined in the schema are validated. Unknown fields are preserved during deep merge.","ref":"Jido.AI.Agent.html#set/3-field-validation"},{"type":"function","title":"Examples - Jido.AI.Agent.set/3","doc":"# Simple update\n    {:ok, agent} = MyAgent.set(agent, status: :running)\n\n    # Deep merge update\n    {:ok, agent} = MyAgent.set(agent, %{\n      config: %{retries: 3},\n      metadata: %{started_at: DateTime.utc_now()}\n    })\n\n    # Validation failure\n    {:error, \"Invalid status value\"} = MyAgent.set(agent, status: :invalid)\n\nSee `validate/1` for validation details and `Jido.Agent` callbacks for lifecycle hooks.","ref":"Jido.AI.Agent.html#set/3-examples"},{"type":"function","title":"Jido.AI.Agent.shutdown/2","doc":"","ref":"Jido.AI.Agent.html#shutdown/2"},{"type":"type","title":"Jido.AI.Agent.t/0","doc":"","ref":"Jido.AI.Agent.html#t:t/0"},{"type":"function","title":"Jido.AI.Agent.tags/0","doc":"","ref":"Jido.AI.Agent.html#tags/0"},{"type":"function","title":"Jido.AI.Agent.to_json/0","doc":"","ref":"Jido.AI.Agent.html#to_json/0"},{"type":"function","title":"Jido.AI.Agent.tool_response/2","doc":"","ref":"Jido.AI.Agent.html#tool_response/2"},{"type":"function","title":"Jido.AI.Agent.transform_result/3","doc":"","ref":"Jido.AI.Agent.html#transform_result/3"},{"type":"function","title":"Jido.AI.Agent.validate/2","doc":"Validates the agent's state through a three-phase process:\n\n1. Executes pre-validation callback (`on_before_validate_state/1`)\n2. Validates known fields against schema using NimbleOptions\n3. Executes post-validation callback (`on_after_validate_state/1`)","ref":"Jido.AI.Agent.html#validate/2"},{"type":"function","title":"Validation Process - Jido.AI.Agent.validate/2","doc":"* Only schema-defined fields are validated\n* Unknown fields are preserved unchanged\n* NimbleOptions performs type and constraint checking","ref":"Jido.AI.Agent.html#validate/2-validation-process"},{"type":"function","title":"Parameters - Jido.AI.Agent.validate/2","doc":"* `agent` - The agent struct to validate\n* `opts` - Optional keyword list of options:\n  * `strict_validation` - Boolean, whether to perform strict validation (default: false)","ref":"Jido.AI.Agent.html#validate/2-parameters"},{"type":"function","title":"Returns - Jido.AI.Agent.validate/2","doc":"* `{:ok, validated_agent}` - Agent with validated state\n* `{:error, reason}` - Validation failed with reason","ref":"Jido.AI.Agent.html#validate/2-returns"},{"type":"function","title":"Examples - Jido.AI.Agent.validate/2","doc":"# Successful validation with schema\n    defmodule MyAgent do\n      use Jido.Agent,\n        name: \"my_agent\",\n        schema: [\n          status: [type: :atom, values: [:pending, :running]],\n          retries: [type: :integer, minimum: 0]\n        ]\n\n      # Optional validation hooks\n      def on_before_validate_state(agent) do\n        # Pre-validation logic\n        {:ok, agent}\n      end\n    end\n\n    {:ok, agent} = MyAgent.validate(agent)\n\n    # Failed validation\n    {:error, \"Invalid status value\"} = MyAgent.validate(%{\n      agent | state: %{status: :invalid}\n    })\n\n    # Unknown fields preserved\n    {:ok, agent} = MyAgent.validate(%{\n      agent | state: %{status: :pending, custom_field: \"preserved\"}\n    })","ref":"Jido.AI.Agent.html#validate/2-examples"},{"type":"function","title":"Validation Flow - Jido.AI.Agent.validate/2","doc":"1. `on_before_validate_state` - Preprocess state\n2. Schema validation via NimbleOptions\n3. `on_after_validate_state` - Postprocess validated state\n\nSee `NimbleOptions` documentation for supported validation rules.","ref":"Jido.AI.Agent.html#validate/2-validation-flow"},{"type":"function","title":"Jido.AI.Agent.vsn/0","doc":"","ref":"Jido.AI.Agent.html#vsn/0"},{"type":"module","title":"Jido.AI.Application","doc":"The Jido.AI Application module.\n\nManages the application lifecycle and starts the supervision tree.","ref":"Jido.AI.Application.html"},{"type":"module","title":"Jido.AI.Keyring","doc":"A GenServer that manages environment variables and application configuration.\n\nThis module serves as the source of truth for configuration values, with a hierarchical loading priority:\n\n1. Session values (per-process overrides)\n2. Environment variables (via Dotenvy)\n3. Application environment (under :jido_ai, :keyring)\n4. Default values\n\nThe keyring supports both global environment values and process-specific session values,\nallowing for flexible configuration management in different contexts.","ref":"Jido.AI.Keyring.html"},{"type":"module","title":"Usage - Jido.AI.Keyring","doc":"# Get a value (checks session then environment)\n    value = Keyring.get(:my_key, \"default\")\n\n    # Set a session-specific override\n    Keyring.set_session_value(:my_key, \"override\")\n\n    # Clear session values\n    Keyring.clear_session_value(:my_key)\n    Keyring.clear_all_session_values()","ref":"Jido.AI.Keyring.html#module-usage"},{"type":"function","title":"Jido.AI.Keyring.child_spec/1","doc":"Returns the child specification for starting the keyring under a supervisor.","ref":"Jido.AI.Keyring.html#child_spec/1"},{"type":"function","title":"Jido.AI.Keyring.clear_all_session_values/2","doc":"Clears all session-specific values for the specified process.","ref":"Jido.AI.Keyring.html#clear_all_session_values/2"},{"type":"function","title":"Parameters - Jido.AI.Keyring.clear_all_session_values/2","doc":"* `server` - The server to query (default: Elixir.Jido.AI.Keyring)\n  * `pid` - The process ID to clear all values for (default: current process)\n\nReturns `:ok`.","ref":"Jido.AI.Keyring.html#clear_all_session_values/2-parameters"},{"type":"function","title":"Jido.AI.Keyring.clear_session_value/3","doc":"Clears a session-specific value for the specified process.","ref":"Jido.AI.Keyring.html#clear_session_value/3"},{"type":"function","title":"Parameters - Jido.AI.Keyring.clear_session_value/3","doc":"* `server` - The server to query (default: Elixir.Jido.AI.Keyring)\n  * `key` - The key to clear (as an atom)\n  * `pid` - The process ID to clear the value for (default: current process)\n\nReturns `:ok`.","ref":"Jido.AI.Keyring.html#clear_session_value/3-parameters"},{"type":"function","title":"Jido.AI.Keyring.get/4","doc":"Gets a value from the keyring, checking session values first, then environment values.","ref":"Jido.AI.Keyring.html#get/4"},{"type":"function","title":"Parameters - Jido.AI.Keyring.get/4","doc":"* `server` - The server to query (default: Elixir.Jido.AI.Keyring)\n  * `key` - The key to look up (as an atom)\n  * `default` - The default value if key is not found\n  * `pid` - The process ID to check session values for (default: current process)\n\nReturns the value if found, otherwise returns the default value.","ref":"Jido.AI.Keyring.html#get/4-parameters"},{"type":"function","title":"Jido.AI.Keyring.get_env_value/3","doc":"Gets a value from the environment-level storage, also checking for LiveBook prefixed keys as fallback.","ref":"Jido.AI.Keyring.html#get_env_value/3"},{"type":"function","title":"Parameters - Jido.AI.Keyring.get_env_value/3","doc":"* `server` - The server to query (default: Elixir.Jido.AI.Keyring)\n  * `key` - The key to look up (as an atom)\n  * `default` - The default value if key is not found\n\nReturns the environment value if found, otherwise returns the default value.","ref":"Jido.AI.Keyring.html#get_env_value/3-parameters"},{"type":"function","title":"Jido.AI.Keyring.get_env_var/2","doc":"Gets an environment variable with a default value.","ref":"Jido.AI.Keyring.html#get_env_var/2"},{"type":"function","title":"Parameters - Jido.AI.Keyring.get_env_var/2","doc":"* `key` - The environment variable name\n  * `default` - The default value if not found\n\nReturns the environment variable value if found, otherwise returns the default value.","ref":"Jido.AI.Keyring.html#get_env_var/2-parameters"},{"type":"function","title":"Jido.AI.Keyring.get_session_value/3","doc":"Gets a session-specific value for the specified process.","ref":"Jido.AI.Keyring.html#get_session_value/3"},{"type":"function","title":"Parameters - Jido.AI.Keyring.get_session_value/3","doc":"* `server` - The server to query (default: Elixir.Jido.AI.Keyring)\n  * `key` - The key to look up (as an atom)\n  * `pid` - The process ID to get the value for (default: current process)\n\nReturns the session value if found, otherwise returns `nil`.","ref":"Jido.AI.Keyring.html#get_session_value/3-parameters"},{"type":"function","title":"Jido.AI.Keyring.has_value?/1","doc":"Checks if a value exists and is non-empty.\n\nReturns `true` if the value is a non-empty string, `false` otherwise.","ref":"Jido.AI.Keyring.html#has_value?/1"},{"type":"function","title":"Jido.AI.Keyring.list/1","doc":"Lists all available keys in the keyring.\n\nReturns a list of atoms representing the available environment-level keys.\nDoes not include session-specific overrides.","ref":"Jido.AI.Keyring.html#list/1"},{"type":"function","title":"Jido.AI.Keyring.set_session_value/4","doc":"Sets a session-specific value that will override the environment value\nfor the specified process.","ref":"Jido.AI.Keyring.html#set_session_value/4"},{"type":"function","title":"Parameters - Jido.AI.Keyring.set_session_value/4","doc":"* `server` - The server to query (default: Elixir.Jido.AI.Keyring)\n  * `key` - The key to set (as an atom)\n  * `value` - The value to store\n  * `pid` - The process ID to associate with this value (default: current process)\n\nReturns `:ok`.","ref":"Jido.AI.Keyring.html#set_session_value/4-parameters"},{"type":"function","title":"Jido.AI.Keyring.start_link/1","doc":"Starts the keyring process.","ref":"Jido.AI.Keyring.html#start_link/1"},{"type":"function","title":"Options - Jido.AI.Keyring.start_link/1","doc":"* `:name` - The name to register the process under (default: Elixir.Jido.AI.Keyring)\n  * `:registry` - The name for the ETS registry table (default: jido_ai_keyring_sessions)","ref":"Jido.AI.Keyring.html#start_link/1-options"},{"type":"module","title":"Jido.AI.Model","doc":"","ref":"Jido.AI.Model.html"},{"type":"function","title":"Jido.AI.Model.from/1","doc":"Creates a model struct from various input formats.\n\nThis is the main entry point for creating a model struct. It handles:\n- An existing %Jido.AI.Model{} struct (pass-through)\n- A tuple of {provider, opts} where provider is an atom and opts is a keyword list\n- A category tuple of {:category, category, class}","ref":"Jido.AI.Model.html#from/1"},{"type":"function","title":"Parameters - Jido.AI.Model.from/1","doc":"- input: The input to create a model from","ref":"Jido.AI.Model.html#from/1-parameters"},{"type":"function","title":"Returns - Jido.AI.Model.from/1","doc":"* `{:ok, %Jido.AI.Model{}}` - on success\n  * `{:error, reason}` - on failure","ref":"Jido.AI.Model.html#from/1-returns"},{"type":"function","title":"Examples - Jido.AI.Model.from/1","doc":"iex> Jido.AI.Model.from({:anthropic, [model: \"claude-3-5-haiku\"]})\n    {:ok, %Jido.AI.Model{provider: :anthropic, model: \"claude-3-5-haiku\", ...}}\n\n    iex> Jido.AI.Model.from(%Jido.AI.Model{provider: :openai, model: \"gpt-4\"})\n    {:ok, %Jido.AI.Model{provider: :openai, model: \"gpt-4\", ...}}","ref":"Jido.AI.Model.html#from/1-examples"},{"type":"function","title":"Jido.AI.Model.new!/2","doc":"Creates a new model configuration with the given provider and options.","ref":"Jido.AI.Model.html#new!/2"},{"type":"function","title":"Parameters - Jido.AI.Model.new!/2","doc":"* `provider_or_tuple` - Either an atom representing the provider (e.g., `:openrouter`)\n  or a tuple with provider and options.\n* `opts` - Keyword list of options for the model (optional when using tuple format).","ref":"Jido.AI.Model.html#new!/2-parameters"},{"type":"function","title":"Examples - Jido.AI.Model.new!/2","doc":"# Using provider atom and options separately\n    iex> Jido.AI.Model.new!(:openrouter, model: \"anthropic/claude-3.5-haiku\")\n\n    # Using tuple shorthand\n    iex> Jido.AI.Model.new!({:anthropic, capabilities: [:chat], tier: :small})","ref":"Jido.AI.Model.html#new!/2-examples"},{"type":"function","title":"Returns - Jido.AI.Model.new!/2","doc":"A model configuration that can be used with Jido.AI.Agent.\n\n@deprecated Use Jido.AI.Model.from/1 instead","ref":"Jido.AI.Model.html#new!/2-returns"},{"type":"type","title":"Jido.AI.Model.t/0","doc":"","ref":"Jido.AI.Model.html#t:t/0"},{"type":"function","title":"Jido.AI.Model.validate/1","doc":"Validates a model configuration.","ref":"Jido.AI.Model.html#validate/1"},{"type":"function","title":"Parameters - Jido.AI.Model.validate/1","doc":"* `model_config` - The model configuration to validate.","ref":"Jido.AI.Model.html#validate/1-parameters"},{"type":"function","title":"Returns - Jido.AI.Model.validate/1","doc":"* `{:ok, model_config}` - The model configuration is valid.\n* `{:error, reason}` - The model configuration is invalid.\n\n@deprecated Use Jido.AI.Model.from/1 instead","ref":"Jido.AI.Model.html#validate/1-returns"},{"type":"function","title":"Jido.AI.Model.validate_model_opts/1","doc":"Validates model options for use in an action.","ref":"Jido.AI.Model.html#validate_model_opts/1"},{"type":"function","title":"Parameters - Jido.AI.Model.validate_model_opts/1","doc":"- opts: The options to validate","ref":"Jido.AI.Model.html#validate_model_opts/1-parameters"},{"type":"function","title":"Returns - Jido.AI.Model.validate_model_opts/1","doc":"* `{:ok, %Jido.AI.Model{}}` - on success\n  * `{:error, reason}` - on failure","ref":"Jido.AI.Model.html#validate_model_opts/1-returns"},{"type":"module","title":"Jido.AI.Model.Architecture","doc":"","ref":"Jido.AI.Model.Architecture.html"},{"type":"type","title":"Jido.AI.Model.Architecture.t/0","doc":"","ref":"Jido.AI.Model.Architecture.html#t:t/0"},{"type":"module","title":"Jido.AI.Model.Endpoint","doc":"","ref":"Jido.AI.Model.Endpoint.html"},{"type":"type","title":"Jido.AI.Model.Endpoint.t/0","doc":"","ref":"Jido.AI.Model.Endpoint.html#t:t/0"},{"type":"module","title":"Jido.AI.Model.Pricing","doc":"","ref":"Jido.AI.Model.Pricing.html"},{"type":"type","title":"Jido.AI.Model.Pricing.t/0","doc":"","ref":"Jido.AI.Model.Pricing.html#t:t/0"},{"type":"behaviour","title":"Jido.AI.Model.Provider.Adapter","doc":"Defines the behavior that any provider adapter must implement.\n\nThis allows for extending the system with new providers without modifying\nthe core Provider module.","ref":"Jido.AI.Model.Provider.Adapter.html"},{"type":"callback","title":"Jido.AI.Model.Provider.Adapter.base_url/0","doc":"Returns the base URL for the provider's API.","ref":"Jido.AI.Model.Provider.Adapter.html#c:base_url/0"},{"type":"callback","title":"Parameters - Jido.AI.Model.Provider.Adapter.base_url/0","doc":"- provider: The provider struct","ref":"Jido.AI.Model.Provider.Adapter.html#c:base_url/0-parameters"},{"type":"callback","title":"Returns - Jido.AI.Model.Provider.Adapter.base_url/0","doc":"- The base URL as a string","ref":"Jido.AI.Model.Provider.Adapter.html#c:base_url/0-returns"},{"type":"callback","title":"Jido.AI.Model.Provider.Adapter.build/1","doc":"Builds a %Jido.AI.Model{} struct from the provided options.\n\nThis is the main entry point for creating a model struct from provider-specific options.\nEach provider implements this to handle its own validation, defaults, and API key retrieval.","ref":"Jido.AI.Model.Provider.Adapter.html#c:build/1"},{"type":"callback","title":"Parameters - Jido.AI.Model.Provider.Adapter.build/1","doc":"- opts: Keyword list of options for building the model","ref":"Jido.AI.Model.Provider.Adapter.html#c:build/1-parameters"},{"type":"callback","title":"Returns - Jido.AI.Model.Provider.Adapter.build/1","doc":"* `{:ok, %Jido.AI.Model{}}` - on success\n  * `{:error, reason}` - on failure","ref":"Jido.AI.Model.Provider.Adapter.html#c:build/1-returns"},{"type":"callback","title":"Jido.AI.Model.Provider.Adapter.definition/0","doc":"Returns the provider definition.","ref":"Jido.AI.Model.Provider.Adapter.html#c:definition/0"},{"type":"callback","title":"Returns - Jido.AI.Model.Provider.Adapter.definition/0","doc":"- A provider struct","ref":"Jido.AI.Model.Provider.Adapter.html#c:definition/0-returns"},{"type":"callback","title":"Jido.AI.Model.Provider.Adapter.list_models/1","doc":"Fetches models from the provider's API.","ref":"Jido.AI.Model.Provider.Adapter.html#c:list_models/1"},{"type":"callback","title":"Parameters - Jido.AI.Model.Provider.Adapter.list_models/1","doc":"- opts: Options for the fetch operation (like API key, etc.)","ref":"Jido.AI.Model.Provider.Adapter.html#c:list_models/1-parameters"},{"type":"callback","title":"Returns - Jido.AI.Model.Provider.Adapter.list_models/1","doc":"* `{:ok, models}` - on success\n  * `{:error, reason}` - on failure","ref":"Jido.AI.Model.Provider.Adapter.html#c:list_models/1-returns"},{"type":"callback","title":"Jido.AI.Model.Provider.Adapter.model/2","doc":"Fetches a specific model by ID from the provider's API.","ref":"Jido.AI.Model.Provider.Adapter.html#c:model/2"},{"type":"callback","title":"Parameters - Jido.AI.Model.Provider.Adapter.model/2","doc":"- model: The ID of the model to fetch\n  - opts: Options for the fetch operation (like API key, etc.)","ref":"Jido.AI.Model.Provider.Adapter.html#c:model/2-parameters"},{"type":"callback","title":"Returns - Jido.AI.Model.Provider.Adapter.model/2","doc":"* `{:ok, model}` - on success\n  * `{:error, reason}` - on failure","ref":"Jido.AI.Model.Provider.Adapter.html#c:model/2-returns"},{"type":"callback","title":"Jido.AI.Model.Provider.Adapter.normalize/2","doc":"Normalizes a model ID to ensure it's in the correct format for the provider.","ref":"Jido.AI.Model.Provider.Adapter.html#c:normalize/2"},{"type":"callback","title":"Parameters - Jido.AI.Model.Provider.Adapter.normalize/2","doc":"- id: The ID to normalize\n  - opts: Options for normalization","ref":"Jido.AI.Model.Provider.Adapter.html#c:normalize/2-parameters"},{"type":"callback","title":"Returns - Jido.AI.Model.Provider.Adapter.normalize/2","doc":"* `{:ok, normalized_id}` - on success\n  * `{:error, reason}` - on failure","ref":"Jido.AI.Model.Provider.Adapter.html#c:normalize/2-returns"},{"type":"callback","title":"Jido.AI.Model.Provider.Adapter.request_headers/1","doc":"Returns the headers required for API requests to the provider.","ref":"Jido.AI.Model.Provider.Adapter.html#c:request_headers/1"},{"type":"callback","title":"Parameters - Jido.AI.Model.Provider.Adapter.request_headers/1","doc":"- provider: The provider struct\n  - opts: Options for the request (like API key, etc.)","ref":"Jido.AI.Model.Provider.Adapter.html#c:request_headers/1-parameters"},{"type":"callback","title":"Returns - Jido.AI.Model.Provider.Adapter.request_headers/1","doc":"- A map of headers","ref":"Jido.AI.Model.Provider.Adapter.html#c:request_headers/1-returns"},{"type":"callback","title":"Jido.AI.Model.Provider.Adapter.transform_model_to_clientmodel/2","doc":"Transforms a generic `Jido.AI.Model` struct into a provider-specific client model.\n\nFor example, `transform_model_to_clientmodel(:langchain, model)` might produce a\nconfig map specialized for LangChain usage.","ref":"Jido.AI.Model.Provider.Adapter.html#c:transform_model_to_clientmodel/2"},{"type":"callback","title":"Jido.AI.Model.Provider.Adapter.validate_model_opts/1","doc":"Validates the options for creating a Jido.AI.Model specific to this provider.\n\nProviders can parse and verify that `opts` is valid. Returns:\n  - `{:ok, %Jido.AI.Model{}}` if validation succeeds\n  - `{:error, reason}` otherwise.","ref":"Jido.AI.Model.Provider.Adapter.html#c:validate_model_opts/1"},{"type":"module","title":"Jido.AI.Prompt","doc":"A module that provides struct-based prompt generation.\n\nThe struct-based approach provides full visibility into the prompt's content\nwhen inspecting the agent state, making it easier to debug and understand\nthe conversation flow.","ref":"Jido.AI.Prompt.html"},{"type":"module","title":"Examples - Jido.AI.Prompt","doc":"# Create a simple prompt with a single message\n    prompt = Jido.AI.Prompt.new(%{\n      messages: [\n        %{role: :user, content: \"Hello\"}\n      ]\n    })\n\n    # Create a prompt with EEx templates\n    prompt = Jido.AI.Prompt.new(%{\n      messages: [\n        %{role: :system, content: \"You are a <%= @assistant_type %>\", engine: :eex},\n        %{role: :user, content: \"Hello <%= @name %>\", engine: :eex}\n      ],\n      params: %{\n        assistant_type: \"helpful assistant\",\n        name: \"Alice\"\n      }\n    })\n\n    # Create a prompt with Liquid templates\n    prompt = Jido.AI.Prompt.new(%{\n      messages: [\n        %{role: :system, content: \"You are a {{ assistant_type }}\", engine: :liquid},\n        %{role: :user, content: \"Hello {{ name }}\", engine: :liquid}\n      ],\n      params: %{\n        assistant_type: \"helpful assistant\",\n        name: \"Alice\"\n      }\n    })\n\n    # Render the prompt to get the final messages\n    messages = Jido.AI.Prompt.render(prompt)\n    # => [\n    #      %{role: :system, content: \"You are a helpful assistant\"},\n    #      %{role: :user, content: \"Hello Alice\"}\n    #    ]","ref":"Jido.AI.Prompt.html#module-examples"},{"type":"function","title":"Jido.AI.Prompt.add_message/4","doc":"Adds a new message to the prompt.\n\nEnforces the rule that system messages can only appear first in the message list.\nRaises ArgumentError if attempting to add a system message in any other position.","ref":"Jido.AI.Prompt.html#add_message/4"},{"type":"function","title":"Examples - Jido.AI.Prompt.add_message/4","doc":"iex> alias Jido.AI.Prompt\n    iex> prompt = Prompt.new(%{\n    ...>   messages: [\n    ...>     %{role: :user, content: \"Hello\"}\n    ...>   ]\n    ...> })\n    iex> updated = Prompt.add_message(prompt, :assistant, \"Hi there!\")\n    iex> length(updated.messages)\n    2\n    iex> List.last(updated.messages).content\n    \"Hi there!\"","ref":"Jido.AI.Prompt.html#add_message/4-examples"},{"type":"function","title":"Jido.AI.Prompt.compare_versions/3","doc":"Compares two versions of a prompt and returns the differences.","ref":"Jido.AI.Prompt.html#compare_versions/3"},{"type":"function","title":"Examples - Jido.AI.Prompt.compare_versions/3","doc":"iex> alias Jido.AI.Prompt\n    iex> prompt = Prompt.new(:user, \"Hello\")\n    iex> v2 = Prompt.new_version(prompt, fn p -> Prompt.add_message(p, :assistant, \"Hi there!\") end)\n    iex> {:ok, diff} = Prompt.compare_versions(v2, 2, 1)\n    iex> diff.added_messages\n    [%{role: :assistant, content: \"Hi there!\"}]","ref":"Jido.AI.Prompt.html#compare_versions/3-examples"},{"type":"function","title":"Jido.AI.Prompt.get_version/2","doc":"Gets a specific version of the prompt.\n\nReturns the current prompt if version matches the current version,\nor reconstructs a historical version from the history.","ref":"Jido.AI.Prompt.html#get_version/2"},{"type":"function","title":"Examples - Jido.AI.Prompt.get_version/2","doc":"iex> alias Jido.AI.Prompt\n    iex> prompt = Prompt.new(:user, \"Hello\")\n    iex> updated = Prompt.new_version(prompt, fn p -> Prompt.add_message(p, :assistant, \"Hi there!\") end)\n    iex> {:ok, original} = Prompt.get_version(updated, 1)\n    iex> length(original.messages)\n    1\n    iex> hd(original.messages).content\n    \"Hello\"","ref":"Jido.AI.Prompt.html#get_version/2-examples"},{"type":"function","title":"Jido.AI.Prompt.list_versions/1","doc":"Lists all available versions of the prompt.\n\nReturns a list of version numbers, with the most recent first.","ref":"Jido.AI.Prompt.html#list_versions/1"},{"type":"function","title":"Examples - Jido.AI.Prompt.list_versions/1","doc":"iex> alias Jido.AI.Prompt\n    iex> prompt = Prompt.new(:user, \"Hello\")\n    iex> v2 = Prompt.new_version(prompt, fn p -> Prompt.add_message(p, :assistant, \"Hi there!\") end)\n    iex> v3 = Prompt.new_version(v2, fn p -> Prompt.add_message(p, :user, \"How are you?\") end)\n    iex> Prompt.list_versions(v3)\n    [3, 2, 1]","ref":"Jido.AI.Prompt.html#list_versions/1-examples"},{"type":"function","title":"Jido.AI.Prompt.new/1","doc":"Creates a new prompt struct from the given attributes.","ref":"Jido.AI.Prompt.html#new/1"},{"type":"function","title":"Rules - Jido.AI.Prompt.new/1","doc":"- Only one system message is allowed\n- If present, the system message must be the first message\n- Messages are rendered without the engine field","ref":"Jido.AI.Prompt.html#new/1-rules"},{"type":"function","title":"Examples - Jido.AI.Prompt.new/1","doc":"iex> alias Jido.AI.Prompt\n    iex> prompt = Prompt.new(%{\n    ...>   messages: [\n    ...>     %{role: :user, content: \"Hello\"}\n    ...>   ]\n    ...> })\n    iex> prompt.messages |> length()\n    1\n    iex> hd(prompt.messages).role\n    :user\n    iex> hd(prompt.messages).content\n    \"Hello\"","ref":"Jido.AI.Prompt.html#new/1-examples"},{"type":"function","title":"Jido.AI.Prompt.new/3","doc":"Creates a new prompt with a single message.\n\nThis is a convenience function for creating a prompt with a single message.","ref":"Jido.AI.Prompt.html#new/3"},{"type":"function","title":"Examples - Jido.AI.Prompt.new/3","doc":"iex> alias Jido.AI.Prompt\n    iex> prompt = Prompt.new(:user, \"Hello\")\n    iex> prompt.messages |> length()\n    1\n    iex> hd(prompt.messages).role\n    :user\n    iex> hd(prompt.messages).content\n    \"Hello\"","ref":"Jido.AI.Prompt.html#new/3-examples"},{"type":"function","title":"Jido.AI.Prompt.new_version/2","doc":"Creates a new version of the prompt.\n\nThis function creates a new version of the prompt by:\n1. Storing the current state in the history\n2. Incrementing the version number\n3. Applying the changes to the prompt","ref":"Jido.AI.Prompt.html#new_version/2"},{"type":"function","title":"Examples - Jido.AI.Prompt.new_version/2","doc":"iex> alias Jido.AI.Prompt\n    iex> prompt = Prompt.new(:user, \"Hello\")\n    iex> updated = Prompt.new_version(prompt, fn p -> Prompt.add_message(p, :assistant, \"Hi there!\") end)\n    iex> updated.version\n    2\n    iex> length(updated.history)\n    1\n    iex> length(updated.messages)\n    2","ref":"Jido.AI.Prompt.html#new_version/2-examples"},{"type":"function","title":"Jido.AI.Prompt.render/2","doc":"Renders the prompt into a list of messages with interpolated content.\n\nThe rendered messages will only include the role and content fields,\nexcluding the engine field to ensure compatibility with API requests.","ref":"Jido.AI.Prompt.html#render/2"},{"type":"function","title":"Examples - Jido.AI.Prompt.render/2","doc":"iex> alias Jido.AI.Prompt\n    iex> prompt = Prompt.new(%{\n    ...>   messages: [\n    ...>     %{role: :user, content: \"Hello <%= @name %>\", engine: :eex}\n    ...>   ],\n    ...>   params: %{name: \"Alice\"}\n    ...> })\n    iex> Prompt.render(prompt)\n    [%{role: :user, content: \"Hello Alice\"}]","ref":"Jido.AI.Prompt.html#render/2-examples"},{"type":"type","title":"Jido.AI.Prompt.t/0","doc":"A complete prompt with messages and parameters","ref":"Jido.AI.Prompt.html#t:t/0"},{"type":"function","title":"Jido.AI.Prompt.to_text/2","doc":"Converts the prompt to a single text string.\n\nThis is useful for debugging or when the LLM API expects a single text prompt.","ref":"Jido.AI.Prompt.html#to_text/2"},{"type":"function","title":"Examples - Jido.AI.Prompt.to_text/2","doc":"iex> alias Jido.AI.Prompt\n    iex> prompt = Prompt.new(%{\n    ...>   messages: [\n    ...>     %{role: :system, content: \"You are an assistant\"},\n    ...>     %{role: :user, content: \"Hello\"}\n    ...>   ]\n    ...> })\n    iex> Prompt.to_text(prompt)\n    \"[system] You are an assistant\\n[user] Hello\"","ref":"Jido.AI.Prompt.html#to_text/2-examples"},{"type":"function","title":"Jido.AI.Prompt.validate_prompt_opts/1","doc":"Validates and converts the prompt option.\n\nAccepts either:\n- A string, which is converted to a system message in a Prompt struct\n- An existing Prompt struct, which is returned as-is","ref":"Jido.AI.Prompt.html#validate_prompt_opts/1"},{"type":"function","title":"Examples - Jido.AI.Prompt.validate_prompt_opts/1","doc":"iex> Jido.AI.Prompt.validate_prompt_opts(\"You are a helpful assistant\")\n    {:ok, %Jido.AI.Prompt{messages: [%Jido.AI.Prompt.MessageItem{role: :system, content: \"You are a helpful assistant\", engine: :none}], id: nil, version: 1, history: [], params: %{}, metadata: %{}}}\n\n    iex> prompt = Jido.AI.Prompt.new(:system, \"Custom prompt\")\n    iex> Jido.AI.Prompt.validate_prompt_opts(prompt)\n    {:ok, prompt}","ref":"Jido.AI.Prompt.html#validate_prompt_opts/1-examples"},{"type":"module","title":"Jido.AI.Prompt.MessageItem","doc":"Represents a single message item within a prompt.\n\nEach message has a role (system, user, assistant, function) and content.\nThe content can be either a raw string, an EEx template to be rendered,\na Liquid template to be rendered, or a list of content parts for rich media support.","ref":"Jido.AI.Prompt.MessageItem.html"},{"type":"function","title":"Jido.AI.Prompt.MessageItem.file_part/1","doc":"Creates a new file content part.","ref":"Jido.AI.Prompt.MessageItem.html#file_part/1"},{"type":"function","title":"Examples - Jido.AI.Prompt.MessageItem.file_part/1","doc":"iex> Jido.AI.Prompt.MessageItem.file_part(\"https://example.com/document.pdf\")\n    %{type: :file_url, file_url: \"https://example.com/document.pdf\"}","ref":"Jido.AI.Prompt.MessageItem.html#file_part/1-examples"},{"type":"function","title":"Jido.AI.Prompt.MessageItem.from_map/1","doc":"Creates a new MessageItem struct from a map with string keys.\n\nThis is useful when creating message items from JSON or other external sources.","ref":"Jido.AI.Prompt.MessageItem.html#from_map/1"},{"type":"function","title":"Examples - Jido.AI.Prompt.MessageItem.from_map/1","doc":"iex> Jido.AI.Prompt.MessageItem.from_map(%{\"role\" => \"user\", \"content\" => \"Hello\"})\n    %Jido.AI.Prompt.MessageItem{role: :user, content: \"Hello\", engine: :none}","ref":"Jido.AI.Prompt.MessageItem.html#from_map/1-examples"},{"type":"function","title":"Jido.AI.Prompt.MessageItem.image_part/1","doc":"Creates a new image content part.","ref":"Jido.AI.Prompt.MessageItem.html#image_part/1"},{"type":"function","title":"Examples - Jido.AI.Prompt.MessageItem.image_part/1","doc":"iex> Jido.AI.Prompt.MessageItem.image_part(\"https://example.com/image.jpg\")\n    %{type: :image_url, image_url: \"https://example.com/image.jpg\"}","ref":"Jido.AI.Prompt.MessageItem.html#image_part/1-examples"},{"type":"function","title":"Jido.AI.Prompt.MessageItem.new/1","doc":"Creates a new MessageItem struct.","ref":"Jido.AI.Prompt.MessageItem.html#new/1"},{"type":"function","title":"Examples - Jido.AI.Prompt.MessageItem.new/1","doc":"iex> Jido.AI.Prompt.MessageItem.new(%{role: :user, content: \"Hello\"})\n    %Jido.AI.Prompt.MessageItem{role: :user, content: \"Hello\", engine: :none}\n\n    iex> Jido.AI.Prompt.MessageItem.new(%{role: :system, content: \"You are <%= @assistant_type %>\", engine: :eex})\n    %Jido.AI.Prompt.MessageItem{role: :system, content: \"You are <%= @assistant_type %>\", engine: :eex}\n\n    iex> Jido.AI.Prompt.MessageItem.new(%{role: :user, content: \"Hello {{ name }}\", engine: :liquid})\n    %Jido.AI.Prompt.MessageItem{role: :user, content: \"Hello {{ name }}\", engine: :liquid}","ref":"Jido.AI.Prompt.MessageItem.html#new/1-examples"},{"type":"function","title":"Jido.AI.Prompt.MessageItem.new_multipart/2","doc":"Creates a new MessageItem with multi-part content.","ref":"Jido.AI.Prompt.MessageItem.html#new_multipart/2"},{"type":"function","title":"Examples - Jido.AI.Prompt.MessageItem.new_multipart/2","doc":"iex> Jido.AI.Prompt.MessageItem.new_multipart(:user, [\n    ...>   Jido.AI.Prompt.MessageItem.text_part(\"Check out this image:\"),\n    ...>   Jido.AI.Prompt.MessageItem.image_part(\"https://example.com/image.jpg\")\n    ...> ])\n    %Jido.AI.Prompt.MessageItem{role: :user, content: [\n      %{type: :text, text: \"Check out this image:\"},\n      %{type: :image_url, image_url: \"https://example.com/image.jpg\"}\n    ], engine: :none}","ref":"Jido.AI.Prompt.MessageItem.html#new_multipart/2-examples"},{"type":"type","title":"Jido.AI.Prompt.MessageItem.t/0","doc":"A message item within a prompt","ref":"Jido.AI.Prompt.MessageItem.html#t:t/0"},{"type":"function","title":"Jido.AI.Prompt.MessageItem.text_part/1","doc":"Creates a new text content part.","ref":"Jido.AI.Prompt.MessageItem.html#text_part/1"},{"type":"function","title":"Examples - Jido.AI.Prompt.MessageItem.text_part/1","doc":"iex> Jido.AI.Prompt.MessageItem.text_part(\"Hello\")\n    %{type: :text, text: \"Hello\"}","ref":"Jido.AI.Prompt.MessageItem.html#text_part/1-examples"},{"type":"module","title":"Jido.AI.Prompt.Splitter","doc":"This module is used to split a string into chunks by the number of tokens,\nwhile accounting for *other* data that might be going with it to the API\nendpoint with the limited token count.\n\nFor example, the search entry agent may be processing a large file, one that\nmust be split into 3 slices just to fit it into the payload of an API call.\nIn order to retain context between chunks, the agent essentially _reduces_\nover the file, keeping track of information in the previous chunks to\ngenerate a final summary. Doing that means that we need to not only split the\nfile by the number of tokens in each slice, but also keep some space for the\nbespoke data that will be added to the payload as the agent's \"accumulator\".","ref":"Jido.AI.Prompt.Splitter.html"},{"type":"function","title":"Jido.AI.Prompt.Splitter.new/2","doc":"","ref":"Jido.AI.Prompt.Splitter.html#new/2"},{"type":"function","title":"Jido.AI.Prompt.Splitter.next_chunk/2","doc":"","ref":"Jido.AI.Prompt.Splitter.html#next_chunk/2"},{"type":"module","title":"Jido.AI.Prompt.Template","doc":"Enables defining a prompt template and delaying the final\nbuilding of it until a later time when input values are substituted in.\n\nThis also supports the ability to create a Message from a Template.\n\nPromptTemplates are powerful because they support Elixir's EEx templates\nallowing for parameter substitution. This is helpful when we want to prepare a\ntemplate message and plan to later substitute in information from the user.\n\nHere's an example of setting up a template using a parameter then later\nproviding the input value.\n\n    template = Jido.AI.Prompt.Template.from_string!(\"What's a name for a company that makes <%= @product %>?\")\n\n    # later, format the final text after after applying the values.\n    Jido.AI.Prompt.Template.format(template, %{product: \"colorful socks\"})\n    #=> \"What's a name for a company that makes colorful socks?\"","ref":"Jido.AI.Prompt.Template.html"},{"type":"function","title":"Jido.AI.Prompt.Template.compile/1","doc":"Compile a template to check for syntax errors.","ref":"Jido.AI.Prompt.Template.html#compile/1"},{"type":"function","title":"Jido.AI.Prompt.Template.create_clean_copy/1","doc":"Creates a clean copy with reset version history","ref":"Jido.AI.Prompt.Template.html#create_clean_copy/1"},{"type":"function","title":"Jido.AI.Prompt.Template.estimate_tokens/2","doc":"Estimates the number of tokens that would be used by this template.\nThis is useful for ensuring prompts don't exceed model token limits.\n\nNote: This is a very rough estimation - tokens vary by model.","ref":"Jido.AI.Prompt.Template.html#estimate_tokens/2"},{"type":"function","title":"Jido.AI.Prompt.Template.format/3","doc":"Format the template with inputs to replace with assigns. It returns the\nformatted text.\n\n    template = Jido.AI.Prompt.Template.from_string!(\"Suggest a name for a company that makes <%= @product %>?\")\n    Jido.AI.Prompt.Template.format(template, %{product: \"colorful socks\"})\n    #=> \"Suggest a name for a company that makes colorful socks?\"\n\nA Template supports storing input values on the struct. These could be\nset when the template is defined. If an input value is not provided when the\n`format` function is called, any inputs on the struct will be used.","ref":"Jido.AI.Prompt.Template.html#format/3"},{"type":"function","title":"Jido.AI.Prompt.Template.format!/2","doc":"Same as format/2 but raises on error.","ref":"Jido.AI.Prompt.Template.html#format!/2"},{"type":"function","title":"Jido.AI.Prompt.Template.format_composed/3","doc":"Format a template with sub-templates.\n\nThis is useful when you want to compose a template from other templates.\nThe sub-templates can be either Template structs or strings.","ref":"Jido.AI.Prompt.Template.html#format_composed/3"},{"type":"function","title":"Example - Jido.AI.Prompt.Template.format_composed/3","doc":"main = Template.new!(%{text: \"Header: <%= @intro %>\nBody: <%= @body %>\"})\n    intro = Template.new!(%{text: \"Welcome <%= @name %>!\"})\n    body = \"This is the body text.\"\n\n    Template.format_composed(main, %{intro: intro, body: body}, %{name: \"Alice\"})\n    #=> \"Header: Welcome Alice!\nBody: This is the body text.\"","ref":"Jido.AI.Prompt.Template.html#format_composed/3-example"},{"type":"function","title":"Jido.AI.Prompt.Template.format_text/3","doc":"Format the template text with inputs to replace placeholders.\n\nOperates directly on text to apply the inputs. This does not take the\nTemplate struct.\n\n    Jido.AI.Prompt.Template.format_text(\"Hi! My name is <%= @name %>.\", %{name: \"Jose\"})\n    #=> \"Hi! My name is Jose.\"","ref":"Jido.AI.Prompt.Template.html#format_text/3"},{"type":"function","title":"Jido.AI.Prompt.Template.from_string/2","doc":"Build a Template struct from a string.\n\nShortcut function for building a user prompt.\n\n    {:ok, template} = Jido.AI.Prompt.Template.from_string(\"Suggest a name for a company that makes <%= @product %>?\")","ref":"Jido.AI.Prompt.Template.html#from_string/2"},{"type":"function","title":"Jido.AI.Prompt.Template.from_string!/2","doc":"Build a Template struct from a string and return the struct or error if invalid.\n\nShortcut function for building a user prompt.\n\n    template = Jido.AI.Prompt.Template.from_string!(\"Suggest a name for a company that makes <%= @product %>?\")","ref":"Jido.AI.Prompt.Template.html#from_string!/2"},{"type":"function","title":"Jido.AI.Prompt.Template.from_string_with_defaults/3","doc":"Build a Template with default values for parameters.\n\nThis is useful when you want to set some default values that can be overridden later.\n\n    template = Jido.AI.Prompt.Template.from_string_with_defaults(\n      \"Hello <%= @name %>, welcome to <%= @service %>!\",\n      %{service: \"Jido AI\"}\n    )\n    Jido.AI.Prompt.Template.format(template, %{name: \"Alice\"})\n    #=> \"Hello Alice, welcome to Jido AI!\"","ref":"Jido.AI.Prompt.Template.html#from_string_with_defaults/3"},{"type":"function","title":"Jido.AI.Prompt.Template.from_string_with_defaults!/3","doc":"Build a Template with default values for parameters.\nRaises an exception if the template is invalid.\n\n    template = Jido.AI.Prompt.Template.from_string_with_defaults!(\n      \"Hello <%= @name %>, welcome to <%= @service %>!\",\n      %{service: \"Jido AI\"}\n    )","ref":"Jido.AI.Prompt.Template.html#from_string_with_defaults!/3"},{"type":"function","title":"Jido.AI.Prompt.Template.increment_version/1","doc":"Increments the version number of the template.\nReturns a new template with the incremented version and adds the previous\nversion to history.","ref":"Jido.AI.Prompt.Template.html#increment_version/1"},{"type":"function","title":"Jido.AI.Prompt.Template.list_versions/1","doc":"Lists all available versions of the template","ref":"Jido.AI.Prompt.Template.html#list_versions/1"},{"type":"function","title":"Jido.AI.Prompt.Template.new/1","doc":"Create a new Template struct using the attributes.","ref":"Jido.AI.Prompt.Template.html#new/1"},{"type":"function","title":"Example - Jido.AI.Prompt.Template.new/1","doc":"{:ok, template} = Jido.AI.Prompt.Template.new(%{text: \"My template\", role: :user})","ref":"Jido.AI.Prompt.Template.html#new/1-example"},{"type":"function","title":"Jido.AI.Prompt.Template.new!/1","doc":"Create a new Template struct using the attributes. If invalid, an\nexception is raised with the reason.","ref":"Jido.AI.Prompt.Template.html#new!/1"},{"type":"function","title":"Example - Jido.AI.Prompt.Template.new!/1","doc":"A template is created using a simple map with `text` and `role` keys.\n\n    Jido.AI.Prompt.Template.new!(%{text: \"My template\", role: :user})\n\nTypically a template is used with parameter substitution as that's\nit's primary purpose. EEx is used to render the final text.\n\n    Jido.AI.Prompt.Template.new!(%{\n      text: \"My name is <%= @user_name %>. Warmly welcome me.\",\n      role: :user\n    })","ref":"Jido.AI.Prompt.Template.html#new!/1-example"},{"type":"function","title":"Jido.AI.Prompt.Template.record_usage/2","doc":"Records usage statistics for the template.","ref":"Jido.AI.Prompt.Template.html#record_usage/2"},{"type":"function","title":"Parameters - Jido.AI.Prompt.Template.record_usage/2","doc":"- template: The template to update\n  - metrics: A map containing metrics to record, such as:\n    - tokens_used: Number of tokens used in the response\n    - response_time_ms: Time taken to generate response\n    - success: Whether the generation was successful","ref":"Jido.AI.Prompt.Template.html#record_usage/2-parameters"},{"type":"function","title":"Example - Jido.AI.Prompt.Template.record_usage/2","doc":"template = record_usage(template, %{\n      tokens_used: 150,\n      response_time_ms: 500,\n      success: true\n    })","ref":"Jido.AI.Prompt.Template.html#record_usage/2-example"},{"type":"function","title":"Jido.AI.Prompt.Template.rollback_to_version/2","doc":"Rolls back to a specific version if it exists in history","ref":"Jido.AI.Prompt.Template.html#rollback_to_version/2"},{"type":"function","title":"Jido.AI.Prompt.Template.sanitize_inputs/1","doc":"Sanitizes user inputs to prevent template injection attacks.","ref":"Jido.AI.Prompt.Template.html#sanitize_inputs/1"},{"type":"function","title":"Jido.AI.Prompt.Template.schema/0","doc":"Returns the NimbleOptions schema for Template.","ref":"Jido.AI.Prompt.Template.html#schema/0"},{"type":"type","title":"Jido.AI.Prompt.Template.t/0","doc":"","ref":"Jido.AI.Prompt.Template.html#t:t/0"},{"type":"function","title":"Jido.AI.Prompt.Template.to_message/2","doc":"Convert a template to a MessageItem struct.\n\nThis is useful when you want to use a template as part of a conversation.","ref":"Jido.AI.Prompt.Template.html#to_message/2"},{"type":"function","title":"Jido.AI.Prompt.Template.to_message!/2","doc":"Convert a template to a MessageItem struct. Raises if there's an error.","ref":"Jido.AI.Prompt.Template.html#to_message!/2"},{"type":"function","title":"Jido.AI.Prompt.Template.to_messages!/2","doc":"Convert a list of templates, message items, and strings to a list of message items.\n\nThis is useful when you want to build a conversation from a mix of\ntemplates and messages.","ref":"Jido.AI.Prompt.Template.html#to_messages!/2"},{"type":"function","title":"Example - Jido.AI.Prompt.Template.to_messages!/2","doc":"t1 = Template.new!(%{text: \"System: <%= @sysinfo %>\", role: :system})\n    t2 = Template.new!(%{text: \"Question: <%= @question %>\", role: :user})\n\n    messages = Template.to_messages!([t1, t2, \"A direct user string\"], %{\n      sysinfo: \"Guide the user\",\n      question: \"What is 2+2?\"\n    })","ref":"Jido.AI.Prompt.Template.html#to_messages!/2-example"},{"type":"function","title":"Jido.AI.Prompt.Template.update_text/2","doc":"Updates template text and automatically increments version","ref":"Jido.AI.Prompt.Template.html#update_text/2"},{"type":"function","title":"Jido.AI.Prompt.Template.validate_template_syntax/1","doc":"Validates the syntax of a template without evaluating it.","ref":"Jido.AI.Prompt.Template.html#validate_template_syntax/1"},{"type":"protocol","title":"Jido.AI.Promptable","doc":"Protocol for data structures that can be converted into prompts for LLMs.\n\nImplementing this protocol allows any struct to be convertible\nto a string prompt via `Jido.AI.Promptable.to_prompt/1`.","ref":"Jido.AI.Promptable.html"},{"type":"protocol","title":"Examples - Jido.AI.Promptable","doc":"defimpl Jido.AI.Promptable, for: MyApp.User do\n      def to_prompt(user) do\n        \"User #{user.name} is #{user.age} years old\"\n      end\n    end\n\n    user = %MyApp.User{name: \"Alice\", age: 30}\n    Jido.AI.Promptable.to_prompt(user) #=> \"User Alice is 30 years old\"","ref":"Jido.AI.Promptable.html#module-examples"},{"type":"type","title":"Jido.AI.Promptable.t/0","doc":"All the types that implement this protocol.","ref":"Jido.AI.Promptable.html#t:t/0"},{"type":"function","title":"Jido.AI.Promptable.to_prompt/1","doc":"Converts the given data structure into a prompt string suitable for an LLM.","ref":"Jido.AI.Promptable.html#to_prompt/1"},{"type":"module","title":"Jido.AI.Provider","doc":"","ref":"Jido.AI.Provider.html"},{"type":"function","title":"Jido.AI.Provider.base_dir/0","doc":"Returns the base directory path for provider-specific files.\n\nThis is where provider configuration, models, and other data files are stored.\nThe path is relative to the project root and expands to `./priv/provider/`.","ref":"Jido.AI.Provider.html#base_dir/0"},{"type":"function","title":"Jido.AI.Provider.call_provider_callback/3","doc":"","ref":"Jido.AI.Provider.html#call_provider_callback/3"},{"type":"function","title":"Jido.AI.Provider.ensure_atom/1","doc":"Ensures the given value is an atom.","ref":"Jido.AI.Provider.html#ensure_atom/1"},{"type":"function","title":"Jido.AI.Provider.get_adapter_by_id/1","doc":"Gets an adapter module by provider ID.\n\nThis is a helper function for getting the adapter module directly by ID.","ref":"Jido.AI.Provider.html#get_adapter_by_id/1"},{"type":"function","title":"Jido.AI.Provider.get_adapter_module/1","doc":"","ref":"Jido.AI.Provider.html#get_adapter_module/1"},{"type":"function","title":"Jido.AI.Provider.get_combined_model_info/1","doc":"Retrieves combined information for a model across all providers.","ref":"Jido.AI.Provider.html#get_combined_model_info/1"},{"type":"function","title":"Parameters - Jido.AI.Provider.get_combined_model_info/1","doc":"- model_name: The name of the model to search for","ref":"Jido.AI.Provider.html#get_combined_model_info/1-parameters"},{"type":"function","title":"Returns - Jido.AI.Provider.get_combined_model_info/1","doc":"- {:ok, model_info} - Combined model information\n  - {:error, reason} - Error if model not found","ref":"Jido.AI.Provider.html#get_combined_model_info/1-returns"},{"type":"function","title":"Jido.AI.Provider.get_model/3","doc":"Gets a specific model from a provider by its ID or name.","ref":"Jido.AI.Provider.html#get_model/3"},{"type":"function","title":"Parameters - Jido.AI.Provider.get_model/3","doc":"* `provider` - The provider struct or ID\n* `model` - The ID or name of the model to fetch\n* `opts` - Additional options for the request","ref":"Jido.AI.Provider.html#get_model/3-parameters"},{"type":"function","title":"Returns - Jido.AI.Provider.get_model/3","doc":"* `{:ok, model}` - The model was found\n* `{:error, reason}` - The model was not found or an error occurred","ref":"Jido.AI.Provider.html#get_model/3-returns"},{"type":"function","title":"Jido.AI.Provider.list/0","doc":"","ref":"Jido.AI.Provider.html#list/0"},{"type":"function","title":"Jido.AI.Provider.list_all_cached_models/0","doc":"Lists all cached models across all providers.","ref":"Jido.AI.Provider.html#list_all_cached_models/0"},{"type":"function","title":"Returns - Jido.AI.Provider.list_all_cached_models/0","doc":"- List of model maps, each containing provider information","ref":"Jido.AI.Provider.html#list_all_cached_models/0-returns"},{"type":"function","title":"Jido.AI.Provider.models/2","doc":"","ref":"Jido.AI.Provider.html#models/2"},{"type":"type","title":"Jido.AI.Provider.provider_id/0","doc":"","ref":"Jido.AI.Provider.html#t:provider_id/0"},{"type":"type","title":"Jido.AI.Provider.provider_type/0","doc":"","ref":"Jido.AI.Provider.html#t:provider_type/0"},{"type":"function","title":"Jido.AI.Provider.providers/0","doc":"","ref":"Jido.AI.Provider.html#providers/0"},{"type":"function","title":"Jido.AI.Provider.standardize_model_name/1","doc":"Standardizes a model name across providers by removing version numbers and dates.\nThis helps match equivalent models from different providers.","ref":"Jido.AI.Provider.html#standardize_model_name/1"},{"type":"function","title":"Examples - Jido.AI.Provider.standardize_model_name/1","doc":"iex> standardize_model_name(\"claude-3.7-sonnet-20250219\")\n    \"claude-3.7-sonnet\"\n    iex> standardize_model_name(\"gpt-4-0613\")\n    \"gpt-4\"","ref":"Jido.AI.Provider.html#standardize_model_name/1-examples"},{"type":"type","title":"Jido.AI.Provider.t/0","doc":"An AI model provider","ref":"Jido.AI.Provider.html#t:t/0"},{"type":"module","title":"Jido.AI.Provider.Anthropic","doc":"Adapter for the Anthropic AI provider.\n\nImplements the ProviderBehavior for Anthropic's specific API.","ref":"Jido.AI.Provider.Anthropic.html"},{"type":"function","title":"Jido.AI.Provider.Anthropic.build/1","doc":"Builds a %Jido.AI.Model{} struct from the provided options.\n\nThis function validates the options, sets defaults, and creates a fully populated\nmodel struct for the Anthropic provider.","ref":"Jido.AI.Provider.Anthropic.html#build/1"},{"type":"function","title":"Parameters - Jido.AI.Provider.Anthropic.build/1","doc":"- opts: Keyword list of options for building the model","ref":"Jido.AI.Provider.Anthropic.html#build/1-parameters"},{"type":"function","title":"Returns - Jido.AI.Provider.Anthropic.build/1","doc":"- {:ok, %Jido.AI.Model{}} on success\n  - {:error, reason} on failure","ref":"Jido.AI.Provider.Anthropic.html#build/1-returns"},{"type":"function","title":"Jido.AI.Provider.Anthropic.list_models/1","doc":"Lists available models from local cache or API.","ref":"Jido.AI.Provider.Anthropic.html#list_models/1"},{"type":"function","title":"Options - Jido.AI.Provider.Anthropic.list_models/1","doc":"- refresh: boolean - Whether to force refresh from API (default: false)\n  - api_key: string - Anthropic API key (optional)\n\nReturns a tuple with {:ok, models} on success or {:error, reason} on failure.","ref":"Jido.AI.Provider.Anthropic.html#list_models/1-options"},{"type":"function","title":"Jido.AI.Provider.Anthropic.model/2","doc":"Fetches a specific model by ID from the API or cache.","ref":"Jido.AI.Provider.Anthropic.html#model/2"},{"type":"function","title":"Options - Jido.AI.Provider.Anthropic.model/2","doc":"- refresh: boolean - Whether to force refresh from API (default: false)\n  - api_key: string - Anthropic API key (optional)\n\nReturns a tuple with {:ok, model} on success or {:error, reason} on failure.","ref":"Jido.AI.Provider.Anthropic.html#model/2-options"},{"type":"function","title":"Jido.AI.Provider.Anthropic.normalize/2","doc":"Normalizes a model ID to ensure it's in the correct format for Anthropic.","ref":"Jido.AI.Provider.Anthropic.html#normalize/2"},{"type":"function","title":"Options - Jido.AI.Provider.Anthropic.normalize/2","doc":"- No specific options for this method\n\nReturns a tuple with {:ok, normalized_id} on success or {:error, reason} on failure.","ref":"Jido.AI.Provider.Anthropic.html#normalize/2-options"},{"type":"module","title":"Jido.AI.Provider.Cloudflare","doc":"Adapter for the Cloudflare AI provider.\n\nImplements the ProviderBehavior for Cloudflare's AI API.","ref":"Jido.AI.Provider.Cloudflare.html"},{"type":"function","title":"Jido.AI.Provider.Cloudflare.build/1","doc":"Builds a %Jido.AI.Model{} struct from the provided options.\n\nThis function validates the options, sets defaults, and creates a fully populated\nmodel struct for the Cloudflare provider.","ref":"Jido.AI.Provider.Cloudflare.html#build/1"},{"type":"function","title":"Parameters - Jido.AI.Provider.Cloudflare.build/1","doc":"- opts: Keyword list of options for building the model","ref":"Jido.AI.Provider.Cloudflare.html#build/1-parameters"},{"type":"function","title":"Returns - Jido.AI.Provider.Cloudflare.build/1","doc":"- {:ok, %Jido.AI.Model{}} on success\n  - {:error, reason} on failure","ref":"Jido.AI.Provider.Cloudflare.html#build/1-returns"},{"type":"function","title":"Jido.AI.Provider.Cloudflare.list_models/1","doc":"Lists available models from local cache or API.","ref":"Jido.AI.Provider.Cloudflare.html#list_models/1"},{"type":"function","title":"Options - Jido.AI.Provider.Cloudflare.list_models/1","doc":"- refresh: boolean - Whether to force refresh from API (default: false)\n  - api_key: string - Cloudflare API key (optional)\n  - email: string - Cloudflare account email (optional)\n  - account_id: string - Cloudflare account ID (required)\n\nReturns a tuple with {:ok, models} on success or {:error, reason} on failure.","ref":"Jido.AI.Provider.Cloudflare.html#list_models/1-options"},{"type":"function","title":"Jido.AI.Provider.Cloudflare.model/2","doc":"Fetches a specific model by ID from the API or cache.","ref":"Jido.AI.Provider.Cloudflare.html#model/2"},{"type":"function","title":"Options - Jido.AI.Provider.Cloudflare.model/2","doc":"- refresh: boolean - Whether to force refresh from API (default: false)\n  - api_key: string - Cloudflare API key (optional)\n  - email: string - Cloudflare account email (optional)\n  - account_id: string - Cloudflare account ID (required)\n\nReturns a tuple with {:ok, model} on success or {:error, reason} on failure.","ref":"Jido.AI.Provider.Cloudflare.html#model/2-options"},{"type":"module","title":"Jido.AI.Provider.Google","doc":"Adapter for the Google Gemini API provider.\n\nImplements the ProviderBehavior for Google's OpenAI-compatible API.","ref":"Jido.AI.Provider.Google.html"},{"type":"function","title":"Jido.AI.Provider.Google.build/1","doc":"Builds a %Jido.AI.Model{} struct from the provided options.\n\nThis function validates the options, sets defaults, and creates a fully populated\nmodel struct for the Google provider.","ref":"Jido.AI.Provider.Google.html#build/1"},{"type":"function","title":"Parameters - Jido.AI.Provider.Google.build/1","doc":"- opts: Map or keyword list of options for building the model","ref":"Jido.AI.Provider.Google.html#build/1-parameters"},{"type":"function","title":"Returns - Jido.AI.Provider.Google.build/1","doc":"- {:ok, %Jido.AI.Model{}} on success\n  - {:error, reason} on failure","ref":"Jido.AI.Provider.Google.html#build/1-returns"},{"type":"function","title":"Jido.AI.Provider.Google.list_models/1","doc":"Lists available models from local cache or API.","ref":"Jido.AI.Provider.Google.html#list_models/1"},{"type":"function","title":"Options - Jido.AI.Provider.Google.list_models/1","doc":"- refresh: boolean - Whether to force refresh from API (default: false)\n  - api_key: string - Google Gemini API key (optional)\n\nReturns a tuple with {:ok, models} on success or {:error, reason} on failure.","ref":"Jido.AI.Provider.Google.html#list_models/1-options"},{"type":"function","title":"Jido.AI.Provider.Google.model/2","doc":"Fetches a specific model by ID from the API or cache.","ref":"Jido.AI.Provider.Google.html#model/2"},{"type":"function","title":"Options - Jido.AI.Provider.Google.model/2","doc":"- refresh: boolean - Whether to force refresh from API (default: false)\n  - api_key: string - Google Gemini API key (optional)\n\nReturns a tuple with {:ok, model} on success or {:error, reason} on failure.","ref":"Jido.AI.Provider.Google.html#model/2-options"},{"type":"function","title":"Jido.AI.Provider.Google.models/1","doc":"Returns a list of models for the provider.\n\nThis is a required function for the Provider.Adapter behaviour.","ref":"Jido.AI.Provider.Google.html#models/1"},{"type":"function","title":"Jido.AI.Provider.Google.normalize/2","doc":"Normalizes a model ID to ensure it's in the correct format for Google Gemini.","ref":"Jido.AI.Provider.Google.html#normalize/2"},{"type":"function","title":"Options - Jido.AI.Provider.Google.normalize/2","doc":"- No specific options for this method\n\nReturns a tuple with {:ok, normalized_id} on success or {:error, reason} on failure.","ref":"Jido.AI.Provider.Google.html#normalize/2-options"},{"type":"module","title":"Jido.AI.Provider.Helpers","doc":"Common helper functions for AI provider adapters.\n\nThis module centralizes functionality that would otherwise be duplicated\nacross provider implementations, such as:\n- File path management for model caching\n- Reading from and writing to cache\n- Making API requests with proper authentication\n- Model name standardization across providers","ref":"Jido.AI.Provider.Helpers.html"},{"type":"function","title":"Jido.AI.Provider.Helpers.cache_single_model/3","doc":"Caches a single model to a file.","ref":"Jido.AI.Provider.Helpers.html#cache_single_model/3"},{"type":"function","title":"Jido.AI.Provider.Helpers.extract_model_from_response/1","doc":"Extracts a model from different response formats.","ref":"Jido.AI.Provider.Helpers.html#extract_model_from_response/1"},{"type":"function","title":"Jido.AI.Provider.Helpers.extract_models_from_response/1","doc":"Extracts models from different response formats.","ref":"Jido.AI.Provider.Helpers.html#extract_models_from_response/1"},{"type":"function","title":"Jido.AI.Provider.Helpers.fetch_and_cache_models/5","doc":"Fetches models from the API and caches them.","ref":"Jido.AI.Provider.Helpers.html#fetch_and_cache_models/5"},{"type":"function","title":"Jido.AI.Provider.Helpers.fetch_model_from_api/7","doc":"Fetches a specific model from the API and caches it.","ref":"Jido.AI.Provider.Helpers.html#fetch_model_from_api/7"},{"type":"function","title":"Jido.AI.Provider.Helpers.fetch_model_from_cache/4","doc":"Fetches a model from the cache.","ref":"Jido.AI.Provider.Helpers.html#fetch_model_from_cache/4"},{"type":"function","title":"Jido.AI.Provider.Helpers.get_api_key/3","doc":"Gets an API key from options or environment.","ref":"Jido.AI.Provider.Helpers.html#get_api_key/3"},{"type":"function","title":"Jido.AI.Provider.Helpers.get_model_file_path/2","doc":"Gets the path to a specific model file for a provider.","ref":"Jido.AI.Provider.Helpers.html#get_model_file_path/2"},{"type":"function","title":"Jido.AI.Provider.Helpers.get_models_file_path/1","doc":"Gets the path to the models file for a provider.","ref":"Jido.AI.Provider.Helpers.html#get_models_file_path/1"},{"type":"function","title":"Jido.AI.Provider.Helpers.merge_model_information/1","doc":"Merges model information from multiple providers.","ref":"Jido.AI.Provider.Helpers.html#merge_model_information/1"},{"type":"function","title":"Parameters - Jido.AI.Provider.Helpers.merge_model_information/1","doc":"- models: List of model maps from different providers","ref":"Jido.AI.Provider.Helpers.html#merge_model_information/1-parameters"},{"type":"function","title":"Returns - Jido.AI.Provider.Helpers.merge_model_information/1","doc":"- A merged model map with combined information","ref":"Jido.AI.Provider.Helpers.html#merge_model_information/1-returns"},{"type":"function","title":"Jido.AI.Provider.Helpers.read_models_from_cache/2","doc":"Reads models from the cache file.","ref":"Jido.AI.Provider.Helpers.html#read_models_from_cache/2"},{"type":"function","title":"Jido.AI.Provider.Helpers.standardize_name/1","doc":"Standardizes a model name across providers by removing version numbers and dates.\nThis helps match equivalent models from different providers.","ref":"Jido.AI.Provider.Helpers.html#standardize_name/1"},{"type":"function","title":"Examples - Jido.AI.Provider.Helpers.standardize_name/1","doc":"iex> standardize_name(\"claude-3.7-sonnet-20250219\")\n    \"claude-3.7-sonnet\"\n    iex> standardize_name(\"gpt-4-0613\")\n    \"gpt-4\"","ref":"Jido.AI.Provider.Helpers.html#standardize_name/1-examples"},{"type":"module","title":"Jido.AI.Provider.OpenAI","doc":"Adapter for the OpenAI AI provider.\n\nImplements the ProviderBehavior for OpenAI's specific API.","ref":"Jido.AI.Provider.OpenAI.html"},{"type":"function","title":"Jido.AI.Provider.OpenAI.build/1","doc":"Builds a %Jido.AI.Model{} struct from the provided options.\n\nThis function validates the options, sets defaults, and creates a fully populated\nmodel struct for the OpenAI provider.","ref":"Jido.AI.Provider.OpenAI.html#build/1"},{"type":"function","title":"Parameters - Jido.AI.Provider.OpenAI.build/1","doc":"- opts: Keyword list of options for building the model","ref":"Jido.AI.Provider.OpenAI.html#build/1-parameters"},{"type":"function","title":"Returns - Jido.AI.Provider.OpenAI.build/1","doc":"- {:ok, %Jido.AI.Model{}} on success\n  - {:error, reason} on failure","ref":"Jido.AI.Provider.OpenAI.html#build/1-returns"},{"type":"function","title":"Jido.AI.Provider.OpenAI.list_models/1","doc":"Lists available models from local cache or API.","ref":"Jido.AI.Provider.OpenAI.html#list_models/1"},{"type":"function","title":"Options - Jido.AI.Provider.OpenAI.list_models/1","doc":"- refresh: boolean - Whether to force refresh from API (default: false)\n  - api_key: string - OpenAI API key (optional)\n\nReturns a tuple with {:ok, models} on success or {:error, reason} on failure.","ref":"Jido.AI.Provider.OpenAI.html#list_models/1-options"},{"type":"function","title":"Jido.AI.Provider.OpenAI.model/2","doc":"Fetches a specific model by ID from the API or cache.","ref":"Jido.AI.Provider.OpenAI.html#model/2"},{"type":"function","title":"Options - Jido.AI.Provider.OpenAI.model/2","doc":"- refresh: boolean - Whether to force refresh from API (default: false)\n  - api_key: string - OpenAI API key (optional)\n\nReturns a tuple with {:ok, model} on success or {:error, reason} on failure.","ref":"Jido.AI.Provider.OpenAI.html#model/2-options"},{"type":"function","title":"Jido.AI.Provider.OpenAI.normalize/2","doc":"Normalizes a model ID to ensure it's in the correct format for OpenAI.","ref":"Jido.AI.Provider.OpenAI.html#normalize/2"},{"type":"function","title":"Options - Jido.AI.Provider.OpenAI.normalize/2","doc":"- No specific options for this method\n\nReturns a tuple with {:ok, normalized_id} on success or {:error, reason} on failure.","ref":"Jido.AI.Provider.OpenAI.html#normalize/2-options"},{"type":"module","title":"Jido.AI.Provider.OpenRouter","doc":"Adapter for the OpenRouter AI provider.\n\nImplements the ProviderBehavior for OpenRouter's specific API.","ref":"Jido.AI.Provider.OpenRouter.html"},{"type":"function","title":"Jido.AI.Provider.OpenRouter.build/1","doc":"Builds a %Jido.AI.Model{} struct from the provided options.\n\nThis function validates the options, sets defaults, and creates a fully populated\nmodel struct for the OpenRouter provider.","ref":"Jido.AI.Provider.OpenRouter.html#build/1"},{"type":"function","title":"Parameters - Jido.AI.Provider.OpenRouter.build/1","doc":"- opts: Keyword list of options for building the model","ref":"Jido.AI.Provider.OpenRouter.html#build/1-parameters"},{"type":"function","title":"Returns - Jido.AI.Provider.OpenRouter.build/1","doc":"- {:ok, %Jido.AI.Model{}} on success\n  - {:error, reason} on failure","ref":"Jido.AI.Provider.OpenRouter.html#build/1-returns"},{"type":"function","title":"Jido.AI.Provider.OpenRouter.list_models/1","doc":"Lists available models from local cache or API.","ref":"Jido.AI.Provider.OpenRouter.html#list_models/1"},{"type":"function","title":"Options - Jido.AI.Provider.OpenRouter.list_models/1","doc":"- refresh: boolean - Whether to force refresh from API (default: false)\n  - api_key: string - OpenRouter API key (optional)\n\nReturns a tuple with {:ok, models} on success or {:error, reason} on failure.","ref":"Jido.AI.Provider.OpenRouter.html#list_models/1-options"},{"type":"function","title":"Jido.AI.Provider.OpenRouter.model/2","doc":"Fetches a specific model by ID from the API or cache.","ref":"Jido.AI.Provider.OpenRouter.html#model/2"},{"type":"function","title":"Options - Jido.AI.Provider.OpenRouter.model/2","doc":"- refresh: boolean - Whether to force refresh from API (default: false)\n  - api_key: string - OpenRouter API key (optional)\n\nReturns a tuple with {:ok, model} on success or {:error, reason} on failure.","ref":"Jido.AI.Provider.OpenRouter.html#model/2-options"},{"type":"function","title":"Jido.AI.Provider.OpenRouter.models/1","doc":"Returns a list of models for the provider.\n\nThis is a required function for the Provider.Adapter behaviour.","ref":"Jido.AI.Provider.OpenRouter.html#models/1"},{"type":"function","title":"Jido.AI.Provider.OpenRouter.normalize/2","doc":"Normalizes a model ID to ensure it's in the correct format for OpenRouter.","ref":"Jido.AI.Provider.OpenRouter.html#normalize/2"},{"type":"function","title":"Options - Jido.AI.Provider.OpenRouter.normalize/2","doc":"- No specific options for this method\n\nReturns a tuple with {:ok, normalized_id} on success or {:error, reason} on failure.","ref":"Jido.AI.Provider.OpenRouter.html#normalize/2-options"},{"type":"module","title":"Jido.AI.Skill","doc":"General purpose AI skill powered by Jido","ref":"Jido.AI.Skill.html"},{"type":"function","title":"Jido.AI.Skill.validate_opts/1","doc":"","ref":"Jido.AI.Skill.html#validate_opts/1"},{"type":"module","title":"Jido.AI.Tokenizer","doc":"A simple tokenizer for AI models that provides basic encode/decode functionality.\nThis is a placeholder implementation that should be replaced with actual tokenization logic.","ref":"Jido.AI.Tokenizer.html"},{"type":"function","title":"Jido.AI.Tokenizer.decode/2","doc":"Decodes tokens back into a string for the given model.","ref":"Jido.AI.Tokenizer.html#decode/2"},{"type":"function","title":"Jido.AI.Tokenizer.encode/2","doc":"Encodes a string into tokens for the given model.","ref":"Jido.AI.Tokenizer.html#encode/2"},{"type":"module","title":"Jido.Examples.InstructorDemo","doc":"A demo module showcasing how to use Jido.AI with Instructor for structured prompting.","ref":"Jido.Examples.InstructorDemo.html"},{"type":"function","title":"Jido.Examples.InstructorDemo.boolean/0","doc":"","ref":"Jido.Examples.InstructorDemo.html#boolean/0"},{"type":"function","title":"Jido.Examples.InstructorDemo.chat/0","doc":"","ref":"Jido.Examples.InstructorDemo.html#chat/0"},{"type":"function","title":"Jido.Examples.InstructorDemo.choice/0","doc":"Demonstrates using the ChatResponse action for simpler chat interactions","ref":"Jido.Examples.InstructorDemo.html#choice/0"},{"type":"function","title":"Jido.Examples.InstructorDemo.model/0","doc":"","ref":"Jido.Examples.InstructorDemo.html#model/0"},{"type":"module","title":"Jido.Examples.InstructorDemo.ResponseSchema","doc":"","ref":"Jido.Examples.InstructorDemo.ResponseSchema.html"},{"type":"module","title":"JidoAi.Examples.Gemini","doc":"Example demonstrating how to use Google's Gemini models with Jido AI.\n\nThis example shows how to use the Model.from/1 function to create a Gemini model\nand use it with the OpenaiEx action to generate text.","ref":"JidoAi.Examples.Gemini.html"},{"type":"module","title":"Usage - JidoAi.Examples.Gemini","doc":"```\n$ mix run examples/gemini.ex\n```\n\nMake sure to set your Google API key as an environment variable:\n\n```\n$ GOOGLE_API_KEY=your_api_key mix run examples/gemini.ex\n```\n\nOr add it to your .env file.","ref":"JidoAi.Examples.Gemini.html#module-usage"},{"type":"function","title":"JidoAi.Examples.Gemini.run/0","doc":"","ref":"JidoAi.Examples.Gemini.html#run/0"},{"type":"module","title":"LangchainDemo","doc":"","ref":"LangchainDemo.html"},{"type":"function","title":"LangchainDemo.chat/0","doc":"","ref":"LangchainDemo.html#chat/0"},{"type":"function","title":"LangchainDemo.tool/0","doc":"","ref":"LangchainDemo.html#tool/0"},{"type":"task","title":"mix jido.ai.models","doc":"Fetches and caches models from AI providers.\n\nThis task provides a comprehensive interface for managing AI model information across different providers.\nIt allows you to list, fetch, and view detailed information about models from various AI providers.","ref":"Mix.Tasks.Jido.Ai.Models.html"},{"type":"task","title":"Features - mix jido.ai.models","doc":"* List available providers\n  * List all cached models across providers\n  * List models from specific providers\n  * Fetch and cache models from providers\n  * View detailed model information\n  * Compare models across providers\n  * Standardize model names across providers","ref":"Mix.Tasks.Jido.Ai.Models.html#module-features"},{"type":"task","title":"Examples - mix jido.ai.models","doc":"# List all available providers\n  mix jido.ai.models --list-providers\n\n  # List all cached models (across all providers)\n  mix jido.ai.models --list-all-models\n\n  # List all cached models with verbose output\n  mix jido.ai.models --list-all-models --verbose\n\n  # List models from a specific provider\n  mix jido.ai.models anthropic --list\n\n  # List models from a specific provider with verbose output\n  mix jido.ai.models anthropic --list --verbose\n\n  # Fetch and cache all models from a provider\n  mix jido.ai.models anthropic --fetch\n\n  # Fetch and cache a specific model\n  mix jido.ai.models anthropic --fetch --model=claude-3-7-sonnet-20250219\n\n  # Fetch and cache all models from all providers\n  mix jido.ai.models all --fetch\n\n  # Show detailed information for a model (combined across providers)\n  mix jido.ai.models --show=claude-3-7-sonnet\n\n  # Show detailed information with raw data\n  mix jido.ai.models --show=claude-3-7-sonnet --verbose\n\n  # Refresh cached model information\n  mix jido.ai.models anthropic --fetch --refresh","ref":"Mix.Tasks.Jido.Ai.Models.html#module-examples"},{"type":"task","title":"Model Information Display - mix jido.ai.models","doc":"When showing model information, the task displays:\n  * Model name and description\n  * Available providers\n  * Capabilities (chat, embedding, image, vision, etc.)\n  * Pricing information by provider\n  * Model tier and description\n  * Raw model data (with --verbose)","ref":"Mix.Tasks.Jido.Ai.Models.html#module-model-information-display"},{"type":"task","title":"Standardized Model Names - mix jido.ai.models","doc":"The task automatically standardizes model names across providers:\n  * claude-3-7-sonnet\n  * claude-3-5-sonnet\n  * claude-3-opus\n  * gpt-4\n  * gpt-3.5\n  * mistral-7b\n  * mistral-8x7b\n  * llama-2-70b\n  * llama-2-13b\n  * llama-2-7b","ref":"Mix.Tasks.Jido.Ai.Models.html#module-standardized-model-names"},{"type":"task","title":"Cache Location - mix jido.ai.models","doc":"Models are cached in the following location:\n  _build/dev/lib/jido_ai/priv/provider/ /models.json","ref":"Mix.Tasks.Jido.Ai.Models.html#module-cache-location"},{"type":"task","title":"Options - mix jido.ai.models","doc":"* --verbose: Show detailed information\n  * --refresh: Force refresh of cached data\n  * --model: Specify a model ID\n  * --list: List models\n  * --fetch: Fetch and cache models\n  * --show: Show detailed model information\n  * --list-providers: List available providers\n  * --list-all-models: List all cached models","ref":"Mix.Tasks.Jido.Ai.Models.html#module-options"},{"type":"module","title":"OpenAIExDemo","doc":"","ref":"OpenAIExDemo.html"},{"type":"function","title":"OpenAIExDemo.openai/0","doc":"","ref":"OpenAIExDemo.html#openai/0"},{"type":"function","title":"OpenAIExDemo.openai_stream/0","doc":"","ref":"OpenAIExDemo.html#openai_stream/0"},{"type":"function","title":"OpenAIExDemo.openai_stream_with_cancellation/0","doc":"","ref":"OpenAIExDemo.html#openai_stream_with_cancellation/0"},{"type":"function","title":"OpenAIExDemo.openai_stream_with_error_handling/0","doc":"","ref":"OpenAIExDemo.html#openai_stream_with_error_handling/0"},{"type":"function","title":"OpenAIExDemo.openrouter/0","doc":"","ref":"OpenAIExDemo.html#openrouter/0"},{"type":"function","title":"OpenAIExDemo.tool/0","doc":"","ref":"OpenAIExDemo.html#tool/0"},{"type":"exception","title":"Jido.AI.Error","doc":"Custom error type for Jido.AI operations.","ref":"Jido.AI.Error.html"},{"type":"function","title":"Jido.AI.Error.new/2","doc":"","ref":"Jido.AI.Error.html#new/2"},{"type":"type","title":"Jido.AI.Error.t/0","doc":"","ref":"Jido.AI.Error.html#t:t/0"},{"type":"extras","title":"Jido AI","doc":"# Jido AI\n\nJido AI is an extension of the Jido framework for building AI Agents and Workflows in Elixir. At present, it provides a single action for interacting with Anthropic's Claude models via the Instructor library.","ref":"readme.html"},{"type":"extras","title":"Installation - Jido AI","doc":"> **Note:** You must install `instructor` from GitHub until a new version is released. Hex does not yet have a release of `instructor` that supports the `Instructor.Adapters.Anthropic` adapter.\n\n```elixir\ndef deps do\n  [\n    {:jido, \"~> 1.0.0\"},\n    {:jido_ai, \"~> 1.0.0\"},\n\n    # Must install from github until a new version is released\n    {:instructor, github: \"thmsmlr/instructor_ex\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Jido AI","doc":"You will need to properly configure the `Instructor` library to use the Anthropic adapter:\n\n```elixir\n# config/config.exs\nconfig :instructor,\n  adapter: Instructor.Adapters.Anthropic,\n  anthropic: [\n    api_key: System.get_env(\"ANTHROPIC_API_KEY\")\n  ]\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Supported Providers - Jido AI","doc":"Jido AI supports multiple LLM providers:\n\n- Anthropic (Claude models)\n- OpenAI (GPT models)\n- OpenRouter (proxy for multiple models)\n- Cloudflare (Workers AI models)\n- Google (Gemini models)","ref":"readme.html#supported-providers"},{"type":"extras","title":"Using Google Gemini - Jido AI","doc":"To use Google's Gemini models with the OpenAI-compatible API:\n\n```elixir\n# Set your Google API key\nJido.AI.Keyring.set_session_value(:google_api_key, \"your_gemini_api_key\")\n\n# Create a model using the Google provider\n{:ok, model} = Jido.AI.Model.from({:google, [model: \"gemini-2.0-flash\"]})\n\n# Use the model with any OpenAI-compatible action\n{:ok, result} = Jido.AI.Actions.OpenaiEx.run(\n  %{\n    model: model,\n    messages: [\n      %{role: \"user\", content: \"Tell me about Elixir programming language\"}\n    ],\n    temperature: 0.7\n  },\n  %{}\n)\n```\n\nYou can also set the Google API key using environment variables:\n\n```\nGOOGLE_API_KEY=your_gemini_api_key\n```","ref":"readme.html#using-google-gemini"},{"type":"extras","title":"Prompt and Message Handling - Jido AI","doc":"Jido AI provides a robust system for handling prompts and messages when interacting with LLMs.","ref":"readme.html#prompt-and-message-handling"},{"type":"extras","title":"MessageItem - Jido AI","doc":"The `Jido.AI.Prompt.MessageItem` module is used to represent messages in conversations with LLMs. It supports:\n\n- Basic text messages with different roles (user, assistant, system, function)\n- Rich content including images and files\n- Template-based messages using EEx\n\n```elixir\nalias Jido.AI.Prompt.MessageItem\n\n# Create a simple user message\nuser_msg = MessageItem.new(%{role: :user, content: \"Hello\"})\n\n# Create a system message\nsystem_msg = MessageItem.new(%{role: :system, content: \"You are a helpful assistant\"})\n\n# Create a message with rich content (image)\nrich_msg = MessageItem.new_multipart(:user, [\n  MessageItem.text_part(\"Check out this image:\"),\n  MessageItem.image_part(\"https://example.com/image.jpg\")\n])\n\n# Create a message with a template\ntemplate_msg = MessageItem.new(%{\n  role: :system,\n  content: \"You are a <%= @assistant_type %>\",\n  engine: :eex\n})\n```\n\nFor more details on MessageItem usage, refer to the documentation.","ref":"readme.html#messageitem"},{"type":"extras","title":"Example - Jido AI","doc":"Here's how to use Jido AI with Jido.Exec to get structured information about US politicians. See the [examples/politician.ex](examples/politician.ex) for more a full example.\n\n```elixir\n# Define a simple workflow\ndefmodule JidoAi.Examples.Politician do\n  defmodule Schema do\n    use Ecto.Schema\n    use Instructor\n    @primary_key false\n    embedded_schema do\n      field(:first_name, :string)\n      field(:last_name, :string)\n\n      embeds_many :offices_held, Office, primary_key: false do\n        field(:office, Ecto.Enum,\n          values: [:president, :vice_president, :governor, :congress, :senate]\n        )\n\n        field(:from_date, :date)\n        field(:to_date, :date)\n      end\n    end\n  end\n\n  use Jido.Action,\n    name: \"politician\",\n    description: \"A description of United States Politicians and the offices that they held\",\n    schema: [\n      query: [type: :string, required: true, doc: \"The query to search for\"]\n    ]\n\n  def run(params, _context) do\n    # Run the Anthropic ChatCompletion action\n    JidoAi.Actions.Anthropic.ChatCompletion.run(\n      %{\n        model: \"claude-3-5-haiku-latest\",\n        messages: [\n          %{\n            role: \"user\",\n            content: params.query\n          }\n        ],\n        response_model: Schema,\n        temperature: 0.5,\n        max_tokens: 1000\n      },\n      %{}\n    )\n    |> case do\n      {:ok, %{result: politician}} -> {:ok, %{result: politician}}\n      {:error, reason} -> {:error, reason}\n    end\n  end\nend\n\n# Run the workflow\niex> {:ok, result} = Jido.Exec.run(JidoAi.Examples.Politician, %{query: \"Tell me about Barack Obama's political career\"})\niex> result.result\n%JidoAi.Examples.Politician.Schema{\n  first_name: \"Barack\",\n  last_name: \"Obama\",\n  offices_held: [\n    %JidoAi.Examples.Politician.Schema.Office{\n      office: :senate,\n      from_date: ~D[2005-01-03],\n      to_date: ~D[2008-11-16]\n    },\n    %JidoAi.Examples.Politician.Schema.Office{\n      office: :president,\n      from_date: ~D[2009-01-20],\n      to_date: ~D[2017-01-20]\n    }\n  ]\n}\n```\n\nThe example demonstrates how JidoAi can:\n\n- Write Actions that can wrap other Actions\n- Use Jido.Exec to orchestrate AI operations\n- Parse natural language queries about politicians\n- Return structured data using Ecto schemas\n- Handle complex nested data structures\n- Provide type validation through Ecto's type system\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#example"},{"type":"extras","title":"LLM Keyring - Jido AI","doc":"The Jido.AI application includes a Keyring system that manages API keys for various LLM providers. The Keyring is a singleton GenServer that helps to manage LLM keys for convenience, not for security.","ref":"readme.html#llm-keyring"},{"type":"extras","title":"Key Sources - Jido AI","doc":"Keys are loaded with the following priority:\n\n1. Environment variables (highest priority)\n2. Application environment\n3. Default values (lowest priority)","ref":"readme.html#key-sources"},{"type":"extras","title":"Session-based Keys - Jido AI","doc":"Keys can also be set on a per-session (per-process) basis. This allows different parts of your application to use different API keys without affecting other processes.","ref":"readme.html#session-based-keys"},{"type":"extras","title":"Usage - Jido AI","doc":"```elixir\n# Get a key (checks session keys first, then environment keys)\napi_key = Jido.AI.Keyring.get_key(:anthropic)\n\n# Get only the environment-level key\nenv_key = Jido.AI.Keyring.get_env_key(:anthropic)\n\n# Set a session-specific key (only affects the current process)\nJido.AI.Keyring.set_session_key(:anthropic, \"my_session_key\")\n\n# Clear a session key\nJido.AI.Keyring.clear_session_key(:anthropic)\n\n# Clear all session keys for the current process\nJido.AI.Keyring.clear_all_session_keys()\n\n# Check if a key is valid (non-nil and non-empty)\nJido.AI.Keyring.has_valid_key?(api_key)\n\n# Test if a key is valid by making an API request\nJido.AI.Keyring.test_key(:anthropic, api_key)\n```","ref":"readme.html#usage"},{"type":"extras","title":"Configuration - Jido AI","doc":"You can configure keys in your `config.exs` file:\n\n```elixir\nconfig :jido_ai, :instructor,\n  anthropic: [\n    api_key: \"your_anthropic_key\"\n  ]\n\nconfig :jido_ai, :openai,\n  api_key: \"your_openai_key\"\n```\n\nOr using environment variables:\n\n```\nANTHROPIC_API_KEY=your_anthropic_key\nOPENAI_API_KEY=your_openai_key\n```\n\nEnvironment variables take precedence over application configuration.","ref":"readme.html#configuration"},{"type":"extras","title":"Getting Started","doc":"# Getting Started with Jido AI\n\nWelcome to **Jido AI**, an Elixir library that brings robust Large Language Model (LLM) capabilities, multi-modal generation, and structured data handling into your Elixir applications. This guide will walk you through the basic setup and show you how to run your first AI action using Jido AI.\n\n---","ref":"getting-started.html"},{"type":"extras","title":"Overview - Getting Started","doc":"Jido AI leverages [Jido](https://hexdocs.pm/jido) (a workflow orchestration tool) and ties in various model providers—OpenAI, Anthropic, and more—to enable:\n\n- **Text Generation & Chat Completion**: Interact with LLMs in your Elixir code.\n- **Structured Data Generation**: Produce validated JSON objects or arrays using JSON schemas.\n- **Multi-Modal Generation**: Create images and audio from text prompts.\n- **Configurable Providers**: Switch between or extend providers at runtime.\n\n---","ref":"getting-started.html#overview"},{"type":"extras","title":"Installation - Getting Started","doc":"1. Add `jido_ai` to your `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:jido, \"~> 1.1.0\"}\n    {:jido_ai, \"~> 0.1.0\"}\n  ]\nend\n```\n\n2. Fetch and compile:\n\n```\nmix deps.get\nmix compile\n```\n\n3. Verify installation by running the test suite:\n\n```\nmix test\n```","ref":"getting-started.html#installation"},{"type":"extras","title":"Managing Keys","doc":"# Jido AI Keyring","ref":"keyring.html"},{"type":"extras","title":"Overview - Managing Keys","doc":"The Jido AI Keyring helps manage LLM API Keys. It provides a centralized system for managing environment variables, API keys, and configuration settings across different environments and execution contexts with a hierarchical, context-aware approach.","ref":"keyring.html#overview"},{"type":"extras","title":"Key Features - Managing Keys","doc":"- **Hierarchical Configuration**: Values are loaded with explicit precedence rules\n- **Process-Specific Overrides**: Isolate configuration changes to specific processes with per-PID session values\n- **Runtime Configuration**: Change settings without application restarts\n- **Default Fallbacks**: Specify fallback values for missing configurations\n- **Consistent API Provider Integration**: Seamless integration with various AI provider configurations\n- **Automatic Startup**: Started automatically by `Jido.AI.Application`","ref":"keyring.html#key-features"},{"type":"extras","title":"Conceptual Model - Managing Keys","doc":"The Keyring implements a hierarchical lookup system with the following precedence (highest to lowest):\n\n1. **Session Values**: Process-specific overrides (stored in ETS)\n2. **Environment Variables**: System-wide environment settings (via Dotenvy)\n3. **Application Environment**: Configuration in your application\n4. **Default Values**: Fallbacks for missing configurations\n\n```\nSession Values → Environment Variables → Application Environment → Default Values\n                         (highest)                                    (lowest)\n```","ref":"keyring.html#conceptual-model"},{"type":"extras","title":"Basic Usage - Managing Keys","doc":"","ref":"keyring.html#basic-usage"},{"type":"extras","title":"Installation - Managing Keys","doc":"The Keyring is automatically started by the `Jido.AI.Application` module, so you don't need to add it to your application's supervision tree. The relevant implementation is:\n\n```elixir\n# In Jido.AI.Application\ndefmodule Jido.AI.Application do\n  use Application\n\n  @impl true\n  def start(_type, _args) do\n    children = [\n      # Start the Keyring GenServer\n      Jido.AI.Keyring\n    ]\n\n    opts = [strategy: :one_for_one, name: Jido.AI.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\nend\n```","ref":"keyring.html#installation"},{"type":"extras","title":"Retrieving Configuration Values - Managing Keys","doc":"To retrieve values from the Keyring:\n\n```elixir\n# Basic usage with default value\napi_key = Jido.AI.Keyring.get(:openai_api_key, \"default_key\")\n\n# Without a default (returns nil if not found)\nmodel_name = Jido.AI.Keyring.get(:model_name)\n\n# High-level API convenience function\napi_key = Jido.AI.get(:anthropic_api_key)\n```","ref":"keyring.html#retrieving-configuration-values"},{"type":"extras","title":"Setting Session Values - Managing Keys","doc":"Session values provide process-specific configuration overrides. Each process can have its own set of configuration values, which take precedence over environment values:\n\n```elixir\n# Override a value for the current process only\nJido.AI.Keyring.set_session_value(:openai_api_key, \"test_key_for_this_process\")\n\n# Using high-level API\nJido.AI.set_session_value(:anthropic_api_key, \"my_session_key\")\n\n# Set a value for a specific process (not just the current one)\nother_pid = spawn(fn -> receive do :ok -> :ok end end)\nJido.AI.Keyring.set_session_value(:openai_api_key, \"process_specific_key\", other_pid)\n\n# Later in the same process\napi_key = Jido.AI.Keyring.get(:openai_api_key)  # Returns \"test_key_for_this_process\"\n```","ref":"keyring.html#setting-session-values"},{"type":"extras","title":"Clearing Session Values - Managing Keys","doc":"Remove process-specific overrides when no longer needed:\n\n```elixir\n# Clear a specific session value for the current process\nJido.AI.Keyring.clear_session_value(:openai_api_key)\n\n# Clear a specific session value for another process\nJido.AI.Keyring.clear_session_value(:openai_api_key, other_pid)\n\n# Clear all session values for the current process\nJido.AI.Keyring.clear_all_session_values()\n\n# Clear all session values for another process\nJido.AI.Keyring.clear_all_session_values(other_pid)\n\n# Using high-level API (always operates on current process)\nJido.AI.clear_session_value(:anthropic_api_key)\nJido.AI.clear_all_session_values()\n```","ref":"keyring.html#clearing-session-values"},{"type":"extras","title":"Configuration Sources - Managing Keys","doc":"","ref":"keyring.html#configuration-sources"},{"type":"extras","title":"Environment Variables with Dotenvy - Managing Keys","doc":"The Keyring uses the Dotenvy library under the hood to load environment variables from multiple sources. It automatically loads variables from several locations in a specific order:\n\n```\n./envs/.env                    # Base environment file\n./envs/.{environment}.env      # Environment-specific (dev/test/prod)\n./envs/.{environment}.overrides.env  # Local overrides (not committed to source control)\nSystem environment variables   # OS-level environment variables\n```\n\nDotenvy handles type conversion, with all values loaded as strings by default. For more complex types, use the application environment configuration.\n\nEnvironment variables are converted to atoms by:\n1. Converting to lowercase\n2. Replacing non-alphanumeric characters with underscores\n\nExample:\n```\nOPENAI_API_KEY=sk-123456789 → :openai_api_key\n```\n\nHere's how the implementation loads environment variables:\n\n```elixir\ndefp load_from_env do\n  env_dir_prefix = Path.expand(\"./envs/\")\n\n  Dotenvy.source!([\n    Path.join(File.cwd!(), \".env\"),\n    Path.absname(\".env\", env_dir_prefix),\n    Path.absname(\".#{Mix.env()}.env\", env_dir_prefix),\n    Path.absname(\".#{Mix.env()}.overrides.env\", env_dir_prefix),\n    System.get_env()\n  ])\n  |> Enum.reduce(%{}, fn {key, value}, acc ->\n    atom_key = env_var_to_atom(key)\n    Map.put(acc, atom_key, value)\n  end)\nend\n```","ref":"keyring.html#environment-variables-with-dotenvy"},{"type":"extras","title":"Application Environment - Managing Keys","doc":"Configure values in your `config/config.exs` or environment-specific config files:\n\n```elixir\n# In config/config.exs\nconfig :jido_ai, :keyring, %{\n  openai_api_key: System.get_env(\"OPENAI_API_KEY\"),\n  model_name: \"gpt-4\",\n  temperature: 0.7\n}\n```","ref":"keyring.html#application-environment"},{"type":"extras","title":"Integration with AI Providers - Managing Keys","doc":"The Keyring is designed to seamlessly work with various AI providers in the Jido ecosystem. It's a critical component for the `Model` module and provider adapters:\n\n```elixir\ndefmodule MyAI do\n  alias Jido.AI.Model\n  \n  def generate_response(prompt) do\n    # The API key is automatically retrieved from Keyring\n    {:ok, model} = Model.from({:anthropic, [model: \"claude-3-opus\"]})\n    \n    # Use the model with automatic API key management\n    ChatClient.generate(model, prompt)\n  end\nend\n```","ref":"keyring.html#integration-with-ai-providers"},{"type":"extras","title":"Provider Keys - Managing Keys","doc":"The Keyring looks for provider-specific keys in the following formats:\n\n- OpenAI: `:openai_api_key` or `OPENAI_API_KEY`\n- Anthropic: `:anthropic_api_key` or `ANTHROPIC_API_KEY`\n- OpenRouter: `:openrouter_api_key` or `OPENROUTER_API_KEY`\n- Cloudflare: `:cloudflare_api_key` or `CLOUDFLARE_API_KEY`\n- Google: `:google_api_key` or `GOOGLE_API_KEY`","ref":"keyring.html#provider-keys"},{"type":"extras","title":"Advanced Usage - Managing Keys","doc":"","ref":"keyring.html#advanced-usage"},{"type":"extras","title":"Process Isolation for Testing - Managing Keys","doc":"Session values are isolated to the calling process, making them ideal for testing. The Keyring's implementation uses ETS tables to store process-specific values, indexed by the process PID:\n\n```elixir\ndefmodule MyTest do\n  use ExUnit.Case\n  alias Jido.AI.Keyring\n\n  setup do\n    # Override configuration for this test only\n    Keyring.set_session_value(:anthropic_api_key, \"test_key\")\n    Keyring.set_session_value(:model, \"test-model-name\")\n    \n    on_exit(fn -> \n      # Clean up after the test\n      Keyring.clear_all_session_values()\n    end)\n    \n    :ok\n  end\n  \n  test \"my feature with mocked API key\" do\n    # Test code will use the session values\n    assert MyModule.process() == :expected_result\n  end\nend\n```\n\nUnder the hood, the session storage works by inserting values into an ETS table with the process PID as part of the key:\n\n```elixir\ndef set_session_value(server \\\\ @default_name, key, value, pid \\\\ self()) when is_atom(key) do\n  registry = GenServer.call(server, :get_registry)\n  :ets.insert(registry, {{pid, key}, value})\n  :ok\nend\n```","ref":"keyring.html#process-isolation-for-testing"},{"type":"extras","title":"Named Instances - Managing Keys","doc":"For more complex applications, you can run multiple Keyring instances:\n\n```elixir\n# Start a custom Keyring instance\n{:ok, _pid} = Jido.AI.Keyring.start_link(name: :custom_keyring, registry: :custom_registry)\n\n# Use the custom instance\napi_key = Jido.AI.Keyring.get(:custom_keyring, :openai_api_key)\n```","ref":"keyring.html#named-instances"},{"type":"extras","title":"Value Validation - Managing Keys","doc":"Check if a configuration value is set and non-empty:\n\n```elixir\napi_key = Jido.AI.Keyring.get(:openai_api_key)\n\nif Jido.AI.Keyring.has_value?(api_key) do\n  # Proceed with API request\nelse\n  # Handle missing configuration\n  {:error, \"OpenAI API key not configured\"}\nend\n```\n\nThe Keyring provides a helper function to check if values are valid:\n\n```elixir\n@spec has_value?(term()) :: boolean()\ndef has_value?(nil), do: false\ndef has_value?(\"\"), do: false\ndef has_value?(value) when is_binary(value), do: true\ndef has_value?(_), do: false\n```","ref":"keyring.html#value-validation"},{"type":"extras","title":"Debugging Tips - Managing Keys","doc":"List all available configuration keys:\n\n```elixir\nJido.AI.Keyring.list()\n# => [:openai_api_key, :anthropic_api_key, :model_name, ...]\n```\n\nCompare environment and session values:\n\n```elixir\n# Get the environment value directly\nenv_value = Jido.AI.Keyring.get_env_value(:openai_api_key)\n\n# Get the session value\nsession_value = Jido.AI.Keyring.get_session_value(:openai_api_key)\n\n# Get the effective value (session overrides environment)\neffective_value = Jido.AI.Keyring.get(:openai_api_key)\n```","ref":"keyring.html#debugging-tips"},{"type":"extras","title":"Implementation Details - Managing Keys","doc":"","ref":"keyring.html#implementation-details"},{"type":"extras","title":"ETS Table for Session Storage - Managing Keys","doc":"The Keyring uses ETS (Erlang Term Storage) for session values, providing:\n\n- Efficient key-value lookups\n- Process-specific storage\n- Automatic cleanup when processes terminate","ref":"keyring.html#ets-table-for-session-storage"},{"type":"extras","title":"Loading from Environment Files - Managing Keys","doc":"The implementation leverages Dotenvy for sophisticated environment file loading:\n\n```elixir\nenv_dir_prefix = Path.expand(\"./envs/\")\n\nDotenvy.source!([\n  Path.join(File.cwd!(), \".env\"),\n  Path.absname(\".env\", env_dir_prefix),\n  Path.absname(\".#{Mix.env()}.env\", env_dir_prefix),\n  Path.absname(\".#{Mix.env()}.overrides.env\", env_dir_prefix),\n  System.get_env()\n])\n```","ref":"keyring.html#loading-from-environment-files"},{"type":"extras","title":"Conversion of Environment Variables - Managing Keys","doc":"Environment variables are automatically converted to atom keys for consistent access:\n\n```elixir\ndefp env_var_to_atom(env_var) do\n  env_var\n  |> String.downcase()\n  |> String.replace(~r/[^a-z0-9_]/, \"_\")\n  |> String.to_atom()\nend\n```","ref":"keyring.html#conversion-of-environment-variables"},{"type":"extras","title":"Common Questions - Managing Keys","doc":"","ref":"keyring.html#common-questions"},{"type":"extras","title":"How does the Keyring handle environment variable types? - Managing Keys","doc":"By default, all values are loaded as strings. For more complex types, use the application environment to define typed values:\n\n```elixir\n# In config/config.exs\nconfig :jido_ai, :keyring, %{\n  max_tokens: 2048,  # integer\n  temperature: 0.7,  # float\n  use_cache: true    # boolean\n}\n```","ref":"keyring.html#how-does-the-keyring-handle-environment-variable-types"},{"type":"extras","title":"Can I modify environment values at runtime? - Managing Keys","doc":"The Keyring primarily focuses on reading environment values, but you can simulate updates using session values for the current process.","ref":"keyring.html#can-i-modify-environment-values-at-runtime"},{"type":"extras","title":"What happens if a process terminates? - Managing Keys","doc":"Session values are automatically cleaned up when a process terminates, preventing memory leaks.","ref":"keyring.html#what-happens-if-a-process-terminates"},{"type":"extras","title":"How does the Keyring handle multiple environments? - Managing Keys","doc":"The Keyring loads environment-specific files based on the current Mix environment:\n\n```elixir\nPath.absname(\".#{Mix.env()}.env\", env_dir_prefix)\n```\n\nThis allows for different configurations in development, test, and production environments.","ref":"keyring.html#how-does-the-keyring-handle-multiple-environments"},{"type":"extras","title":"Common Questions - Managing Keys","doc":"","ref":"keyring.html#common-questions"},{"type":"extras","title":"How does the Keyring handle environment variable types? - Managing Keys","doc":"The Keyring uses Dotenvy under the hood, which loads values as strings by default. For typed values, use the application environment configuration:\n\n```elixir\n# In config/config.exs\nconfig :jido_ai, :keyring, %{\n  max_tokens: 2048,  # integer\n  temperature: 0.7,  # float\n  use_cache: true    # boolean\n}\n```","ref":"keyring.html#how-does-the-keyring-handle-environment-variable-types"},{"type":"extras","title":"What happens if a process terminates? - Managing Keys","doc":"Session values are automatically cleaned up when a process terminates, as they're stored in an ETS table with the process PID as part of the key. This prevents memory leaks.","ref":"keyring.html#what-happens-if-a-process-terminates"},{"type":"extras","title":"Can I get values for other processes? - Managing Keys","doc":"Yes, the Keyring supports specifying a PID when getting session values:\n\n```elixir\n# Get a value for another process\nother_pid = spawn(fn -> receive do :ok -> :ok end end)\nvalue = Jido.AI.Keyring.get_session_value(:my_key, other_pid)\n```","ref":"keyring.html#can-i-get-values-for-other-processes"},{"type":"extras","title":"Is the Keyring thread-safe? - Managing Keys","doc":"Yes, the Keyring uses ETS for session storage and GenServer for environment values, both of which are thread-safe in Elixir's concurrent environment.","ref":"keyring.html#is-the-keyring-thread-safe"},{"type":"extras","title":"Prompting","doc":"# Jido.AI.Prompt","ref":"prompt.html"},{"type":"extras","title":"Introduction - Prompting","doc":"The `Jido.AI.Prompt` module provides a structured approach to managing conversations with Large Language Models (LLMs). Instead of working with simple strings, this module enables developers to create, version, manipulate, and render sophisticated prompts with dynamic content substitution.","ref":"prompt.html#introduction"},{"type":"extras","title":"Core Concepts - Prompting","doc":"","ref":"prompt.html#core-concepts"},{"type":"extras","title":"Understanding the Prompt Architecture - Prompting","doc":"The `Jido.AI.Prompt` module is built around a central struct with these key components:\n\n```elixir\ntypedstruct do\n  field(:id, String.t(), default: Jido.Util.generate_id())\n  field(:version, non_neg_integer(), default: 1)\n  field(:history, list(map()), default: [])\n  field(:messages, list(MessageItem.t()), default: [])\n  field(:params, map(), default: %{})\n  field(:metadata, map(), default: %{})\nend\n```\n\n- **Messages**: The core content of the prompt, each with a role (system, user, assistant)\n- **Parameters**: Values that can be interpolated into templated messages\n- **Versioning**: Built-in tracking of prompt changes with history and rollback capability","ref":"prompt.html#understanding-the-prompt-architecture"},{"type":"extras","title":"Getting Started - Prompting","doc":"","ref":"prompt.html#getting-started"},{"type":"extras","title":"Creating Basic Prompts - Prompting","doc":"```elixir\nalias Jido.AI.Prompt\n\n# Simple prompt with a single message\nprompt = Prompt.new(:user, \"How do I use Elixir's pattern matching?\")\n\n# Multiple messages\ncomplex_prompt = Prompt.new(%{\n  messages: [\n    %{role: :system, content: \"You are a programming assistant\"},\n    %{role: :user, content: \"Explain pattern matching in Elixir\"}\n  ]\n})\n```","ref":"prompt.html#creating-basic-prompts"},{"type":"extras","title":"Rendering Prompts for LLM Submission - Prompting","doc":"To convert your prompt into a format suitable for LLM API calls:\n\n```elixir\n# Get a list of message maps\nmessages = Prompt.render(prompt)\n# => [%{role: :user, content: \"How do I use Elixir's pattern matching?\"}]\n\n# For debugging or text-based APIs\ntext_format = Prompt.to_text(prompt)\n# => \"[user] How do I use Elixir's pattern matching?\"\n```","ref":"prompt.html#rendering-prompts-for-llm-submission"},{"type":"extras","title":"Working with Templates - Prompting","doc":"The module's true power emerges when using templates for dynamic content generation.","ref":"prompt.html#working-with-templates"},{"type":"extras","title":"Template-Based Messages - Prompting","doc":"```elixir\n# Create a prompt with EEx templates\ntemplate_prompt = Prompt.new(%{\n  messages: [\n    %{role: :system, content: \"You are a <%= @assistant_type %>\", engine: :eex},\n    %{role: :user, content: \"Help me with <%= @topic %>\", engine: :eex}\n  ],\n  params: %{\n    assistant_type: \"programming assistant\",\n    topic: \"recursion\"\n  }\n})\n\n# Render with default parameters\nmessages = Prompt.render(template_prompt)\n\n# Override parameters during rendering\nmessages = Prompt.render(template_prompt, %{topic: \"list comprehensions\"})\n```","ref":"prompt.html#template-based-messages"},{"type":"extras","title":"Template Engines - Prompting","doc":"The module supports different template engines:\n\n```elixir\n# EEx (Embedded Elixir) - default\neex_message = %{\n  role: :user, \n  content: \"My name is <%= @name %>, I need help with <%= @topic %>\", \n  engine: :eex\n}\n\n# Liquid templates\nliquid_message = %{\n  role: :user, \n  content: \"My name is {{ name }}, I need help with {{ topic }}\", \n  engine: :liquid\n}\n```","ref":"prompt.html#template-engines"},{"type":"extras","title":"Building Conversations - Prompting","doc":"","ref":"prompt.html#building-conversations"},{"type":"extras","title":"Adding Messages - Prompting","doc":"```elixir\n# Start with a system message\nprompt = Prompt.new(:system, \"You are a helpful assistant\")\n\n# Add a user question\nprompt = Prompt.add_message(prompt, :user, \"How does pattern matching work?\")\n\n# Add an assistant response\nprompt = Prompt.add_message(prompt, :assistant, \"Pattern matching in Elixir allows...\")\n\n# Add a follow-up question\nprompt = Prompt.add_message(prompt, :user, \"Can you show an example?\")\n```","ref":"prompt.html#adding-messages"},{"type":"extras","title":"Message Roles and Validation - Prompting","doc":"The module enforces rules about message roles:\n\n1. Only one system message is allowed\n2. If present, the system message must be the first message\n\n```elixir\n# This works - system message first\nvalid_prompt = Prompt.new(%{\n  messages: [\n    %{role: :system, content: \"You are an assistant\"},\n    %{role: :user, content: \"Hello\"}\n  ]\n})\n\n# This raises an error - system message not first\n# invalid_prompt = Prompt.new(%{\n#   messages: [\n#     %{role: :user, content: \"Hello\"},\n#     %{role: :system, content: \"You are an assistant\"}\n#   ]\n# })\n```","ref":"prompt.html#message-roles-and-validation"},{"type":"extras","title":"Versioning and History - Prompting","doc":"","ref":"prompt.html#versioning-and-history"},{"type":"extras","title":"Creating New Versions - Prompting","doc":"```elixir\n# Start with a basic prompt\nprompt = Prompt.new(:user, \"Initial question\")\n\n# Create version 2 with an additional message\nv2 = Prompt.new_version(prompt, fn p -> \n  Prompt.add_message(p, :assistant, \"Initial response\") \nend)\n\n# Create version 3\nv3 = Prompt.new_version(v2, fn p ->\n  Prompt.add_message(p, :user, \"Follow-up question\")\nend)\n```","ref":"prompt.html#creating-new-versions"},{"type":"extras","title":"Managing Versions - Prompting","doc":"```elixir\n# List all versions\nversions = Prompt.list_versions(v3)  # [3, 2, 1]\n\n# Retrieve a specific version\n{:ok, original} = Prompt.get_version(v3, 1)\n\n# Compare versions\n{:ok, diff} = Prompt.compare_versions(v3, 3, 1)\n# => %{added_messages: [...], removed_messages: [...]}\n```","ref":"prompt.html#managing-versions"},{"type":"extras","title":"Advanced Usage Patterns - Prompting","doc":"","ref":"prompt.html#advanced-usage-patterns"},{"type":"extras","title":"Parameter Substitution with Logic - Prompting","doc":"```elixir\ntemplate = \"\"\"\n<%= if @advanced_mode do %>\nYou are an expert-level <%= @domain %> consultant. Use technical terminology and provide in-depth explanations.\n<% else %>\nYou are a helpful <%= @domain %> assistant. Explain concepts simply and avoid technical jargon.\n<% end %>\n\"\"\"\n\nprompt = Prompt.new(%{\n  messages: [\n    %{role: :system, content: template, engine: :eex}\n  ],\n  params: %{\n    advanced_mode: false,\n    domain: \"machine learning\"\n  }\n})\n```","ref":"prompt.html#parameter-substitution-with-logic"},{"type":"extras","title":"Creating Reusable Templates - Prompting","doc":"For common prompt patterns, leverage the `Template` module:\n\n```elixir\nalias Jido.AI.Prompt.Template\n\n# Use template to create prompts\nprompt = Prompt.new(%{\n  messages: [\n    %{role: :system, content: \"You are a code reviewer\"},\n    %{role: :user, content: Template.format(code_review_template, %{\n      language: \"elixir\",\n      code: \"defmodule Math do\\n  def add(a, b), do: a + b\\nend\",\n      focus_areas: [\"Performance\", \"Readability\", \"Error handling\"]\n    }), engine: :none}\n  ]\n})\n```","ref":"prompt.html#creating-reusable-templates"},{"type":"extras","title":"Integration with AI Actions - Prompting","doc":"Jido.AI includes action modules that use these prompts for LLM interactions:\n\n```elixir\n# Create a prompt\nprompt = Prompt.new(:user, \"What is the Elixir programming language?\")\n\n# Use with ChatResponse action\n{:ok, result} = Jido.AI.Actions.Instructor.ChatResponse.run(%{\n  model: %Jido.AI.Model{provider: :anthropic, model: \"claude-3-haiku-20240307\"},\n  prompt: prompt,\n  temperature: 0.7\n}, %{})\n\n# Response is in result.response\nIO.puts(result.response)\n```","ref":"prompt.html#integration-with-ai-actions"},{"type":"extras","title":"Error Handling and Validation - Prompting","doc":"","ref":"prompt.html#error-handling-and-validation"},{"type":"extras","title":"Validating Prompt Options - Prompting","doc":"```elixir\ncase Prompt.validate_prompt_opts(user_input) do\n  {:ok, validated_prompt} ->\n    # Use the validated prompt\n    messages = Prompt.render(validated_prompt)\n    # Call LLM with messages\n    \n  {:error, reason} ->\n    # Handle validation error\n    Logger.error(\"Invalid prompt: #{reason}\")\nend\n```","ref":"prompt.html#validating-prompt-options"},{"type":"extras","title":"Template Rendering Errors - Prompting","doc":"Handle potential rendering errors when working with templates:\n\n```elixir\ntry do\n  messages = Prompt.render(template_prompt)\n  # Use rendered messages\nrescue\n  e in Jido.AI.Error ->\n    # Handle template rendering errors\n    Logger.error(\"Failed to render prompt: #{Exception.message(e)}\")\nend\n```","ref":"prompt.html#template-rendering-errors"},{"type":"extras","title":"Best Practices - Prompting","doc":"1. **Separate Structure from Content**\n   - Use templates to isolate prompt structure from variable content\n   - Create reusable prompt patterns for common use cases\n\n2. **Leverage Role-Based Messaging**\n   - Use system messages for overall instruction\n   - Use user messages for specific queries\n   - Use assistant messages to provide context from previous responses\n\n3. **Manage Complexity with Versioning**\n   - Use the built-in versioning for complex, evolving prompts\n   - Compare versions when debugging unexpected LLM behaviors\n\n4. **Validate and Sanitize Inputs**\n   - Use `sanitize_inputs` to prevent template injection when working with user inputs\n   - Validate inputs before rendering templates\n\n5. **Progressive Enhancement**\n   - Start with simple prompts and gradually add complexity\n   - Test prompt variations to optimize LLM responses","ref":"prompt.html#best-practices"},{"type":"extras","title":"Example Workflow: Implementing a Chain-of-Thought - Prompting","doc":"```elixir\ndefmodule ChainOfThoughtPrompt do\n  alias Jido.AI.Prompt\n  alias Jido.AI.Model\n  alias Jido.AI.Actions.Instructor.ChatResponse\n  \n  def solve_problem(problem_statement) do\n    # Create a base prompt with system instruction\n    prompt = Prompt.new(:system, \"\"\"\n    You are a problem-solving assistant that uses step-by-step reasoning.\n    Always break down problems into clear steps before providing the final answer.\n    \"\"\")\n    \n    # Add the user's problem\n    prompt = Prompt.add_message(prompt, :user, problem_statement)\n    \n    # Get initial response with reasoning\n    {:ok, init_result} = ChatResponse.run(%{\n      model: %Model{provider: :anthropic, model: \"claude-3-haiku-20240307\"},\n      prompt: prompt\n    }, %{})\n    \n    # Add the response to the conversation\n    prompt = Prompt.add_message(prompt, :assistant, init_result.response)\n    \n    # Add a follow-up to verify the solution\n    prompt = Prompt.add_message(prompt, :user, \"\"\"\n    Thank you for the step-by-step solution. \n    Can you check your work and ensure the final answer is correct?\n    \"\"\")\n    \n    # Get verification response\n    {:ok, final_result} = ChatResponse.run(%{\n      model: %Model{provider: :anthropic, model: \"claude-3-haiku-20240307\"},\n      prompt: prompt\n    }, %{})\n    \n    # Return the complete conversation and final response\n    %{\n      conversation: Prompt.to_text(prompt),\n      final_answer: final_result.response\n    }\n  end\nend\n```","ref":"prompt.html#example-workflow-implementing-a-chain-of-thought"},{"type":"extras","title":"Conclusion - Prompting","doc":"The `Jido.AI.Prompt` module provides a powerful foundation for building sophisticated LLM interactions in Elixir. By leveraging its structured approach to prompt management, templates, and version control, developers can create robust, maintainable, and dynamic LLM-powered applications.\n\nBy mastering these techniques, you'll be able to create prompt systems that adapt to changing requirements, maintain context across complex conversations, and deliver consistent, high-quality interactions with large language models.","ref":"prompt.html#conclusion"},{"type":"extras","title":"LLM Providers","doc":"# Jido AI Provider Integration Guide","ref":"providers.html"},{"type":"extras","title":"Overview - LLM Providers","doc":"Jido AI delivers a framework for integrating multiple AI providers into your Jido Agents. This guide explores the provider architecture, model configuration, and best practices for leveraging AI services through a unified interface. The provider system enables seamless switching between services like Anthropic, OpenAI, and more, while maintaining consistent interaction patterns. It builds upon popular Hex Packages to manage the AI integration such as `Instructor`, `Langchain`, and `OpenaiEx`.","ref":"providers.html#overview"},{"type":"extras","title":"Provider Architecture - LLM Providers","doc":"Jido AI implements a modular architecture where each provider adapter conforms to the `Jido.AI.Model.Provider.Adapter` behavior. This standardizes how you interact with diverse AI services while preserving their unique capabilities.","ref":"providers.html#provider-architecture"},{"type":"extras","title":"Core Components - LLM Providers","doc":"- **Provider Adapters**: Specialized modules implementing provider-specific API requirements\n- **Model Registry**: Central repository for discovering and accessing available models\n- **Credential Management**: Secure API key handling through the Keyring system","ref":"providers.html#core-components"},{"type":"extras","title":"Available Providers - LLM Providers","doc":"Jido AI supports multiple provider integrations:\n\n| Provider | Module | Description |\n|----------|--------|-------------|\n| Anthropic | `Jido.AI.Provider.Anthropic` | Access to Claude models for advanced natural language tasks |\n| OpenAI | `Jido.AI.Provider.OpenAI` | Access to GPT models, DALL-E, and embeddings |\n| OpenRouter | `Jido.AI.Provider.OpenRouter` | Unified access to multiple AI providers through a single API |\n| Cloudflare | `Jido.AI.Provider.Cloudflare` | Access to Cloudflare's AI Gateway and Workers AI models |","ref":"providers.html#available-providers"},{"type":"extras","title":"Model Configuration - LLM Providers","doc":"","ref":"providers.html#model-configuration"},{"type":"extras","title":"Creating a Model - LLM Providers","doc":"You can create a model instance using the `Jido.AI.Model.from/1` function:\n\n```elixir\n# Using the Anthropic provider with Claude\n{:ok, model} = Jido.AI.Model.from({:anthropic, [\n  model: \"claude-3-5-haiku\",\n  temperature: 0.7,\n  max_tokens: 1024\n]})\n\n# Using OpenAI provider with GPT-4\n{:ok, gpt4_model} = Jido.AI.Model.from({:openai, [\n  model: \"gpt-4\",\n  temperature: 0.5\n]})\n\n# Using OpenRouter for model access\n{:ok, router_model} = Jido.AI.Model.from({:openrouter, [\n  model: \"anthropic/claude-3-opus-20240229\",\n  max_tokens: 2000\n]})\n```","ref":"providers.html#creating-a-model"},{"type":"extras","title":"Model Structure - LLM Providers","doc":"The `Jido.AI.Model` struct offers a unified representation of any AI model:\n\n```elixir\n%Jido.AI.Model{\n  id: String.t(),              # Unique identifier for the model\n  name: String.t(),            # Human-readable name\n  provider: atom(),            # Provider identifier (e.g., :anthropic, :openai)\n  model: String.t(),           # Provider-specific model identifier\n  base_url: String.t(),        # API base URL\n  api_key: String.t(),         # API key for authentication\n  temperature: float(),        # Temperature setting for generation\n  max_tokens: non_neg_integer(), # Maximum tokens to generate\n  max_retries: non_neg_integer(), # Maximum number of retry attempts\n  architecture: Architecture.t(), # Model architecture information\n  created: integer(),          # Creation timestamp\n  description: String.t(),     # Model description\n  endpoints: list(Endpoint.t()) # Available API endpoints\n}\n```","ref":"providers.html#model-structure"},{"type":"extras","title":"API Key Management - LLM Providers","doc":"Jido AI provides flexible API key management through the `Jido.AI.Keyring` module:\n\n```elixir\n# Set an API key for a provider\nJido.AI.Keyring.set_session_value(:anthropic_api_key, \"your-api-key\")\n\n# Get an API key (checks session, environment variables, and default config)\napi_key = Jido.AI.Keyring.get(:anthropic_api_key)\n\n# Create a model using the stored API key (automatically retrieves from Keyring)\n{:ok, model} = Jido.AI.Model.from({:anthropic, [model: \"claude-3-5-haiku\"]})\n```\n\nAPI keys can be provided through multiple methods (in order of precedence):\n1. Direct specification in model options\n2. Session values in the `Jido.AI.Keyring` module\n3. Environment variables (e.g., `ANTHROPIC_API_KEY`, `OPENAI_API_KEY`)\n4. Application configuration","ref":"providers.html#api-key-management"},{"type":"extras","title":"Prompt Management - LLM Providers","doc":"Jido AI includes a comprehensive prompt management system for creating, formatting, and organizing prompts:\n\n```elixir\n# Create a simple prompt\nprompt = Jido.AI.Prompt.new(:user, \"Explain quantum computing\")\n\n# Create a prompt with a system message and user message\nprompt = Jido.AI.Prompt.new(%{\n  messages: [\n    %{role: :system, content: \"You are a helpful assistant specializing in physics\"},\n    %{role: :user, content: \"Explain quantum computing\"}\n  ]\n})\n\n# Create a templated prompt with parameter substitution\ntemplate = Jido.AI.Prompt.Template.from_string!(\n  \"Explain <%= @topic %> in <%= @style %> terms\"\n)\n\n# Format the template with values\nformatted = Jido.AI.Prompt.Template.format(template, %{\n  topic: \"quantum computing\",\n  style: \"simple\"\n})\n```","ref":"providers.html#prompt-management"},{"type":"extras","title":"Provider-Specific Configuration - LLM Providers","doc":"","ref":"providers.html#provider-specific-configuration"},{"type":"extras","title":"Anthropic Provider - LLM Providers","doc":"```elixir\n{:ok, claude_model} = Jido.AI.Model.from({:anthropic, [\n  model: \"claude-3-7-sonnet\",\n  temperature: 0.3,\n  max_tokens: 2048\n]})\n```\n\nKey configuration options:\n- `model`: Claude model identifier (e.g., \"claude-3-7-sonnet\", \"claude-3-5-haiku\")\n- `temperature`: Controls randomness (0.0 to 1.0)\n- `max_tokens`: Maximum tokens to generate","ref":"providers.html#anthropic-provider"},{"type":"extras","title":"OpenAI Provider - LLM Providers","doc":"```elixir\n{:ok, openai_model} = Jido.AI.Model.from({:openai, [\n  model: \"gpt-4o\",\n  temperature: 0.7,\n  max_tokens: 1024\n]})\n```\n\nKey configuration options:\n- `model`: OpenAI model identifier (e.g., \"gpt-4o\", \"gpt-3.5-turbo\")\n- `temperature`: Controls randomness (0.0 to 2.0)\n- `max_tokens`: Maximum tokens to generate","ref":"providers.html#openai-provider"},{"type":"extras","title":"OpenRouter Provider - LLM Providers","doc":"```elixir\n{:ok, router_model} = Jido.AI.Model.from({:openrouter, [\n  model: \"anthropic/claude-3-opus-20240229\",\n  max_tokens: 2000\n]})\n```\n\nKey configuration options:\n- `model`: Provider and model in format \"provider/model\"\n- `temperature`: Controls randomness (0.0 to 1.0)\n- `max_tokens`: Maximum tokens to generate","ref":"providers.html#openrouter-provider"},{"type":"extras","title":"Cloudflare Provider - LLM Providers","doc":"```elixir\n{:ok, cloudflare_model} = Jido.AI.Model.from({:cloudflare, [\n  model: \"@cf/meta/llama-3-8b-instruct\",\n  account_id: \"your-account-id\"\n]})\n```\n\nKey configuration options:\n- `model`: Cloudflare model identifier\n- `account_id`: Your Cloudflare account ID\n- `email`: Your Cloudflare account email (optional)","ref":"providers.html#cloudflare-provider"},{"type":"extras","title":"Working with Models - LLM Providers","doc":"","ref":"providers.html#working-with-models"},{"type":"extras","title":"Listing and Fetching Models - LLM Providers","doc":"Each provider implements endpoints to retrieve model information. Jido AI automatically caches this data locally to minimize API calls.\n\n```elixir\n# List all OpenAI models\n{:ok, models} = Jido.AI.Provider.models(:openai)\n\n# List models with refresh option to fetch latest from API\n{:ok, fresh_models} = Jido.AI.Provider.models(:anthropic, refresh: true)\n\n# Get information about a specific model\n{:ok, model_info} = Jido.AI.Provider.get_model(:anthropic, \"claude-3-5-haiku\")\n```","ref":"providers.html#listing-and-fetching-models"},{"type":"extras","title":"Model Caching with Mix Tasks - LLM Providers","doc":"Jido AI provides mix tasks to help manage model information:\n\n```bash\n# Fetch and cache models for a provider\nmix jido.ai.provider.fetch_models --provider anthropic\n\n# Refresh cached models for all providers\nmix jido.ai.provider.fetch_models --all --refresh\n```\n\nThis allows you to pre-cache model information for faster application startup and offline usage.","ref":"providers.html#model-caching-with-mix-tasks"},{"type":"extras","title":"Model Standardization - LLM Providers","doc":"```elixir\n# Standardize model names for comparison\nstandardized_name = Jido.AI.Provider.standardize_model_name(\"claude-3-7-sonnet-20250219\")\n# Returns \"claude-3.7-sonnet\"\n```","ref":"providers.html#model-standardization"},{"type":"extras","title":"Cross-Provider Model Information - LLM Providers","doc":"```elixir\n# Get combined information for equivalent models across providers\n{:ok, combined_info} = Jido.AI.Provider.get_combined_model_info(\"gpt-4\")\n\n# Compare pricing across providers\npricing_by_provider = combined_info.pricing_by_provider\n```","ref":"providers.html#cross-provider-model-information"},{"type":"extras","title":"Action Integration - LLM Providers","doc":"Jido AI includes a range of action modules that work with the provider system to perform common AI tasks. These are covered in detail in separate documentation, but include:\n\n- `Jido.AI.Actions.Instructor.*` - For structured outputs using the Instructor pattern\n- `Jido.AI.Actions.Langchain.*` - For tool/function integration\n- `Jido.AI.Actions.OpenaiEx.*` - For direct OpenAI API interactions\n\nThese actions can be used directly with your Model instances.","ref":"providers.html#action-integration"},{"type":"extras","title":"Error Handling and Resilience - LLM Providers","doc":"```elixir\ndefmodule MyApp.ResilientModelAccess do\n  def with_fallback_providers(task_fn) do\n    # Try multiple providers in sequence\n    providers = [:anthropic, :openai, :openrouter]\n    \n    Enum.reduce_while(providers, {:error, \"All providers failed\"}, fn provider, acc ->\n      case attempt_with_provider(provider, task_fn) do\n        {:ok, result} -> {:halt, {:ok, result}}\n        {:error, _reason} -> {:cont, acc}\n      end\n    end)\n  end\n  \n  defp attempt_with_provider(provider, task_fn) do\n    case create_model_for_provider(provider) do\n      {:ok, model} -> task_fn.(model)\n      error -> error\n    end\n  end\n  \n  defp create_model_for_provider(:anthropic) do\n    Jido.AI.Model.from({:anthropic, [model: \"claude-3-5-haiku\"]})\n  end\n  \n  defp create_model_for_provider(:openai) do\n    Jido.AI.Model.from({:openai, [model: \"gpt-3.5-turbo\"]})\n  end\n  \n  defp create_model_for_provider(:openrouter) do\n    Jido.AI.Model.from({:openrouter, [model: \"google/gemini-pro\"]})\n  end\nend\n```","ref":"providers.html#error-handling-and-resilience"},{"type":"extras","title":"Custom Provider Adapters - LLM Providers","doc":"To create a custom provider adapter, implement the `Jido.AI.Model.Provider.Adapter` behavior:\n\n```elixir\ndefmodule MyApp.CustomProvider do\n  @behaviour Jido.AI.Model.Provider.Adapter\n  \n  @impl true\n  def definition do\n    %Jido.AI.Provider{\n      id: :custom_provider,\n      name: \"Custom Provider\",\n      description: \"My custom AI provider implementation\",\n      type: :direct,\n      api_base_url: \"https://api.custom-provider.com\",\n      requires_api_key: true\n    }\n  end\n  \n  @impl true\n  def base_url do\n    \"https://api.custom-provider.com\"\n  end\n  \n  @impl true\n  def list_models(opts \\\\ []) do\n    # Implementation details...\n  end\n  \n  @impl true\n  def model(model, opts \\\\ []) do\n    # Implementation details...\n  end\n  \n  @impl true\n  def normalize(model, opts \\\\ []) do\n    # Implementation details...\n  end\n  \n  @impl true\n  def request_headers(opts) do\n    # Implementation details...\n  end\n  \n  @impl true\n  def validate_model_opts(opts) do\n    # Implementation details...\n  end\n  \n  @impl true\n  def build(opts) do\n    # Implementation details...\n  end\n  \n  @impl true\n  def transform_model_to_clientmodel(client_atom, model) do\n    # Implementation details...\n  end\nend\n```","ref":"providers.html#custom-provider-adapters"},{"type":"extras","title":"Complete Example: Document Processing - LLM Providers","doc":"```elixir\ndefmodule MyApp.DocumentProcessor do\n  alias Jido.AI.Model\n  alias Jido.AI.Prompt\n  \n  def process_document(text, opts \\\\ []) do\n    with {:ok, model} <- get_model(opts),\n         {:ok, summary} <- summarize_document(model, text),\n         {:ok, topics} <- extract_key_topics(model, text) do\n      {:ok, %{summary: summary, topics: topics}}\n    else\n      {:error, reason} -> {:error, \"Document processing failed: #{inspect(reason)}\"}\n    end\n  end\n  \n  defp get_model(opts) do\n    provider = Keyword.get(opts, :provider, :anthropic)\n    model_id = Keyword.get(opts, :model, \"claude-3-5-haiku\")\n    \n    Model.from({provider, [\n      model: model_id,\n      temperature: 0.3,\n      max_tokens: 1000\n    ]})\n  end\n  \n  defp summarize_document(model, text) do\n    # Implementation using one of the Action modules...\n  end\n  \n  defp extract_key_topics(model, text) do\n    # Implementation using one of the Action modules...\n  end\nend\n```","ref":"providers.html#complete-example-document-processing"},{"type":"extras","title":"Best Practices - LLM Providers","doc":"1. **API Key Security**:\n   - Store API keys in environment variables or use the Keyring module\n   - Implement proper access control for key management\n   - Consider using HashiCorp Vault or similar services for production\n\n2. **Model Selection**:\n   - Use capabilities data to select suitable models for specific tasks\n   - Consider pricing differences between providers for equivalent models\n   - Use smaller models for drafts and larger models for final outputs\n\n3. **Performance Optimization**:\n   - Cache model information using the provided Mix tasks\n   - Set appropriate token limits for each task\n   - Optimize prompts to reduce token usage\n\n4. **Error Resilience**:\n   - Implement provider fallbacks\n   - Use exponential backoff for retries\n   - Have graceful degradation strategies\n\n5. **Integration Architecture**:\n   - Separate model configuration from business logic\n   - Use dependency injection for model instances\n   - Create adapters for specific AI tasks in your domain","ref":"providers.html#best-practices"},{"type":"extras","title":"Conclusion - LLM Providers","doc":"The Jido AI provider system offers a flexible, robust architecture for integrating multiple AI services into your Elixir applications. By leveraging standardized interfaces, you can easily switch between providers, implement fallbacks, and build resilient AI-powered features while maintaining clean, consistent code.\n\nAs AI systems continue to evolve, Jido AI's modular design allows your applications to adapt and incorporate new capabilities with minimal changes to your core logic.","ref":"providers.html#conclusion"},{"type":"extras","title":"Agent & Skill","doc":"# Jido AI Agent and Skill Integration Guide","ref":"agent-skill.html"},{"type":"extras","title":"Introduction - Agent & Skill","doc":"The Jido AI framework extends the core Jido Agent SDK with powerful artificial intelligence capabilities. Rather than being a standalone system, Jido AI builds upon the foundation of the Jido Agent architecture, adding specialized modules for AI model integration, prompt management, and intelligent conversation handling.\n\nThis guide explores how to leverage the AI-specific extensions (`Jido.AI.Agent` and `Jido.AI.Skill`) within the broader Jido ecosystem to create intelligent, conversational agents that maintain the structured architecture and signal-based communication patterns of the core Jido framework.","ref":"agent-skill.html#introduction"},{"type":"extras","title":"Architectural Overview - Agent & Skill","doc":"","ref":"agent-skill.html#architectural-overview"},{"type":"extras","title":"Jido Core Architecture - Agent & Skill","doc":"The Jido framework is built around several key concepts:\n\n- **Agents**: Autonomous entities that process signals and coordinate actions\n- **Skills**: Modular capabilities that can be attached to agents\n- **Signals**: Structured messages passed between components\n- **Actions**: Discrete operations with defined inputs and outputs\n- **Instructions**: Routing directives that map signals to actions","ref":"agent-skill.html#jido-core-architecture"},{"type":"extras","title":"Jido AI Extension - Agent & Skill","doc":"Jido AI extends this foundation with specialized components:\n\n- **AI Agent**: Extends the base `Jido.Agent` with AI capabilities\n- **AI Skill**: A specialized skill for processing AI-related signals\n- **AI Actions**: Pre-built actions for interacting with AI providers\n- **AI Model**: Configuration for connecting to AI providers\n- **AI Prompt**: Structured templates for AI interactions\n\nThis architecture maintains the clean separation of concerns from the core Jido framework while adding robust AI capabilities.","ref":"agent-skill.html#jido-ai-extension"},{"type":"extras","title":"Getting Started with Jido.AI.Agent - Agent & Skill","doc":"","ref":"agent-skill.html#getting-started-with-jido-ai-agent"},{"type":"extras","title":"Understanding the Extension Pattern - Agent & Skill","doc":"The `Jido.AI.Agent` module is not a standalone agent but rather extends the core `Jido.Agent` module with AI-specific functionality:\n\n```elixir\ndefmodule Jido.AI.Agent do\n  use Jido.Agent,\n    name: \"jido_ai_agent\",\n    description: \"General purpose AI agent powered by Jido\",\n    category: \"AI Agents\",\n    tags: [\"AI\", \"Agent\"],\n    vsn: \"0.1.0\"\n    \n  # AI-specific implementation details...\nend\n```\n\nThis means that all core Jido Agent capabilities are available, with additional AI methods provided as extensions.","ref":"agent-skill.html#understanding-the-extension-pattern"},{"type":"extras","title":"Basic Configuration - Agent & Skill","doc":"Creating a Jido AI Agent requires minimal configuration, following the standard Jido Agent initialization pattern with additional AI-specific options:\n\n```elixir\ndefmodule MyApp.SimpleAgent do\n  alias Jido.AI.Agent\n  \n  def start do\n    {:ok, pid} = Agent.start_link(\n      # Standard Jido Agent options\n      log_level: :debug,\n      \n      # AI-specific configuration\n      ai: [\n        model: {:anthropic, model: \"claude-3-haiku-20240307\"},\n        prompt: \"You are a helpful assistant. Please answer the following question:\\n<%= @message %>\"\n      ]\n    )\n    \n    {:ok, pid}\n  end\n  \n  def ask(pid, question) do\n    Agent.chat_response(pid, question)\n  end\nend\n```","ref":"agent-skill.html#basic-configuration"},{"type":"extras","title":"Key Configuration Options - Agent & Skill","doc":"| Option | Description | Example |\n|--------|-------------|---------|\n| `model` | Specifies the AI model to use | `{:anthropic, model: \"claude-3-haiku-20240307\"}` |\n| `prompt` | Template for system instructions | `\"You are a helpful assistant. Answer: <%= @message %>\"` |\n| `tools` | List of Jido Actions the agent can use | `[Jido.Actions.Weather, Jido.Actions.Search]` |\n| `chat_action` | The Jido Action to handle chat responses | `Jido.AI.Actions.Instructor.ChatResponse` |\n| `tool_action` | The Jido Action to handle tool-based responses | `Jido.AI.Actions.Langchain.ToolResponse` |","ref":"agent-skill.html#key-configuration-options"},{"type":"extras","title":"Understanding Jido.AI.Skill - Agent & Skill","doc":"The `Jido.AI.Skill` module is a specialized Jido Skill implementation that handles AI-specific signal patterns:\n\n```elixir\ndefmodule Jido.AI.Skill do\n  use Jido.Skill,\n    name: \"jido_ai_skill\",\n    description: \"General purpose AI skill powered by Jido\",\n    vsn: \"0.1.0\",\n    opts_key: @ai_opts_key,\n    opts_schema: @ai_opts_schema,\n    signal_patterns: [\n      \"jido.ai.**\"\n    ]\n    \n  # Implementation details...\nend\n```\n\nThis skill acts as a bridge between the standard Jido signal routing system and AI-specific functionality, handling signal patterns like `jido.ai.chat.response` and transforming them into appropriate AI actions.","ref":"agent-skill.html#understanding-jido-ai-skill"},{"type":"extras","title":"Signal Handling Flow - Agent & Skill","doc":"When a signal is received by a Jido AI Agent:\n\n1. The signal is routed through the agent's skill pipeline\n2. If the signal matches a pattern like `jido.ai.**`, the `Jido.AI.Skill` processes it\n3. The skill transforms the signal into an appropriate AI action\n4. The action communicates with the AI provider and returns the result\n5. The result is transformed and returned through the agent's pipeline\n\nThis maintains the consistent signal-based architecture of the Jido framework while enabling AI-specific functionality.","ref":"agent-skill.html#signal-handling-flow"},{"type":"extras","title":"Advanced Agent Patterns - Agent & Skill","doc":"","ref":"agent-skill.html#advanced-agent-patterns"},{"type":"extras","title":"Dynamic Prompt Engineering - Agent & Skill","doc":"Leverage EEx templates within the Jido templating system for dynamic prompt generation:\n\n```elixir\nprompt = \"\"\"\nYou are a <%= @persona %> expert with knowledge of <%= @domain %>.\nAnswer the following question about <%= @topic %>:\n\n<%= @message %>\n\"\"\"\n\n{:ok, pid} = Agent.start_link(\n  ai: [\n    model: {:anthropic, model: \"claude-3-sonnet-20240229\"},\n    prompt: prompt\n  ]\n)\n\n# When asking a question, provide context parameters\nAgent.chat_response(pid, \"How does it work?\", \n  params: %{\n    persona: \"software engineering\",\n    domain: \"distributed systems\",\n    topic: \"message brokers\"\n  }\n)\n```","ref":"agent-skill.html#dynamic-prompt-engineering"},{"type":"extras","title":"Tool Integration with Jido Actions - Agent & Skill","doc":"Enable agents to perform actions using the standard Jido Action system:\n\n```elixir\n{:ok, pid} = Agent.start_link(\n  ai: [\n    model: {:anthropic, model: \"claude-3-opus-20240229\"},\n    prompt: \"You are an agent that can look up weather information.\",\n    tools: [Jido.Actions.Weather.GetForecast, Jido.Actions.Weather.GetCurrentConditions]\n  ]\n)\n\n# The agent will automatically use tools when necessary\nAgent.tool_response(pid, \"What's the weather like in New York today?\")\n```\n\nThe key distinction here is that tools in the Jido AI context are standard Jido Actions, maintaining consistency with the core framework.","ref":"agent-skill.html#tool-integration-with-jido-actions"},{"type":"extras","title":"Implementing Custom AI Skills - Agent & Skill","doc":"While the `Jido.AI.Skill` provides general purpose AI functionality, you can create custom AI-focused skills that follow the standard Jido Skill pattern:\n\n```elixir\ndefmodule MyApp.CustomAISkill do\n  use Jido.Skill,\n    name: \"custom_ai_skill\",\n    description: \"Domain-specific AI capabilities\",\n    signal_patterns: [\n      \"myapp.ai.**\"\n    ]\n    \n  def router(_opts) do\n    [\n      {\"myapp.ai.specialized_response\",\n       %Instruction{\n         action: MyApp.Actions.SpecializedAIResponse,\n         params: %{}\n       }}\n    ]\n  end\n  \n  def handle_signal(signal, _skill_opts) do\n    # Process incoming signal before routing\n    enhanced_signal = add_domain_context(signal)\n    {:ok, enhanced_signal}\n  end\n  \n  def transform_result(_signal, result, _skill_opts) do\n    # Process result after action execution\n    formatted_result = format_for_domain(result)\n    {:ok, formatted_result}\n  end\n  \n  # Helper functions\n  defp add_domain_context(signal) do\n    # Add domain-specific context to the signal\n    Map.update(signal, :data, %{}, fn data ->\n      Map.put(data, :domain_context, \"Specialized information\")\n    end)\n  end\n  \n  defp format_for_domain(result) do\n    # Format the result for the specific domain\n    Map.put(result, :domain_formatted, true)\n  end\nend\n```","ref":"agent-skill.html#implementing-custom-ai-skills"},{"type":"extras","title":"Practical Example: News Reporter Agent - Agent & Skill","doc":"This example demonstrates how to create a complete Jido AI Agent with personality:\n\n```elixir\ndefmodule Examples.NewsReporterAgent do\n  alias Jido.AI.Agent\n  require Logger\n  \n  def start do\n    {:ok, pid} = Agent.start_link(\n      # Standard Jido Agent options\n      log_level: :debug,\n      \n      # AI-specific configuration\n      ai: [\n        model: {:anthropic, model: \"claude-3-haiku-20240307\"},\n        prompt: \"\"\"\n        You are an enthusiastic news reporter with a flair for storytelling! 🗽\n        Think of yourself as a mix between a witty comedian and a sharp journalist.\n        Your style guide:\n        - Start with an attention-grabbing headline using emoji\n        - Share news with enthusiasm and NYC attitude\n        - Keep your responses concise but entertaining\n        - Throw in local references and NYC slang when appropriate\n        - End with a catchy sign-off like 'Back to you in the studio!' or 'Reporting live from the Big Apple!'\n        \n        Answer this question:\n        <%= @message %>\n        \"\"\"\n      ]\n    )\n    \n    {:ok, pid}\n  end\n  \n  def report_news(pid, topic) do\n    # Uses the Jido.AI.Agent extension method\n    {:ok, response} = Agent.chat_response(pid, topic)\n    Logger.info(\"News report: #{response.response}\")\n    response.response\n  end\nend\n```","ref":"agent-skill.html#practical-example-news-reporter-agent"},{"type":"extras","title":"Jido.AI Actions - Agent & Skill","doc":"The Jido AI framework provides several specialized Jido Actions for AI operations:","ref":"agent-skill.html#jido-ai-actions"},{"type":"extras","title":"Instructor-based Actions - Agent & Skill","doc":"- `Jido.AI.Actions.Instructor.ChatResponse`: General purpose chat response\n- `Jido.AI.Actions.Instructor.BooleanResponse`: Yes/no answers with explanation\n- `Jido.AI.Actions.Instructor.ChoiceResponse`: Selection from options","ref":"agent-skill.html#instructor-based-actions"},{"type":"extras","title":"LangChain-based Actions - Agent & Skill","doc":"- `Jido.AI.Actions.Langchain.ToolResponse`: Tool-augmented responses","ref":"agent-skill.html#langchain-based-actions"},{"type":"extras","title":"OpenAI/Ex-based Actions - Agent & Skill","doc":"- `Jido.AI.Actions.OpenaiEx.Embeddings`: Vector embedding generation\n- `Jido.AI.Actions.OpenaiEx.ImageGeneration`: Image creation\n\nThese actions follow the standard Jido Action pattern, maintaining consistency with the core framework.","ref":"agent-skill.html#openai-ex-based-actions"},{"type":"extras","title":"Advanced Response Handling - Agent & Skill","doc":"","ref":"agent-skill.html#advanced-response-handling"},{"type":"extras","title":"Boolean Responses - Agent & Skill","doc":"For yes/no questions with explanation:\n\n```elixir\n{:ok, result} = Agent.boolean_response(pid, \"Is Paris the capital of France?\")\n# Returns:\n# %{\n#   result: true,\n#   explanation: \"Yes, Paris is the capital of France...\",\n#   confidence: 0.99,\n#   is_ambiguous: false\n# }\n```","ref":"agent-skill.html#boolean-responses"},{"type":"extras","title":"Tool Responses - Agent & Skill","doc":"For actions requiring tool use, leveraging the standard Jido Action system:\n\n```elixir\n{:ok, result} = Agent.tool_response(pid, \"What's the weather in Tokyo?\")\n# Returns:\n# %{\n#   result: \"The current weather in Tokyo is...\",\n#   tool_results: [\n#     %{tool: \"weather_lookup\", result: %{temperature: 22, conditions: \"Sunny\"}}\n#   ]\n# }\n```","ref":"agent-skill.html#tool-responses"},{"type":"extras","title":"Working with Jido.AI.Provider - Agent & Skill","doc":"The framework offers configurable provider adapters that integrate with the Jido environment:\n\n```elixir\n# Define a model explicitly\n{:ok, model} = Jido.AI.Model.from({:anthropic, \n  model: \"claude-3-haiku-20240307\",\n  api_key: System.get_env(\"ANTHROPIC_API_KEY\")\n})\n\n# Use the model with an agent\n{:ok, pid} = Agent.start_link(ai: [model: model])\n```\n\nThe provider system allows for consistent configuration and access to various AI providers while maintaining the Jido architectural patterns.","ref":"agent-skill.html#working-with-jido-ai-provider"},{"type":"extras","title":"Best Practices - Agent & Skill","doc":"","ref":"agent-skill.html#best-practices"},{"type":"extras","title":"Integration with Existing Jido Agents - Agent & Skill","doc":"When adding AI capabilities to an existing Jido Agent:\n\n```elixir\ndefmodule MyApp.EnhancedAgent do\n  def start do\n    {:ok, pid} = Jido.Agent.start_link(\n      name: \"enhanced_agent\",\n      skills: [\n        MyApp.ExistingSkill,\n        MyApp.AnotherSkill,\n        Jido.AI.Skill  # Add the AI skill to the existing agent\n      ],\n      \n      # Add AI-specific configuration\n      ai: [\n        model: {:anthropic, model: \"claude-3-haiku-20240307\"},\n        prompt: \"You are a helpful assistant integrated into the enhanced agent.\"\n      ]\n    )\n    \n    {:ok, pid}\n  end\nend\n```","ref":"agent-skill.html#integration-with-existing-jido-agents"},{"type":"extras","title":"Combining Multiple AI and Non-AI Skills - Agent & Skill","doc":"Leverage the full power of the Jido framework by combining AI and non-AI skills:\n\n```elixir\n{:ok, pid} = Jido.AI.Agent.start_link(\n  skills: [\n    # Standard Jido skills\n    MyApp.DatabaseSkill,\n    MyApp.NotificationSkill,\n    \n    # AI-specific skills\n    Jido.AI.Skill,\n    MyApp.CustomAISkill\n  ],\n  \n  ai: [\n    model: {:anthropic, model: \"claude-3-haiku-20240307\"},\n    prompt: \"You are a helpful assistant with database and notification capabilities.\"\n  ]\n)\n```","ref":"agent-skill.html#combining-multiple-ai-and-non-ai-skills"},{"type":"extras","title":"Error Handling - Agent & Skill","doc":"Implement robust error management following Jido patterns:\n\n```elixir\ndef ask_question(pid, question) do\n  case Agent.chat_response(pid, question) do\n    {:ok, response} -> \n      {:ok, response.response}\n    {:error, reason} -> \n      Logger.error(\"AI request failed: #{inspect(reason)}\")\n      {:error, \"Unable to process your request at this time\"}\n  end\nend\n```","ref":"agent-skill.html#error-handling"},{"type":"extras","title":"Conclusion - Agent & Skill","doc":"The Jido AI Agent and Skill modules provide a powerful extension to the core Jido framework, adding robust AI capabilities while maintaining the structured architecture, signal-based communication, and separation of concerns that make Jido effective for building complex agent systems.\n\nBy understanding how the AI components integrate with and extend the core Jido functionality, developers can create sophisticated AI-powered experiences that leverage the full power of the Jido ecosystem.","ref":"agent-skill.html#conclusion"},{"type":"extras","title":"Further Resources - Agent & Skill","doc":"- [Jido GitHub Repository](https://github.com/agentjido/jido)\n- [Jido Framework Documentation](https://hexdocs.pm/jido)","ref":"agent-skill.html#further-resources"},{"type":"extras","title":"Actions","doc":"# Jido AI Actions","ref":"actions.html"},{"type":"extras","title":"Introduction to Jido AI Actions - Actions","doc":"Jido AI Actions are modular, reusable components that encapsulate AI capabilities within your applications. These actions build upon the core Jido SDK action framework, implementing specific AI LLM capabilities that can be composed with other components in the Jido ecosystem. This guide presents an overview of the pre-built actions included with Jido AI and demonstrates how you can extend them to create your own custom actions.","ref":"actions.html#introduction-to-jido-ai-actions"},{"type":"extras","title":"Core Action Types - Actions","doc":"Jido AI includes several foundational action types, each designed for specific use cases:","ref":"actions.html#core-action-types"},{"type":"extras","title":"Instructor-based Actions - Actions","doc":"These actions use the Instructor library to provide structured responses from AI models:\n\n| Action | Description |\n|--------|-------------|\n| `Jido.AI.Actions.Instructor` | Base action providing direct access to Instructor's chat completion functionality |\n| `Jido.AI.Actions.Instructor.BooleanResponse` | Returns true/false answers with explanations |\n| `Jido.AI.Actions.Instructor.ChatResponse` | Provides natural language responses |\n| `Jido.AI.Actions.Instructor.ChoiceResponse` | Selects from available options with explanations |","ref":"actions.html#instructor-based-actions"},{"type":"extras","title":"LangChain-based Actions - Actions","doc":"These actions leverage LangChain for more complex scenarios:\n\n| Action | Description |\n|--------|-------------|\n| `Jido.AI.Actions.Langchain` | Base action providing access to LangChain's chat functionality |\n| `Jido.AI.Actions.Langchain.ToolResponse` | Coordinates with tools/functions for enhanced capabilities |","ref":"actions.html#langchain-based-actions"},{"type":"extras","title":"OpenAI-specific Actions - Actions","doc":"These actions directly interact with OpenAI's APIs:\n\n| Action | Description |\n|--------|-------------|\n| `Jido.AI.Actions.OpenaiEx` | Chat completion using OpenAI Ex with tool calling support |\n| `Jido.AI.Actions.OpenaiEx.Embeddings` | Vector embedding generation |\n| `Jido.AI.Actions.OpenaiEx.ImageGeneration` | Image creation from text prompts |\n| `Jido.AI.Actions.OpenaiEx.ResponseRetrieve` | Asynchronous response retrieval |\n| `Jido.AI.Actions.OpenaiEx.ToolHelper` | Helper for tool/function calling with OpenAI |","ref":"actions.html#openai-specific-actions"},{"type":"extras","title":"Integration with Jido Ecosystem - Actions","doc":"Jido AI Actions aren't standalone components - they're designed to integrate seamlessly with the broader Jido ecosystem. By implementing the `Jido.Action` behavior, these AI-specific actions:\n\n1. **Follow consistent patterns**: Share the same interface as other Jido actions\n2. **Support workflow composition**: Can be combined with non-AI actions in complex workflows\n3. **Leverage core infrastructure**: Utilize the same validation, error handling, and execution context mechanisms\n\nThis integration allows you to mix AI capabilities with other types of actions in your application, creating powerful combinations of functionality.","ref":"actions.html#integration-with-jido-ecosystem"},{"type":"extras","title":"Action Composition Pattern - Actions","doc":"Jido AI Actions follow a composition pattern that allows higher-level actions to build upon simpler ones. This aligns with the core Jido SDK design philosophy of building complex systems from simple, composable pieces. For example:\n\n```elixir\n# BooleanResponse builds upon the base Instructor action\ndefmodule Jido.AI.Actions.Instructor.BooleanResponse do\n  # Define the schema for boolean responses\n  defmodule Schema do\n    use Ecto.Schema\n    use Instructor\n\n    @llm_doc \"\"\"\n    A boolean response from an AI assistant.\n    \"\"\"\n    @primary_key false\n    embedded_schema do\n      field(:answer, :boolean)\n      field(:explanation, :string)\n      field(:confidence, :float)\n      field(:is_ambiguous, :boolean)\n    end\n  end\n\n  # Use the Jido.Action behavior\n  use Jido.Action,\n    name: \"get_boolean_response\",\n    description: \"Get a true/false answer to a question with explanation\",\n    schema: [\n      # Schema definition...\n    ]\n\n  # Leverage the base Instructor action for implementation\n  def run(params, context) do\n    # Implementation details...\n    case Instructor.run(\n      %{\n        model: model,\n        prompt: enhanced_prompt,\n        response_model: Schema,\n        # Other parameters...\n      },\n      context\n    ) do\n      {:ok, %{result: %Schema{} = response}, _} ->\n        {:ok,\n          %{\n            result: response.answer,\n            explanation: response.explanation,\n            confidence: response.confidence,\n            is_ambiguous: response.is_ambiguous\n          }}\n      # Error handling...\n    end\n  end\n\n  # Helper functions...\nend\n```","ref":"actions.html#action-composition-pattern"},{"type":"extras","title":"Multi-Provider Support - Actions","doc":"Jido AI Actions are designed to work with multiple AI providers, including:\n\n- Anthropic (Claude models)\n- OpenAI (GPT models)\n- OpenRouter (for accessing multiple providers via one API)\n- Cloudflare AI\n- Ollama\n- LlamaCPP\n- Together AI\n\nProvider-specific adapters handle the necessary API differences, allowing your actions to be provider-agnostic:\n\n```elixir\n# Example of provider-specific configuration\ncase params.model.provider do\n  :anthropic ->\n    [\n      adapter: Instructor.Adapters.Anthropic,\n      api_key: api_key\n    ]\n  :openai ->\n    [\n      adapter: Instructor.Adapters.OpenAI,\n      openai: [\n        api_key: api_key\n      ]\n    ]\n  # Other providers...\nend\n```","ref":"actions.html#multi-provider-support"},{"type":"extras","title":"Creating Your Own Actions - Actions","doc":"Creating a custom action involves a few key steps:\n\n1. Define your action module using `Jido.Action`\n2. Specify the parameters schema\n3. Implement the `run/2` function\n\nHere's a simplified example:\n\n```elixir\ndefmodule MyApp.CustomAction do\n  use Jido.Action,\n    name: \"my_custom_action\",\n    description: \"A custom action for my application\",\n    schema: [\n      model: [\n        type: {:custom, Jido.AI.Model, :validate_model_opts, []},\n        required: true,\n        doc: \"The AI model to use\"\n      ],\n      prompt: [\n        type: {:custom, Jido.AI.Prompt, :validate_prompt_opts, []},\n        required: true,\n        doc: \"The prompt to use\"\n      ],\n      my_param: [\n        type: :string,\n        required: true,\n        doc: \"A custom parameter\"\n      ]\n    ]\n\n  def run(params, context) do\n    # Implementation using a base action\n    Jido.AI.Actions.Instructor.ChatResponse.run(\n      %{\n        model: params.model,\n        prompt: enhance_prompt(params.prompt, params.my_param),\n        temperature: 0.7\n      },\n      context\n    )\n  end\n\n  defp enhance_prompt(prompt, my_param) do\n    # Custom prompt enhancement logic\n    # ...\n  end\nend\n```","ref":"actions.html#creating-your-own-actions"},{"type":"extras","title":"Action Best Practices - Actions","doc":"1. **Modular Design**: Keep your actions focused on a single responsibility\n2. **Consistent Error Handling**: Return `{:ok, result}` or `{:error, reason}`\n3. **Documentation**: Include thorough docs and examples\n4. **Parameter Validation**: Validate all inputs before processing\n5. **Reuse**: Build on existing actions when possible","ref":"actions.html#action-best-practices"},{"type":"extras","title":"Using Actions in Applications - Actions","doc":"Actions can be used directly in your application code:\n\n```elixir\nalias MyApp.CustomAction\n\ndef process_user_query(query) do\n  params = %{\n    model: {:anthropic, [model: \"claude-3-haiku-20240307\"]},\n    prompt: Jido.AI.Prompt.new(:user, query),\n    my_param: \"some value\"\n  }\n\n  case CustomAction.run(params, %{}) do\n    {:ok, result} -> handle_success(result)\n    {:error, reason} -> handle_error(reason)\n  end\nend\n```\n\nOr with the Jido AI Agent:\n\n```elixir\nalias Jido.AI.Agent\n\n{:ok, agent} = Agent.start_link(\n  skills: [MyApp.CustomSkill],\n  model: {:anthropic, [model: \"claude-3-haiku-20240307\"]}\n)\n\nAgent.tool_response(agent, \"What is the capital of France?\")\n```","ref":"actions.html#using-actions-in-applications"},{"type":"extras","title":"Composing with Other Jido Components - Actions","doc":"Because Jido AI Actions implement the standard Jido Action interface, they can be easily composed with other components in the Jido ecosystem:\n\n```elixir\ndefmodule MyApp.ComplexWorkflow do\n  def execute(input) do\n    with {:ok, parsed_data} <- MyApp.DataParser.run(input),\n         {:ok, validated} <- MyApp.Validator.run(parsed_data),\n         # AI action integrated into the workflow\n         {:ok, enriched} <- Jido.AI.Actions.Instructor.ChatResponse.run(%{\n           model: {:anthropic, [model: \"claude-3-haiku-20240307\"]},\n           prompt: build_enrichment_prompt(validated)\n         }, %{}),\n         {:ok, result} <- MyApp.DataProcessor.run(enriched) do\n      {:ok, result}\n    else\n      {:error, reason} -> {:error, reason}\n    end\n  end\n  \n  # Helper functions...\nend\n```\n\nThis ability to seamlessly mix AI and non-AI actions creates powerful possibilities for complex application workflows.","ref":"actions.html#composing-with-other-jido-components"},{"type":"extras","title":"Conclusion - Actions","doc":"Jido AI Actions provide a powerful, flexible foundation for building AI-enabled applications. By building on the core Jido SDK action framework, these components offer a consistent approach to implementing AI capabilities that can be composed with the broader Jido ecosystem.\n\nBy leveraging the included actions and creating your own custom ones, you can quickly implement complex AI capabilities while maintaining code that is modular, testable, and maintainable.\n\nThe examples included in this guide demonstrate the fundamentals, but there's much more you can do by exploring the full API and creating actions tailored to your specific use cases.","ref":"actions.html#conclusion"}],"proglang":"elixir","producer":{"name":"ex_doc","version":"0.37.3"},"content_type":"text/markdown"}